commit 94c604b0f1c9304093f485a93b940dbf4b5820f6
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jun 1 22:44:08 2026 -0700

    Improve commit 0ad292f62ce2c49ae20c3fa3b421225b7ae8532d: Suppress Eigen warning messages.

commit 1fb8ab928ac88e194c9fd44502646b3d3c63fc44
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jun 1 22:29:19 2026 -0700

    Work around software floating point exceptions.

commit 9097080e9028c844a1df67e04fb7502054180f9e
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Mon Jun 1 13:33:20 2026 -0700

    Fix infinite .d file regeneration loop, fix glslang linking on Ubuntu, detect missing Vulkan 1.4 C++ headers at configure time, and remove VS-specific #pragma region directives

commit de3e392a7fc67346a73705e9d4b2854db51e7f96
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Mon Jun 1 09:10:32 2026 -0700

    Add asy-licenses to asy-pre-nsis-targets so license files are built before install

commit c6ff284bf399675e79f2fa0616eb3dcfb7b9b403
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Mon Jun 1 00:45:58 2026 -0700

    Fix rpmbuild PIE linking by not overwriting CFLAGS in gc configure

commit 624a0132e617da57013320beaf7d153cec65a299
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Mon Jun 1 00:06:14 2026 -0700

    Build gc library before running tests to avoid parallel build race condition

commit 61b32d044b9dbf64d3436d67fe917044d33274d8
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Sun May 31 23:23:28 2026 -0700

    Decouple libatomic_ops symlink from gc configure

commit 392af739da155e209631dba9bb5063c9ade1481d
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 31 21:48:37 2026 -0700

    Add example.

commit 1bcd8a54ce4fdf6d3ebf9e2618e5a1731e59e468
Merge: 26d746da4 206458998
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 31 21:20:27 2026 -0700

    Merge pull request #610 from vectorgraphics/gitignore.
    
    Add some irritating config files to .gitignore.

commit 26d746da4357d5b4b0ee0af1ead1dbb7e47f4d5b
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 31 21:18:27 2026 -0700

    Add missing gc inheritances.

commit d9af6ee632c3df7b90d37bb173ddf9ce7896ef6b
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 31 19:57:39 2026 -0700

    Rename example.

commit 206458998873b36f8202485b214ebdb67f1de6ff
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sun May 31 19:56:13 2026 -0700

    Add some irritating config files to .gitignore.

commit 5d80d832ccc3bb0f7eb322ea62812874c0b44b23
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 31 10:20:26 2026 -0700

    Update asygl.

commit ba7f6d998d9ec51c0fce542030ecdc5c6d769ae8
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 31 10:06:41 2026 -0700

    Add animation examples.

commit e9a27b85e3e7769b15c00d1ab25503e5894ba6f7
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 31 09:48:23 2026 -0700

    Simplify code.

commit b9c42e3ccf2e86a7c0294638085850a9b794c9e6
Merge: 3b82e76e0 62e0491f0
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 31 09:07:38 2026 -0700

    Merge branch 'master' into pr-609.

commit 62e0491f03e852f27d7518a5f694ae2f5d77ea80
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 31 00:00:06 2026 -0700

    Ensure mesh resolution stays consistent with zoom and fitscreen changes.

commit 02a71b2e8529604d009a75d018c43030dab01ff7
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 30 23:47:05 2026 -0700

    Fix fitscreen modes.

commit f8105b755c59bab33c8c645b20d9ec4454abf206
Merge: 3f90b09d5 9efad6efb
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 30 22:05:11 2026 -0700

    Merge pull request #607 from vectorgraphics/contour-duplicate.
    
    Fix duplicate case1 segments at shared cell edges.

commit 9efad6efb77d10407f5e229409cba35ed87a663e
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 30 22:02:56 2026 -0700

    Fix last commit.

commit 55d8e0113d41b93b78bcb9d3b8d9aa880b46b8f3
Merge: c8c9edfc6 3f90b09d5
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 30 21:43:01 2026 -0700

    Merge branch 'master' into contour-duplicate

commit 3f90b09d51179820c0dda792cb26c03407892ce0
Merge: a5ed908b0 e123fd944
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 30 21:33:38 2026 -0700

    Merge pull request #606 from vectorgraphics/485-contour-plot-scale-invariance.
    
    Fix noise budget in contour.asy.

commit e123fd944ab46da1a3d7c16e78c6e4d62e161736
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Sat May 30 21:16:48 2026 -0700

    Fix normalization in contour.asy: scale both domain and range tolerances relative to the problem magnitude.

commit 1c4d8660ab7c8ad2ccff6947ccdf6f6975e1135e
Merge: 6929d9e88 a5ed908b0
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 30 13:04:39 2026 -0700

    Merge branch 'master' into 485-contour-plot-scale-invariance.

commit a5ed908b09a5ba9de3fcb990768ae56f2387b660
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Fri May 29 23:22:15 2026 -0700

    Fix Vulkan offscreen resolution to match OpenGL by using expanded dimensions in initDisplay()

commit db5ef8d799ee0f47895f22ff1debaa759e406462
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Fri May 29 12:14:43 2026 -0700

    Fix OpenGL export: disable multisampling for hidden windows so glReadPixels reads from the resolved back buffer instead of an empty MSAA resolve buffer.

commit ff6a41ee29403eabbfd2523feafc77d528d337e7
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Fri May 29 10:33:28 2026 -0700

    Fix threaded rendering: don't set initialized flag before render thread runs initDisplay()

commit 9d7e3487c1a29b276fe7a447f741f3ed787911ad
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 28 20:02:39 2026 -0700

    Rename readAnyFile to haveReadFile and clarify curl error message.

commit c8c9edfc6905db3fdf840c8a02534526a4cb1f00
Author: Charles <charles.staats.iii@gmail.com>
Date:   Wed May 27 20:47:04 2026 -0700

    Fix duplicate case1 segments at shared cell edges.
    
    When the contour passes exactly through two adjacent grid vertices
    (edge code 9), both cells sharing that edge would emit the same
    segment via case1, causing collect() to stitch them into a
    degenerate back-and-forth cycle.  Pass the triangle index to
    addseg() and suppress the left/bottom copy whenever an interior
    neighbour cell owns that edge instead.

commit 6929d9e88662fe2a67bd8630045fae69527efc24
Author: Charles <charles.staats.iii@gmail.com>
Date:   Wed May 27 20:20:50 2026 -0700

    Fix noise budget in contour.asy.

commit 134173e56bb5f373da7b9476ac6b7139fde8eac2
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Wed May 27 12:27:34 2026 -0700

    Mask FPU traps around GL init and shader compilation to work around Mesa/libgallium driver bug, and guard setDimensions against zero dimensions

commit 1a0a5b0e2c8f3dd69b38067856c5e06de3e04f20
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Wed May 27 11:07:36 2026 -0700

    Use longer Vulkan timeout on software renderers to avoid spurious VK_TIMEOUT during shader JIT compilation

commit 5530d4800d33f9157bddd6b5f5f817efbe8e2ee1
Author: Charles <charles.staats.iii@gmail.com>
Date:   Tue May 26 20:44:29 2026 -0700

    Update stale comment regarding exp::scalable().

commit 78d45bd8117122196e64895f6b219a11381ac867
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 26 19:25:04 2026 -0700

    Improve last commit.

commit b719ee9197f3b1ba4c7a00b218b799bd7e0f0b05
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Tue May 26 19:17:09 2026 -0700

    Make implicit scaling an error

commit c05ad3ac54cf3b0a3ddfd4f987084a1ee18238fa
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 26 12:57:52 2026 -0700

    Make curlAfterRead a SecureSetting.

commit 107f263a7a1215c04a156bbe14c7e5154df3aba2
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Mon May 25 00:57:52 2026 -0700

    Disable libcurl after input() reads any local file; override with -curlAfterRead

commit 5fce1db80953e3e4d7d550179ab90890edbbb1b7
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Sun May 24 23:17:22 2026 -0700

    Fix asy-keywords.el build and version.asy when no git tags are present

commit 7256b13d4ceb08f2b4a08b4ee403412b3540791e
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Sun May 24 10:15:27 2026 -0700

    Rename AsyWebGLRender to NoRender.

commit f3c29c55c47563a8da191aa468e325695bd5ff80
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Sun May 24 09:56:30 2026 -0700

    Initialize camera state and dimensions when prerender > 0

commit 65d5ccaaeb05277cb3b3789ce89b51789a922d88
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Sun May 24 09:56:21 2026 -0700

    Fix uninitialized lightOn in drawTriangles constructor

commit 57c4a38d274f9f4f8a543b44376c1915ebbda27f
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 23 21:38:51 2026 -0700

    Update asygl.

commit 505a365fe9b6845c73d87c671586263e9c4c92eb
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Sat May 23 21:09:33 2026 -0700

    Move PBR material lookup from fragment shader to vertex shader, eliminating per-fragment SSBO reads and branching.

commit dfc3e35f0f5a037ef041ac19b9d8ffb0cc7079a5
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 23 01:57:06 2026 -0700

    Update asygl.

commit 0f86ba791ec0095bc905b74614aed26032e69e8d
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 23 01:42:24 2026 -0700

    Fix WebGL shaders.

commit 2d2dd0c7eee9febf02f0b0aa8bf9c896f3c8ac8f
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Sat May 23 01:06:14 2026 -0700

    Control emissive PBR lighting with lightOn parameter, fix v3d serialization to include it (version 2), fix missing metallic and fresnel0 assignments in drawNurbs copy constructor.

commit f35e91658f93f7cbae8005743b9b286c20814b7e
Merge: 34859a7a7 b484d3151
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 22 22:26:37 2026 -0700

    Merge branch 'fixNoRenderer'.

commit 34859a7a7380726ab496fa8017a2a5e13dc79c26
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri May 22 21:46:38 2026 -0700

    Fix floating point error.

commit b484d31516a39bccecb4dd3e94a8131c0663ccd7
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri May 22 19:58:55 2026 -0700

    Add stubs to allow compilation when HAVE_RENDERER is undefined.

commit 06296b68380ea267caf47b91605649f595657717
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 22 01:17:17 2026 -0700

    Update asygl.

commit 6e2b8ad32491a59ea5e36e124ce7719865362afa
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 22 00:37:32 2026 -0700

    Fix vertex colors with nolight by passing flag through parameters.w to fragment shaders.

commit 69595d01e9e51b5e925a51c1c5489f2a61662cc0
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 21 11:38:50 2026 -0700

    Remove unused function.

commit a3529c51f7820acdac146561167a9385f30d3494
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 21 11:25:37 2026 -0700

    Fix macOS issues.

commit ec0effb6e52a6d6d722ee2cd08d2f6272c052bdb
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Thu May 21 10:56:11 2026 -0700

    Move AsyGLRender and AsyVkRender members from public to private, removing dead friend declarations

commit 07a48c0aac0144fa25a0c36d94b66541d2340fbd
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Thu May 21 10:50:03 2026 -0700

    Add Doxygen documentation to AsyRender virtual methods

commit e285101f2bdbb08bfd00ba4b67f975bba8a74c09
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Thu May 21 10:45:03 2026 -0700

    Remove redundant GLFW include from vkrender.h, centralized in renderBase.h

commit ad297b81e6315d5f6fe7f62d93ed93746d58457c
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Thu May 21 10:42:20 2026 -0700

    Type glfwWindow as GLFWwindow* in AsyRender, eliminating repeated static_casts

commit 13f4b800c194af857b47494b8d5c0fecc71e6e39
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Thu May 21 10:38:29 2026 -0700

    Add matrix accessor member functions to AsyRender base class, remove dead extern declarations from renderer headers

commit 3cd970949c806d7a1c2645a1fb90a71a54cbb070
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Thu May 21 10:11:15 2026 -0700

    Move Vulkan vertex input descriptions from render.h structs to free functions in vkrender.cc, decoupling render.h from the Vulkan API

commit 596ffa61d37ae9e71eb42f5a5b25c79ea97df715
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed May 20 19:42:40 2026 -0700

    Simplify code.

commit 45083c56e9e1a971bcc15f5096e16ec5de187e95
Merge: a8aee0884 c4582ef1c
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed May 20 00:41:18 2026 -0700

    Merge pull request #594 from vectorgraphics/add-licenses
    
    Add licenses.

commit a8aee0884cb511a23425537524341c0c99ecef73
Author: LLLM (Linear-in-time LLM coding assistant) <bowman@ualberta.ca>
Date:   Wed May 20 00:38:49 2026 -0700

    Deduplicate pkg-config cflags with $(sort ...) in OPTS and GLEWOPTS

commit c4582ef1cb6a5869e83bacd56da551d6de1a79f2
Merge: 29adc6941 cf807dc27
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 19 23:23:25 2026 -0700

    Merge branch 'master' into add-licenses

commit cf807dc27d7ce2da6169a3f2af32ee6523fc4d17
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 19 23:00:31 2026 -0700

    Make all configure options consistently display their default values in help strings.

commit 570e20b1b14c38661b1576873acfd8ab10164ad6
Merge: 53937a8a9 df3ca203e
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 19 22:49:05 2026 -0700

    Merge branch 'master' into vulkan-bundled.

commit 29adc69417f4ae00d1daed04ebe487ec0928a218
Merge: 11055b67e df3ca203e
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 19 21:48:22 2026 -0700

    Merge branch 'master' into add-licenses.

commit df3ca203e03432b74592bdba6301d52804861eb4
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 19 21:00:50 2026 -0700

    Fix sizing of multiple scenes.

commit b2e7a360d6469b1b33432f3330e014cf3a9857dd
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 19 11:58:44 2026 -0700

    Respect current srgb setting.

commit 17a64286b3481e6e2ffd065f5262a31b2a30da76
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 19 10:36:01 2026 -0700

    Support SRGB in OpenGL.

commit 430058c6ee21ba7960233506b6879f2ae556bd44
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon May 18 23:30:13 2026 -0700

    Partially revert regression from 3c498af00: restore per-swapchain-image render-finished semaphores introduced in commit a019d2557.

commit 3bddf4e68430ef0a602dcaad6b1ef955688bc3da
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon May 18 22:42:29 2026 -0700

    Restore framebufferResized=true in updateHandler to ensure transparency buffers are created.

commit a940b4dbb813dd5a8f0f3a60936121e90f00e182
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon May 18 21:40:31 2026 -0700

    Support validation layers again; add validation and no validation targets.

commit 4e9d0d50a31aedd295143f2f90704f8355d12535
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon May 18 17:38:20 2026 -0700

    Fix threaded batch-mode hang: drop pthread_cancel, mainLoopRunning bypass, and glrenderThreadId mainthread assignment.

commit 53937a8a9c6f96d634fea8ae7f7d53d9d7451d7e
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon May 18 13:48:25 2026 -0700

    Fix glew.d rule and update macOS bundled build config.
    
    Add a dedicated glew.d dependency rule that uses GLEWOPTS instead
    of MAKEDEPEND to avoid passing -std=c++17 to clang for C files, and
    strips MACOS_ARCH_FLAGS to prevent multiple -arch flags from being
    passed with -M. Also enable --enable-macos-universal and
    --enable-macos-bundling in the bundled macOS configure script, move
    --enable-relocatable alongside the other macOS flags, and add a note
    clarifying the expected VulkanSDK directory name.

commit befab1938675eecfe43c1d03ca1ceaa719226467
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon May 18 12:19:36 2026 -0700

    Delegate renderer creation to glrenderWrapper thread in threaded mode to avoid dlopen deadlock.

commit 645481625362157dc621a8fc714fef04190d086d
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon May 18 12:05:29 2026 -0700

    Fix threaded interactive mode: correct mainthread ID, prevent use-after-free on args pointers, separate handshake from mainLoop entry, and cancel render thread on quit.

commit baffb3357f5588b97212ddd736833b31f0d8d4e7
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon May 18 10:32:50 2026 -0700

    Remove LLVMPIPE from Makefile.in.

commit a424d5a91848eec2f0497391d51e338082b75e73
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon May 18 10:07:31 2026 -0700

    Update asymptote.spec.

commit e59c45db7b9378a0526b5676fecc6439b8b40bab
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon May 18 01:41:28 2026 -0700

    Fix last commit.

commit 468feed12b1977cb20e289fde338cd4f7c70f3f5
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon May 18 01:27:06 2026 -0700

    Disable macOS universal builds and library bundling by default.

commit 513316496b532106553a1c09669966151c93130d
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 17 14:01:11 2026 -0700

    Add instructions for compiling Vulkan software renderer for macOS running on Intel hardware.

commit 0db3b2e1efd33cc2062ea2df68199ec4398c7dd5
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sat May 16 15:32:49 2026 -0700

    Fix `make cleanest` to clean old GC binaries.

commit 11055b67eb97832f78fab6745a39a7de0fe46875
Merge: cc9b0704c 9ca94afc7
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat May 16 12:21:40 2026 -0700

    Merge branch 'add-licenses' of https://github.com/vectorgraphics/asymptote into add-licenses

commit cc9b0704cea3702922cf424ff4c1d99b4a06ecf8
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat May 16 12:20:37 2026 -0700

    cmake: simplify license-dir API and fix sandbox sysdir.
    
    - Remove ASY_LICENSEDIR_INSTALL_DEST as a user-facing cache variable;
      derive it automatically from ASY_LICENSEDIR.
    - Expose ASYMPTOTE_SYSDIR_VALUE as a cache PATH cache variable so
      presets can override it; set it in linux/sandbox to point at the
      build-tree base directory.
    - Update build-asymptote-sandbox to build the asy-with-basefiles target.
    - Update MAINTAINER-LICENSE-GUIDE.md to reflect the simplified API.

commit 9ca94afc7ed2f3533e9a6a87706ca0f63d0e65da
Merge: 9867a090b f96a7d0ca
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 16 02:32:44 2026 -0700

    Merge branch 'master' into add-licenses.

commit 6f83d1d6e3e4bb9d6222874a0e95261eb4c1ff93
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 16 02:18:55 2026 -0700

    Implement dedicated IS_RELOCATABLE compile flag to support staged macOS installation.

commit 2fd3c9007c8f3539d74a27b62d13039ef8488b65
Merge: 0534fdee8 f96a7d0ca
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 16 01:53:24 2026 -0700

    Merge branch 'master' into vulkan-bundled.

commit f96a7d0caa4b62578d4d6b448f58310dbfef38f1
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 16 01:51:12 2026 -0700

    Fix OPTIONS in configure.ac.

commit 8453e158543fafcc3786f24bba6acd2af1553369
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri May 15 21:31:54 2026 -0700

    Add LspCpp generated Makefiles to gitignore.

commit 54463f360dc580cce679559830706c11d0400472
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri May 15 21:21:23 2026 -0700

    Set up sandbox-compatible cmake build for testing.

commit 85dd8754a642375d70d7f767f713269a398a7bac
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri May 15 21:18:33 2026 -0700

    Add libasy*.so compiled libraries to gitignore.

commit 0534fdee8f14300b385a46627ac5547c9af0b9c8
Merge: d482ad8c2 8bb52bd26
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 15 20:04:26 2026 -0700

    Merge branch 'master' into vulkan-bundled.

commit d482ad8c2dc7d7fbd1c8a30f0c8fb777cb3656f0
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Fri May 15 13:59:29 2026 -0700

    Fix GLFW Vulkan loader on macOS bundled builds.
    
    On macOS, GLFW lazily calls dlopen("libvulkan.1.dylib") when creating a
    window surface. In a bundled build the loader's install name is
    "@executable_path/lib/libvulkan.1.dylib", so this bare-name lookup fails
    on machines without the SDK. Fix this by calling glfwInitVulkanLoader
    with the vkGetInstanceProcAddr pointer obtained from our already-loaded
    Vulkan library, eliminating GLFW's need to dlopen the loader itself.

commit d8c3d364dcb7948f2db86493f9c5bbff70d2f36e
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Fri May 15 09:28:02 2026 -0700

    Extract bundling logic into separate script.

commit 9867a090b1632023e6fbaa20c58a8646878f0e19
Merge: 5726b66ad 8bb52bd26
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 15 08:56:01 2026 -0700

    Merge branch 'master' into add-licenses.

commit cc45abab1a8d68b22623340c96ce7cee5b7076f9
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Fri May 15 08:40:39 2026 -0700

    Add script to configure for bundled build.

commit 8bb52bd26aba3f79b02bdf5ec46b84f5e263e3c1
Merge: 44d770c2d 4ef491e19
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 14 23:41:58 2026 -0700

    Merge branch 'master' into vulkan.

commit 44d770c2de4e5f602c7dc74a02fc4acd217c31eb
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 14 22:23:52 2026 -0700

    Support compilation without HAVE_LIBGLFW.

commit d9eac5259c6fac6336cdf795f1f07f2bfc34ba53
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 14 22:11:52 2026 -0700

    Support compilation without HAVE_LIBGLM.

commit ccc850be4bc917344f9a64f9ec55e43e607e3ece
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 14 21:48:59 2026 -0700

    Support compilation without HAVE_PTHREAD.

commit 8b4290c03b661967919947f503e0d5fd26ed7c76
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Thu May 14 21:39:11 2026 -0700

    Make portability work on macOS. Mostly.

commit 93d6f31dbcc3a4f0be36ffdb75ba39a298b736bf
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 14 20:27:15 2026 -0700

    Don't include glxew.h under macOS.

commit 4591aa30630fb17adc6dc98e36c332ea5de846e5
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 14 20:06:42 2026 -0700

    Simplify Makefile.in.

commit eec92d73e8ba999f890d5caefdffe19d6c59bfd1
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 14 19:34:43 2026 -0700

    Conditionally build shim libraries, fix header generation loop, and guard WebGL renderer with HAVE_LIBGLM.

commit 999a6acc51ab8cc69ed8a28af3a7b4367108e873
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Thu May 14 17:11:54 2026 -0700

    Get a working version that can build without access to macports or homebrew libraries.

commit 4ef491e19663a91d9e399a1a1da11d667b6bdd10
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 14 14:29:19 2026 -0700

    Increment version to 3.12.

commit 837fda8bfdb59d503c9249d243bb904a3a9b619c
Merge: 0beffcfca d8f621b6f
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 14 11:11:35 2026 -0700

    Merge branch 'master' into vulkan

commit d8f621b6f9c954aa933bb9db3159d49c951bda5d
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 14 10:59:27 2026 -0700

    Fix issue #597: imageURL option is missing from asy.1.

commit 0beffcfca213562cffa4d3bb79b148a1216c858a
Merge: 8d87f091e 73426b29a
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 14 09:39:13 2026 -0700

    Merge branch 'master' into vulkan.

commit 8d87f091ed0e42b8129c74b2d932598c7956a063
Merge: a27b42606 fb5c90ad0
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 14 08:00:02 2026 -0700

    Merge branch 'master' into vulkan.

commit 73426b29aa5fae55d31606e747c71ca3b93744bf
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 14 09:28:20 2026 -0700

    Update shaders.

commit 710f89cc0723ff940b97cbbd877515fd519d4282
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 14 09:09:06 2026 -0700

    Remove sum2fast compute shader from OpenGL renderer.

commit 1bca94cbfbe6c485eb4ae43624eccf877b1c241f
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 12 11:02:44 2026 -0700

    Silence missing pkg-config warnings.

commit 15f1b2da1d2f07f6256f8eff0174d7e09829dce3
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed May 13 23:23:40 2026 -0700

    Fix fuzz normalization in lineintersections.

commit 0259770646cfb005069e95493f16f8f2a21fbf6e
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 12 17:05:35 2026 -0700

    Clear offsetBuffer on resize to prevent GPU hang from stale data.

commit 95a9c07544402325f1319e995216057cf49e5245
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 12 11:08:38 2026 -0700

    Guard xstream.h.

commit 831efcb96cc3c18b11ac6d4ed0dc2cad30893d10
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 12 11:02:59 2026 -0700

    Don't assume LIBTIRPC is available.

commit a27b426068a48dd84997b3837185e2f0d38fd425
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed May 13 23:23:40 2026 -0700

    Fix fuzz normalization in lineintersections.

commit 3fe0a2a4013f7d0b92df6cb812d6df302d45570e
Merge: 96535c87a 56a50e53c
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Wed May 13 16:46:12 2026 -0700

    Merge branch 'vulkan' into vulkan-bundled

commit 56a50e53c5987343de57f6bc9e45888d66572738
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 12 17:13:58 2026 -0700

    Remove sum2fast compute shader from OpenGL renderer.

commit 9f43e9341c5b0847ae89cc434337869496cf97ba
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 12 17:05:35 2026 -0700

    Clear offsetBuffer on resize to prevent GPU hang from stale data.

commit 67861711e39bf6f4e158770c48f0ac4577940e75
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 12 11:51:42 2026 -0700

    Add memory barrier between fragment shader writes and compute shader reads of countBuffer.

commit 9f178701ed5507433da74932881d3cd7a41e6af3
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 12 11:08:38 2026 -0700

    Guard xstream.h.

commit d8ed76b8be8a59dc0c2f88f821a7a4a52857945c
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 12 11:02:59 2026 -0700

    Don't assume LIBTIRPC is available.

commit 1be4f87ddc98e14a2a8ac329cee6101fe2d2f94c
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 12 11:02:44 2026 -0700

    Silence missing pkg-config warnings.

commit 01a5d55af2132b71b35614aeb4bf8dde30af3965
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 12 09:54:26 2026 -0700

    Update Bezier-to-triangle rendering example.

commit bd5409c3d1cc53c7ac07faf25b3e06f16713b9ad
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 10 22:24:33 2026 -0700

    Simplify code.

commit d01dbc71cb76a90c67cd6450da67d042a6b13c15
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 10 20:20:21 2026 -0700

    Partially revert commit 24916e0e20be04ed55cac494db0a84ab0ed65454.

commit f0516fd855e2347e5a64c83f36d23b258dffa25e
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 10 19:45:08 2026 -0700

    Fix OpenGL export flash by redrawing full scene to back buffer after tiling.

commit b748f5e13cdc12d7f705b54eb6aa4580dee11bac
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 10 19:17:29 2026 -0700

    Fix OpenGL rendering on Wayland and remote UNIX by polling resize events before main loop and showing window before buffer swap.

commit 24916e0e20be04ed55cac494db0a84ab0ed65454
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 10 13:24:39 2026 -0700

    Show OpenGL buffer only when ready.

commit 5c6635ddf6cf6c1234e22022762a386357666cc8
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 10 11:17:37 2026 -0700

    Fix export aspect ratio.

commit a090ac43bb6661347d3383199012eea76f12edde
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 10 01:42:36 2026 -0700

    Fix fitscreen.

commit 5d12d55d993d05b8c28f56db4fdf4e7e66ca3c4b
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 9 14:39:06 2026 -0700

    Remove glfwHideWindow from toggleFitScreen to fix fullscreen on Wayland.

commit f3bf960adf8df460c4e14e7b97e20359c118b81a
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 9 13:34:22 2026 -0700

    Respect HiDPI displays.

commit fb5c90ad0447ba6f95926ec4bb2c0c114f2a5c14
Merge: b2e980b2d ae78163c3
Author: Jamie Lindner <jamievlin@outlook.com>
Date:   Sat May 9 12:02:52 2026 -0600

    Merge pull request #598 from vectorgraphics/dependabot/npm_and_yarn/webgl/fast-uri-3.1.2
    
    Bump fast-uri from 3.1.0 to 3.1.2 in /webgl

commit 4591ff276bbbcf63a238aa94a55c1395c9f5ab99
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 9 10:52:25 2026 -0700

    Update bundled GLEW to 2.2.0; handle Wayland GLX error gracefully; add vsync support to OpenGL.

commit 17760f8ebcb23919557e42caf9a99c6d542ffab0
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 9 00:10:28 2026 -0700

    Support -nothreads again.

commit 6a46a123c81af26bc5b09e6dfa1e62bc82024e85
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 8 23:36:34 2026 -0700

    Eliminate busy-wait spin loop in main thread.

commit ae78163c39ca1a7bec1f74b56741adcb2e9914b7
Author: dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
Date:   Sat May 9 01:18:02 2026 +0000

    Bump fast-uri from 3.1.0 to 3.1.2 in /webgl
    
    Bumps [fast-uri](https://github.com/fastify/fast-uri) from 3.1.0 to 3.1.2.
    - [Release notes](https://github.com/fastify/fast-uri/releases)
    - [Commits](https://github.com/fastify/fast-uri/compare/v3.1.0...v3.1.2)
    
    ---
    updated-dependencies:
    - dependency-name: fast-uri
      dependency-version: 3.1.2
      dependency-type: indirect
    ...
    
    Signed-off-by: dependabot[bot] <support@github.com>

commit 20c25094286f19a3141ec733d883e3823ae01476
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 8 11:12:51 2026 -0700

    Use CPU-side index count for Vulkan draw calls, matching OpenGL behavior.

commit e5ac48a9a01ca0403c1ebdd79910dff05bb7be7e
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 7 22:59:25 2026 -0700

    Fix flickering.

commit b2667573145ebccc7b48ce252cfc258354f48f27
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 7 19:57:54 2026 -0700

    Fix warning message.

commit 121cec3f094eea1f395bd41a7eb8584430e2dac2
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 7 14:06:24 2026 -0700

    Move signal handling to a separate class; defer renderer creation to shipout3.

commit a8ec85f08eb441da6e05b9a034ec645d12a53459
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 7 09:21:28 2026 -0700

    Remove unused include.

commit b7870fd6d911b0c6f9feeb3270a764c532acb6e0
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed May 6 23:53:53 2026 -0700

    Fix compilation under macOS; add llvmpipe Vulkan fallback for macOS Intel when Metal is unavailable.

commit d2658207fbcc210e508ff4c7264c7219ba4f9688
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed May 6 00:32:54 2026 -0700

    Optimize CMake build.

commit d804839f3f19dfbbd1ab27bda3a013c4dcfe64b6
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 5 11:09:50 2026 -0700

    Fix export.

commit 3f39aa84b9889ded8bc8415e06c527d001e9f1e5
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon May 4 22:47:29 2026 -0700

    Load render library shims from Asymptote search path.

commit 9e87f7071cb61fe0f5a2efcb0ddd34eda34df046
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon May 4 11:51:46 2026 -0700

    Unify mouse and export handlers in AsyRender, fixing Vulkan cursor-position bug.

commit ea5b7868d3c159eafbd58d4fa39df5f5f6e11ff6
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon May 4 10:22:53 2026 -0700

    Simplify code.

commit 6822853d87267bfb05b05165727867cb83cbf907
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon May 4 00:06:37 2026 -0700

    Simplify code.

commit 1ffa6561efb23af3ef4a50eeae49831a8e91e1cb
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 3 23:51:30 2026 -0700

    Respect wheelup and wheeldown settings.

commit f17269f5d416128f840918c4d2088fb9eac7092f
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 3 23:25:46 2026 -0700

    Remove obsolete OSMesa support.

commit 0cfb57ed72350c9a55317c9a423c54137305ae57
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 3 22:41:21 2026 -0700

    Remove unused code; fix Makefile dependencies.

commit f54aac2dd4b898c41d453554f41aef8f70261ddb
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 3 22:20:52 2026 -0700

    Fix vulkanshim.cc.

commit 04d1aded7de1a09879fa8d714da51dc24a699d6f
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 3 22:08:28 2026 -0700

    Consolidate duplicate code.

commit 0d688faf97712ae14cc4100d6dcc41bb70140ead
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 3 10:36:28 2026 -0700

    Remove obsolete vcpkg workflow from configure.ac.

commit e1997c8aff834d3f6c382c7170fdbe661d5561ec
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 3 07:46:49 2026 -0700

    Enable large config for cmake builds.

commit 00ca0c8c1e6c3e8edae15c5cbd0509980bc9199b
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 3 01:05:11 2026 -0700

    Add llvmpipe software Vulkan fallback for Windows systems without a hardware GPU.

commit 3b82e76e06d009452639f21318baea0db4689ca8
Author: asmwarrior <asmwarrior@gmail.com>
Date:   Sun May 3 11:41:59 2026 +0800

    export a updateScene function, so the user can do robot motion manually

commit 6520ab04bfc9ed1f4ee4d7600b616f0dda310d28
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 2 16:29:49 2026 -0700

    Support compilation without LIBGLM again.

commit bc337aa9476f32b2ed8eb2cec6a5813fdc3c2337
Merge: a66e8a3a6 7d308d5d9
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 2 15:19:07 2026 -0700

    Merge branch 'vulkan' of github.com:vectorgraphics/asymptote into vulkan

commit 7d308d5d95124032ad51161cfe04626e5fa018f2
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 2 15:13:57 2026 -0700

    Add missing files.

commit a66e8a3a698c239d97eccda8d55c09717aa47ff6
Merge: fd69bda31 38d88219c
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 2 15:14:16 2026 -0700

    Merge branch 'vulkan' of github.com:vectorgraphics/asymptote into vulkan

commit 38d88219c6e58adaeea655845daf76d20aa0acc1
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 2 15:13:57 2026 -0700

    Add missing files.

commit fd69bda313d6c63fedcb372799b05d0c795ed132
Merge: 2d72ea6ee 574278871
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 2 15:12:42 2026 -0700

    Merge branch 'vulkan' of github.com:vectorgraphics/asymptote into vulkan

commit 574278871d0123f07a02ca7ec21ca7a604b5c73b
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 2 15:11:34 2026 -0700

    Fix Vulkan dispatcher initialization on Windows.

commit a3fea6cbbf3bfebd8d4844178b00aa5020080c53
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 2 14:44:23 2026 -0700

    Extract WebGL/v3d rendering into AsyWebGLRender, eliminating Vulkan/OpenGL dependency for HTML output.

commit 2d72ea6eef9f1a85c1ae7d2440f37221a6d6eb38
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 2 15:06:32 2026 -0700

    Fix Vulkan dispatcher initialization on Windows.

commit 3126ddcede47f9cf7df5fdaf19788c75bfbf4e38
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 2 14:44:23 2026 -0700

    Extract WebGL/v3d rendering into AsyWebGLRender, eliminating Vulkan/OpenGL dependency for HTML output.

commit a792d9a5e14c0754181713238bf86832356d1e1a
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 2 14:48:52 2026 -0700

    Fix last commit.

commit c23b5413039fcfbe3d6f1cb9d037d4956a27878e
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 2 14:28:52 2026 -0700

    Fix duplicate YYDEBUG under MSWindows.

commit 77de6709bfcc98c5c8d9ddf69966d8d03487cc76
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 2 13:40:02 2026 -0700

    Fix Windows build crash by directly instantiating Vulkan renderer.

commit c7e36157bb0ccc319060f997348f26b3544867aa
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 2 10:25:39 2026 -0700

    Remove dependence of -render=0 -prc workflow on Vulkan and OpenGL libraries.

commit 28c05145515df5122290eb8a220f1ccb6cb77bed
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 2 02:18:20 2026 -0700

    Don't require either Vulkan for OpenGL.

commit 6552b4d27c9033e96286011abe898e1d5d2b3860
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 1 10:49:56 2026 -0700

    Move gl pointer to renderBase.cc.

commit 2eee1818d245fb98c888084a5aced530c9c77b3e
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 1 07:33:40 2026 -0700

     Don't link explicitly against the OpenGL libraries.

commit 346651b37431bf26bb9db975526bd34d0ab1e847
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 1 07:02:41 2026 -0700

    Fix vcpkg workflow in configue.ac to avoid linking Vulkan into main binary by bypassing pkg-config for glfw3.

commit 2db350fa05dd39f8984abcb4a2a71330023ad693
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Apr 30 11:06:54 2026 -0700

    Don't link explicitly against the vulkan libraries.

commit 42f62f35ffc5ee0e6bc12fa3c0e42f51754e9a98
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Apr 30 00:11:21 2026 -0700

    Support compilation without Vulkan.

commit feb814338878b517652560df25dda29c76f4449d
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 29 22:47:48 2026 -0700

    Avoid linking duplicate (or triplicate) libraries.

commit 0b55f91286d0daa576d4333d4b50fa978f5a112d
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 29 22:33:31 2026 -0700

    Install OpenGL shaders.

commit 758d9257f16ba73e30faeb8f5dfc4d6241953cac
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 29 20:10:32 2026 -0700

    Fix -novulkan -noGPUinterlock.

commit f18944bf7943740e5d2dea2e1b928fb884945632
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 29 19:00:59 2026 -0700

    Fix validation warnings.

commit c79bd95c13b8646ff43e9de490cad467ee830bb5
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 29 10:40:37 2026 -0700

    Fix OpenGL transparent offscreen culling.

commit c27bcd6f52eb3f11a88e1fef6ae72139e44521d7
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 29 10:01:44 2026 -0700

    Reduce default maxFramesInFlight to 3.

commit 35c93dd03e8474a5c9d220b39dd9bd2d2b4e02c4
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 29 09:53:24 2026 -0700

    Fix transparent offscreen culling.

commit 05ec814ffabdba2d6488045c200971911fbdaa1e
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 29 09:19:03 2026 -0700

    Use renderCount instead of rendered bool to prevent premature data loss with multiple frames in flight, partially reverting commit 8c16ee251d1ae2bf07b6a66af8a781d2e2da7253.

commit 6e089147805f53efca03193b2f2b2a5b183151c5
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 29 00:37:38 2026 -0700

    Fix validation errors.

commit 9084b6de50b4907e733737f3fcec2caedf2a1d89
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 28 22:44:54 2026 -0700

    Use persistent per-frame GPU buffers in Vulkan to avoid reallocation overhead.

commit 48c6392d8da26e5578d7b0846029a61ac7c340b6
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 28 21:42:59 2026 -0700

    Simplify code.

commit 8a12c0b7bc6540328aa0b5208188cf80da340f4a
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 28 16:42:27 2026 -0700

    Optimize vkrender.cc.

commit ac519cc6ee51cd95bd2b401c8741e581397dbd7d
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 28 16:06:19 2026 -0700

    Use peristent buffers in Vulkan to match OpenGL behaviour.

commit 1ee57ba67c607c87b2af633b219a48b093d91127
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 28 15:51:23 2026 -0700

    Simplify code.

commit 8c16ee251d1ae2bf07b6a66af8a781d2e2da7253
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 28 12:39:03 2026 -0700

    Standardize code.

commit a13f7f98dad00aaa153aeb13396904f76f26072e
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 27 10:42:37 2026 -0700

    Optimize OpenGL code.

commit 664296dd405290be6c32f762802283e824445547
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 27 00:20:49 2026 -0700

    Standardize code.

commit 1c0a6f196a6da243917c29662974b0cd1accff4e
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 27 00:04:19 2026 -0700

    Port to MSVC.

commit 6619f6b43038bed82bd937351488e2692a632d37
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 26 23:48:52 2026 -0700

    Fix multisampling; remove obsolete code.

commit 455b7b29eca9a8be498e1e4f6eb1e6be19e8fcae
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 26 23:05:15 2026 -0700

    Fix arcball by updating unit() to accept a specified value to return for pathological inputs.

commit 2c58da6e411285290b2c324d4658eae6253c900e
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 26 22:43:43 2026 -0700

    Fix OpenGL rendering on Intel Macs

commit 796b236611dded287c9c7381f102c647de44d9a6
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 26 20:11:41 2026 -0700

    Fix GC diagnostic.

commit 96535c87a6d340977b3c0c6f3f33e4a9fce00451
Merge: ac9f0f179 692c50c5e
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sun Apr 26 19:29:01 2026 -0700

    Merge branch 'vulkan' into vulkan-bundled

commit 692c50c5ea83318e402571624268754c41e58fd4
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 26 14:55:19 2026 -0700

    Remove obsolete code.

commit 94b67f24509895ceb7502291ab44ade2346c2d38
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 26 14:42:13 2026 -0700

    Fix lighting.

commit 83a6ec892f7876ea94f3ff627a137c4fa180556c
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 26 11:59:31 2026 -0700

    Fix floating point exception.

commit a770fc0a8ebc962905e4443b15d7538bb2086d87
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 26 01:37:51 2026 -0700

    git subrepo pull --force LspCpp
    
    subrepo:
      subdir:   "LspCpp"
      merged:   "116f7de34"
    upstream:
      origin:   "git@github.com:vectorgraphics/LspCpp"
      branch:   "master"
      commit:   "116f7de34"
    git-subrepo:
      version:  "0.4.9"
      origin:   "https://github.com/ingydotnet/git-subrepo"
      commit:   "b9b059a"

commit b2e980b2d03ecc0ade75a52b71ff5392c18a628a
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 26 01:37:51 2026 -0700

    git subrepo pull --force LspCpp
    
    subrepo:
      subdir:   "LspCpp"
      merged:   "116f7de34"
    upstream:
      origin:   "git@github.com:vectorgraphics/LspCpp"
      branch:   "master"
      commit:   "116f7de34"
    git-subrepo:
      version:  "0.4.9"
      origin:   "https://github.com/ingydotnet/git-subrepo"
      commit:   "b9b059a"

commit ce68731749f5349d607d00028afb1e9136b54e89
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 26 01:08:12 2026 -0700

    Fix clang++ warning messages.

commit 0ad292f62ce2c49ae20c3fa3b421225b7ae8532d
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 26 00:47:56 2026 -0700

    Suppress Eigen warning messages.

commit 1edd3902a3ed1d110abf1a2b06700c14b459158b
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 25 23:46:08 2026 -0700

    Fix VMA warning message.

commit f26efeba74631c84e61e82266ca730ceee7ebe6d
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 25 23:41:08 2026 -0700

    git subrepo clone --branch=v3.3.0 https://github.com/GPUOpen-LibrariesAndSDKs/VulkanMemoryAllocator VulkanMemoryAllocator
    
    subrepo:
      subdir:   "VulkanMemoryAllocator"
      merged:   "1d8f600fd"
    upstream:
      origin:   "https://github.com/GPUOpen-LibrariesAndSDKs/VulkanMemoryAllocator"
      branch:   "v3.3.0"
      commit:   "1d8f600fd"
    git-subrepo:
      version:  "0.4.9"
      origin:   "https://github.com/ingydotnet/git-subrepo"
      commit:   "b9b059a"

commit 289e1df5f1a0db2b63689ef532ec2c31f18cfcaa
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 25 23:40:56 2026 -0700

    Remove VulkanMemoryAllocator.

commit 2a8c930e871f912b866f36eefff4460d3f4859bc
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 25 23:30:30 2026 -0700

    Fix validation error.

commit 32f58691802467debee9f7709bee41f963e13c4e
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 25 22:17:46 2026 -0700

    Disable GPUinterlocks for NVIDIA RTX 3000 series GPUs.

commit 3963898110185afdb0d2bd2f5afd90ec0dea6439
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 25 18:47:57 2026 -0700

    Fix last commit.

commit 04ed4937559bfa0e639a8972a096a2af30f7cf49
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 25 18:42:14 2026 -0700

    Abandon dynamic loading on Windows; require Vulkan.

commit db8bf6c0da293de8816c4fec3b7f21544c648f19
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 25 15:16:47 2026 -0700

    Fix cmake renderer detection.

commit c2e805ca50fe2e1162381259e4fe8f0e14a47d23
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 25 13:38:51 2026 -0700

    Fix commit 53f6807c12919668eb81f2ec4f74470750e1c0fd.

commit 250e1fb10174471a0bd69b7dac47461cf6bb60cc
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 25 13:01:58 2026 -0700

    Fix diagnostic.

commit 9f4828863d88c1d51f019768344106ca1864082a
Merge: 53f6807c1 5f9fd8934
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 25 11:50:50 2026 -0700

    Merge branch 'master' into vulkan

commit 53f6807c12919668eb81f2ec4f74470750e1c0fd
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 25 11:31:18 2026 -0700

    Only initialize Vulkan or OpenGL when needed; add vulkan setting.

commit cc5c7183bae21a01b29f395832b13c8a99ae62cb
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 25 00:25:21 2026 -0700

    Simplify code.

commit 02b18ebf2328b326ad693661baef1ed40aead7d4
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 25 00:06:38 2026 -0700

    Remove debugging diagnostics.

commit e079cd5e1e21dbfcc76ca602c56d3f54449b2372
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 24 23:39:06 2026 -0700

    Fix GLEW includes.

commit 11bac47e299e0166c3f9c48a85789612a9591fb9
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 24 23:32:37 2026 -0700

    Fix GLEW includes.

commit 7ed4977dbaaa2a7bcedaf89940db66e6d593a8e6
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 24 23:22:28 2026 -0700

    Fix MSWindows port.

commit 89707679215d01755e7e4f261ebb0f5476ff0bdd
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 24 23:20:41 2026 -0700

    Fix MSWindows port.

commit b92840ecacafd41af54320b0f6bd53c98ea31d7c
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 24 23:18:19 2026 -0700

    Fix dynamic loading on MSWindows.

commit 25bb1183f8e9ea54c87c61444fa5dd4d4412767f
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 24 23:07:53 2026 -0700

    Fix cmake OpenGL dependencies.

commit a3568862bc93fd94c720e6cff12180adc55cce04
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 24 22:58:10 2026 -0700

    Avoid MSWindows conflicts.

commit 1b6b639412c1c9d7670c6e8797d47cc46a3a5619
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 24 22:51:45 2026 -0700

    Simplify includes.

commit ba86ebc6bcfb7629c708a8906656b7b7387c1714
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 24 22:37:48 2026 -0700

    Update CMake build.

commit 18ff5ecb6aee4713aa5c9dfcd9e6865bbc1554fd
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 24 22:10:12 2026 -0700

    Dynamically load libvulkan with a fallback to libGL.

commit fef5817a7c18bb83af0baabf106358e3ba3ee3e4
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 24 21:24:36 2026 -0700

    Port to clang++.

commit 63acd47a8b326b75bd1ea00af543756fe8d85b66
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 24 21:12:01 2026 -0700

    Add OpenGL shaders.

commit f3260f85fcbb7800e040af190b3d71cbe4e2f92f
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 24 20:22:21 2026 -0700

    Unify Vulkan and OpenGL renderers.

commit a3f548de46c51f22cc15aafc107c145c88c1c600
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 22 21:50:00 2026 -0700

    Remove unused code.

commit cbd1d0515e67b5fded6daf692b4e2bcf593716cc
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 22 21:17:47 2026 -0700

    Fix commit 382474f8907eda5d39d00d94f7e1894351dbd432.

commit 4fbb26f1b07871ea54000fd8c5795a5301fb6c11
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 22 20:39:13 2026 -0700

    Standardize code.

commit 382474f8907eda5d39d00d94f7e1894351dbd432
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 22 20:30:40 2026 -0700

    Fix memory leak.

commit 36fcd9765d954f37a7828f335b1cbd885f9fd827
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 22 20:02:17 2026 -0700

    Remove extra clearMaterials.

commit 59d6fb1c4b4af97e6e6c31555b534bcfaac53d56
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 22 17:49:50 2026 -0700

    Standardize code.

commit f6f90589b348efa866588b6f84b53c0a98c76314
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 22 00:08:38 2026 -0700

    Fix export aspect ratio.

commit e77a1f8893578d827edcec288b71bcfdbae94506
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 21 23:52:26 2026 -0700

    Simplify code.

commit 5f8bab127e649174bc4234162f249a42e38d1730
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 21 23:44:42 2026 -0700

    Standardize code.

commit 21a1ad981a6d990dcfe24a96627382c3d48ec783
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 21 23:37:13 2026 -0700

    Simplify code.

commit 6495cd4f084de4924c40ce24df4c3c6e6023d344
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 21 18:50:06 2026 -0700

    Set initial VertexBuffer sizes.

commit 99e8d253181425e0622ca49a6513b56189f850ed
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 21 09:15:50 2026 -0700

    Fix interactive mode.

commit 8ce8e23a431d1ad8bdf1560a4b78afc6404909db
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 20 11:25:08 2026 -0700

    Standardize code.

commit cf4da0a9e1705397466f0711bdf7ff8b4072abdd
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 20 01:25:30 2026 -0700

    Standardize code.

commit 4e0dba03f81580fb88c07f16cda38342c8fd6f52
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 20 00:53:18 2026 -0700

    Update renderBase.

commit a7025aa33f3fa9e08d94f70a039b8e8f6326be6c
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 19 23:00:14 2026 -0700

    Simplify code.

commit 4fe9bbf947821dca092d7fa6925bc143a5dbe92e
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 21 10:16:05 2026 -0700

     Move mainLoop to renderBase class.

commit f18f751c1f62e7cc9dabdf700ca4cdc6992114de
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 21 09:52:20 2026 -0700

    Revert "Fix potential race condition."
    
    This reverts commit e4a1df19074cc452b4c4ef140c9e5c3b1839ed5b.

commit 078f70b2858a8df95cf87f97352e987b272fb647
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 19 22:00:19 2026 -0700

    Remove unused function.

commit 1ebf54c0bbebd734ae86e01e0078695aee45cc12
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 19 21:29:51 2026 -0700

    Rename reshape0 to reshape.

commit 2b06b28c33181adbef116452835a5be66ba7e016
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 19 16:07:00 2026 -0700

    Replace vk by generic gl pointer in AsyRender base class.

commit 97f3c76cb8cdc09c9651717fa8bd13b74ceed226
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 18 22:30:20 2026 -0700

    Simplify code.

commit 9cb4db1c8f7c44fe05de094b400de34d194fd5fa
Author: asmwarrior <asmwarrior@gmail.com>
Date:   Sun Apr 19 15:13:51 2026 +0800

    webgl: Fix animated billboard label rendering issue
    
    Animated billboard labels were incorrectly being culled by the offscreen check,
    causing them to not render when they should be visible.
    
    Root cause:
    - The offscreen check used Tcorners() to transform only bounding box corners
    - Actual rendering transforms all control points with T()
    - For animated elements, control points can move outside the static bounding box
    
    Solution:
    - For billboards with transforms (CenterIndex != 0 && this.transform),
      check offscreen status using actual transformed control points
    - For non-billboards, continue using the existing bounding box corner check
    
    This ensures consistency between offscreen detection and actual rendering,
    matching the approach used in the C++ OpenGL renderer.
    
    Fixes issue where billboard labels would disappear during animation
    despite being on-screen.

commit 2c351306763a9364358b2e3b7ef5fcfa0b778ba0
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 18 22:20:32 2026 -0700

    Remove BBT array.

commit 60b9bc2f8e87d3415fd186d4900fd65ba7bc1e36
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 18 21:52:18 2026 -0700

    Standardize renderBase class.

commit 03e5007ba71b42850d63902152379516fb84d962
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 18 20:23:04 2026 -0700

    Fix render.cc example.

commit 0d194daf2d62360c7581726dbfa54d1224bf354f
Author: asmwarrior <asmwarrior@gmail.com>
Date:   Sun Apr 19 10:16:42 2026 +0800

    Try to fix the billboard issue in the webgl animation
    
    The code is mainly  copied from the last year's test code in my modified js file
    
    https://github.com/asmwarrior/asymptote-demo/blob/master/asygl.js

commit a0f1cc9fe6949c9fb4eba3fe41ed5349555bf99a
Author: asmwarrior <asmwarrior@gmail.com>
Date:   Sat Apr 18 11:39:42 2026 +0800

    fix the transform block function call sequence

commit 54f929a8fc3cd712641ef60e6b13fc5435c55185
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 18 12:47:41 2026 -0700

    Optimize Bezier rendering.

commit 182cb1b3bc4647bcf89a5bcfef8a1daaa06f00ea
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 18 11:45:15 2026 -0700

    Fix validation error.

commit 7feff627c3a5f688bcd4acaea4d19b80726bf762
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 18 10:42:29 2026 -0700

    Use 3x3 normMat; avoid global variables.

commit d52912b4be3bc772b82b4ba2651236513d7e40f4
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 17 17:57:12 2026 -0700

    Remove unused struct.

commit 5726b66ad4f0b6618094743a37a0fd9a0239095f
Merge: d03b2d160 5f9fd8934
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Apr 17 18:44:20 2026 -0700

    Merge branch 'master' into add-licenses

commit d03b2d160bee48353a71418c37e08dc76f549c9d
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Apr 17 18:44:04 2026 -0700

    Fix (hopefully) error in github install test.

commit 3e573838b8b2de2af233e1f4178b35d0d212e90b
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Apr 17 17:48:34 2026 -0700

    Git should ignore locally installed licenses.

commit 13336c8821d5457a198d539dbb4f065edd40f5fd
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 17 14:24:31 2026 -0700

    Simplify code.

commit 398fd14276fcf89fe029d57ca7a4b8f3e46ccc8f
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Apr 17 13:39:47 2026 -0700

    Make `--licenses=full` look up licenses rather than hardcode them.

commit e4a1df19074cc452b4c4ef140c9e5c3b1839ed5b
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 17 01:01:18 2026 -0700

    Fix potential race condition.

commit 5f9fd8934f79414f40e044a6997f9409e08e2baf
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Apr 16 20:00:41 2026 -0700

    Update README.

commit b9959959731a48722b3bedd2f6d31d3213ad14be
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Apr 16 16:15:17 2026 -0700

    Update renderBase.h.

commit c2a17a9d7c82e2b4bee486023b3fa35752db0acc
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Apr 16 15:57:35 2026 -0700

    Simpify code.

commit 604849c2607ba02f2707eeaebedcd588df7ee779
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Apr 16 01:09:12 2026 -0700

    Generate feedbackBuffer even with noGPUindexing.

commit 4d793f2888eb2d52423b67e1210bfa4c37cb41ea
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 14 18:04:57 2026 -0700

    Move runtimeError into glfw.cc.

commit a37793c75cd9bc1e765761d6931ac7657e715704
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 14 09:22:02 2026 -0700

    Switch to install-texlive GitHub Action and add Ghostscript caching.

commit 36700f5cc82f5df4f4ad310c0fc49214a896667b
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 14 00:50:34 2026 -0700

    Fix cmake build.

commit 1214613176052b3f7da1afbd5e630bf52f833e17
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 14 00:30:01 2026 -0700

    Fix mouseButtonCallback.

commit 0511d68e02154191f8d21f79e52a82859f0bba3a
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 14 00:09:38 2026 -0700

    Fix multiple 3D scene rendering.

commit d8cf6c23ee5fc204bb0595517a87c502a3d9eacb
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 13 17:16:59 2026 -0700

    Move more functions to renderBase class.

commit 15ed806b1de0177668f8d4b5ee937355373369ba
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 13 15:32:12 2026 -0700

    Move thread synchronization functions out of vkrender.h.

commit 8eed9dd74d6e6ddb5b232c6b7dd70b5c6c3a094b
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 13 15:12:22 2026 -0700

    Move more library-agnostic functions out of vkrender.cc.

commit bebc6133c3c53b43f6f2e183da68acaa9ac2120b
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 13 14:02:28 2026 -0700

    Derive AsyVkRender from new library-agnostic AsyRender class.

commit ac9f0f17991031249336e0de03a641db1d26e22f
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sun Apr 12 14:00:59 2026 -0700

    Bundle vulkan with asy on MacOS.

commit 50a5d5b1c6cd7b0e222f273290e6e0f1f09a553c
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 12 09:35:13 2026 -0700

    Standardize variable names.

commit 911207160df7217e8196cc2a246aeda735e28772
Merge: a655d73ee 836b5cacb
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 11 22:02:57 2026 -0700

    Merge branch 'master' into vulkan.

commit 836b5cacb68ac0f72193c3e0e0d2eabd1ae3fab2
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 11 21:37:32 2026 -0700

    Fix minor documentation issues.

commit 7754f5011e093006622605cebd66aecf84b15248
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 11 19:57:57 2026 -0700

    Add further missing menu item descriptions.

commit 0a34d0bab0dc9ed8004b571082c2047fdb91f07a
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 11 14:47:59 2026 -0700

    Fix typos in documentation.

commit 09dd6d65475df3de946c743477c2ef21e02eb464
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 11 14:05:13 2026 -0700

    Add missing menu item descriptions to documentation.

commit 8383bffcdefc362ce4f90849e9a6c492738b92d9
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat Apr 11 16:30:43 2026 -0700

    Make -licenses=full report GPL for Windows.

commit 10e300b36f4f661f48ac21729824e68e61b44075
Merge: 0b98d78bf 66205a53b
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat Apr 11 15:52:10 2026 -0700

    Merge branch 'master' into add-licenses

commit a655d73ee26f14ccdbe3a1b318fc4e815e5976cd
Author: charlesstaats <charlesstaats@users.noreply.github.com>
Date:   Thu Apr 9 16:20:14 2026 -0700

    Check expected runtime errors in collections library. (#595)
    
    * Check expected runtime errors in collections library.
    
    * Fix cmake test error.
    
    * Reformatted test_collection_errors.py.
    
    * Fix minor issues discovered in review.
    
    * Fix non-verbose failure output of test_collections_errors.py.
    
    * Improve readability of test_collections_errors.py.
    
    * Reformatted with updated formatter.
    
    * Rename base-dir to asy-base-dir to match similar files.

commit 66205a53b24a9fa467a0c66459d004a7326f4614
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Apr 9 14:32:17 2026 -0700

    Reorganize documentation of base modules.

commit 0b98d78bf779643e7d1cf31558635047495fbeb3
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Apr 10 17:11:19 2026 -0700

    Slim down and deduplicate license docs.

commit 714a6f0afada27bb6cf9523349a7d7c03f1ea93d
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Apr 10 16:41:17 2026 -0700

    Deduplicate license install cmake code.

commit 8364daf3b0c55d9488ff530eb79f1178db44ff81
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Apr 10 08:37:17 2026 -0700

    Add LGPL license to `asy --licenses=full`.

commit 9460db5fcc3c604d970192e0d5b3d2bfe6821c43
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu Apr 9 21:21:35 2026 -0700

    Subdivide too-long string for MSVC.

commit 82963a6e71687cf3bc5e8006658893be26090425
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu Apr 9 20:49:30 2026 -0700

    Minor fixes suggested by review.

commit b160637e90de9c684a2c6a3172104ed42083f35d
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu Apr 9 20:34:24 2026 -0700

    More comprehensive gc/LICENSE.txt. License installation fixes.

commit f71be6a6b07bf9256e5501b16de604c036e3346c
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu Apr 9 18:45:04 2026 -0700

    Delete references to legacy getopt.h.

commit c45aaeb5c1813142927b4bd1c3cee430272ba954
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu Apr 9 16:53:32 2026 -0700

    Update licenses for TinyEXR and wyhash.

commit b67b09c3474df817efeb2c23713ade780100da0c
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu Apr 9 16:24:26 2026 -0700

    Remove references to previously included getopt.

commit 568370b6251b3717d03e7bb0fa3e408477688707
Author: charlesstaats <charlesstaats@users.noreply.github.com>
Date:   Thu Apr 9 16:20:14 2026 -0700

    Check expected runtime errors in collections library. (#595)
    
    * Check expected runtime errors in collections library.
    
    * Fix cmake test error.
    
    * Reformatted test_collection_errors.py.
    
    * Fix minor issues discovered in review.
    
    * Fix non-verbose failure output of test_collections_errors.py.
    
    * Improve readability of test_collections_errors.py.
    
    * Reformatted with updated formatter.
    
    * Rename base-dir to asy-base-dir to match similar files.

commit 0641363a504732d68ff3d6f2f1f73d267d6f5af5
Merge: 852d17cd4 3cd86651a
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu Apr 9 16:15:40 2026 -0700

    Merge branch 'master' into add-licenses

commit 852d17cd4d66514c2f094ba27cd63d107f620757
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu Apr 9 16:15:21 2026 -0700

    Minor update to maintainer doc.

commit 5e766450d363383ff6e6b4eb96118deed6e77500
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu Apr 9 16:13:49 2026 -0700

    Add missing file.

commit b159c369b5d98279260c1061a264e4b2023f30ac
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu Apr 9 16:08:17 2026 -0700

    Added `-licenses=full` option to print all the licenses.

commit e5823ba21cebe8b03cb91ed361612fb7c26e7863
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu Apr 9 15:33:16 2026 -0700

    Move wyhash.h into its own directory.

commit dfd9fd07d920661b743c8a885ef650ecde7fab55
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu Apr 9 14:54:46 2026 -0700

    Correctly describe role of MAINTAINER-LICENSE-GUIDE.md.

commit 2e8b08ad68d550e7d18a77be29fd0ce178c56e0b
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 8 22:53:20 2026 -0700

    Remove .c suffix from Makefile.in.

commit 581c86d222365f3a932bce78b23880ff99cab2c3
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 8 22:41:02 2026 -0700

    Update CMake build.

commit 9e6671949050f3b8ece5812ffe32b4e836810e95
Merge: 07d7b659d 3cd86651a
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 8 22:33:56 2026 -0700

    Merge branch 'master' into vulkan.

commit 3cd86651aaebf288c92c7cbdd918424bba3b1633
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 4 01:30:53 2026 -0700

    Fix last revision.

commit b9ca8371dcc52d973cc0ecf657791d97473218c0
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 8 21:51:58 2026 -0700

    Remove legacy getopt fallback.

commit 51c08e567f6366f9766525f22f05af25b39c11e0
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 8 21:33:13 2026 -0700

    Update getopt URL in README.

commit 00bca636352112171525a53f2f35c271d41a0a0b
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 4 01:18:58 2026 -0700

    Update getopt archive.

commit 2fbd4ced0a11a1cfe07535af19ec4dfb1ff2ab55
Author: Charles <charles.staats.iii@gmail.com>
Date:   Wed Apr 8 18:45:56 2026 -0700

    Replace reference to HighwayHash with wyhash in doc.

commit dddbeaa8ac0c78857a69cc6171f3b820f6af5a5f
Author: Charles <charles.staats.iii@gmail.com>
Date:   Wed Apr 8 16:02:38 2026 -0700

    Add licenses to install scripts; documentation fixes.

commit 07d7b659da0420cd20d044237e90aa949ce09f6b
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 7 23:42:37 2026 -0700

    Restore colorPipelines.

commit ca007387669a863476856fe554de77836eec38af
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 6 16:14:01 2026 -0700

    Factor out GLFW code from vkrender.cc.

commit c5175d8feeb25a04598914dac34a12a97bba8380
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 6 15:43:10 2026 -0700

    Fix default screen dimensions.

commit f966288e77c11ad5047cd029d8729f0ab6bbcd19
Merge: 40a618148 98b7152cf
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 6 12:37:23 2026 -0700

    Merge branch 'master' into vulkan.

commit 98b7152cf3d721d16b1ed268d0ddd63f8d24a6ca
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sun Apr 5 16:32:50 2026 -0700

    Delete obsolete files (previously kept for comparison).

commit 92ebc226295fa9700bcd075ffc9d845a3d89176e
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sun Apr 5 16:21:43 2026 -0700

    Update license information.

commit 28bf142cf18d269ec456f0bb3b76d6d681f07c84
Merge: 6932da3f5 a5e2fa7d8
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sun Apr 5 15:53:26 2026 -0700

    Merge branch 'master' into add-licenses

commit a5e2fa7d8ff8c98609ab18a833804c58583db32c
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 4 22:04:45 2026 -0700

    Update installation instructions.

commit a71438463899a5067a0dde1fde75657e510437fb
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 4 22:03:58 2026 -0700

    Remove transitional test file.

commit d4a2a10e286af95ace7f42692568bf6b36667a89
Merge: 1708c5f09 507ad55cd
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 4 21:59:25 2026 -0700

    Merge pull request #593 from vectorgraphics/split-wce
    
    Split wce.

commit 507ad55cdf88378a66d3c1a804e3e4c61520566a
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat Apr 4 21:29:40 2026 -0700

    Format wce.

commit d0684813693c71ee8e259e46d83536621f5e95ff
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat Apr 4 21:18:44 2026 -0700

    Format python file.

commit 666c17f7140059fd1a7044d43724788ad2ab438a
Merge: 1708c5f09 4e0d86842
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat Apr 4 20:45:20 2026 -0700

    Merge branch 'split-wce' of https://github.com/vectorgraphics/asymptote into split-wce

commit 1708c5f095b8d0b2735c642c83878a6fd26228e8
Merge: d269ab860 fec551c20
Author: charlesstaats <charlesstaats@users.noreply.github.com>
Date:   Sat Apr 4 20:22:56 2026 -0700

    Merge pull request #527 from vectorgraphics/autounravelWithDatastructures
    
    Collections (in particular, hashmaps)
    
    Language changes:
    
    User-created structs can be iterated over with for (:) notation if they define operator iter.
    Brackets operators for user-defined structs.
    Builtin hashing for ints, strings, reals, and int[]s.
    
    Additionally, adds a library of collections that use these new features.

commit fec551c2019ad7b671e8f706e17fd90077add7ff
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat Apr 4 19:46:26 2026 -0700

    Move span.hpp into the backports directory.

commit 2f44375e6064ceb414101cd5398387dfdc761c78
Merge: 4efe8c7ab d269ab860
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat Apr 4 19:23:23 2026 -0700

    Merge branch 'master' into autounravelWithDatastructures

commit 40a61814821b327fbb1c21950a8c64eee43e099f
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 4 09:57:11 2026 -0700

    Remove pragma.

commit b427829aa02378c7570eb1e0c890f7b5466b2379
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 4 01:30:53 2026 -0700

    Fix last revision.

commit 7551d05e3b11591812e4713a26a94388a577ff91
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 4 01:18:58 2026 -0700

    Update getopt archive.

commit 78825a040510719b1b3eccdfe9c41d835febbf8f
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 4 01:15:28 2026 -0700

    Revert "Bump the github actions cache key."
    
    This reverts commit fce731711a64037dff3616b879ccc01139428f8f.

commit 10bde0a52204296b131fb66ab47f8570267c9f1d
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 4 01:14:35 2026 -0700

    Revert "Use up-to-date vcpkg."
    
    This reverts commit aada6562f9fc670ed3aa9a05c20d251294ad4a3a.

commit aada6562f9fc670ed3aa9a05c20d251294ad4a3a
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 4 01:02:34 2026 -0700

    Use up-to-date vcpkg.

commit fce731711a64037dff3616b879ccc01139428f8f
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 4 00:46:51 2026 -0700

    Bump the github actions cache key.

commit 93e8d069806e362701a60949eb8d4986dd8cc656
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Apr 4 00:26:53 2026 -0700

    Correct spelling LIBARIES->LIBRARIES.

commit 09158ed101aa6ba3b910f686f5f00e070ac8cb68
Merge: ce43d5604 d269ab860
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 3 21:04:08 2026 -0700

    Merge branch 'master' into vulkan.

commit d269ab860038592e4ce32965ff592ca10622b61b
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 3 20:59:09 2026 -0700

    Use std::optional.

commit ce43d5604b20cab32c11c03452e60b700ae544ec
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 3 20:24:44 2026 -0700

    Update common.h.

commit ef3d7f78e7c2aace1d17e02edc0f1cc92caa1d78
Merge: 3584d0d9d 659f2e956
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 3 20:07:33 2026 -0700

    Merge branch 'master' into vulkan.

commit 659f2e9567c70bd15d02c35210772606ffae4a59
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 3 20:07:20 2026 -0700

    Reformat python files.

commit 3584d0d9d6ca5027a3214357ed2d53a5bb15e481
Merge: 795dcf5aa bfd4d0d44
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 3 20:02:21 2026 -0700

    Merge branch 'master' into vulkan.

commit bfd4d0d44f332fd0148d76b35303d3159bc547bd
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 3 20:02:06 2026 -0700

    Update CI.

commit 795dcf5aaaa18316d2ba08f79ea8e85db15bc114
Merge: 76887b27f 7270628f3
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 3 19:51:09 2026 -0700

    Merge branch 'master' into vulkan.

commit 76887b27f16253204f2c597c14ae21ee8d33f1c6
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 3 11:59:04 2026 -0700

    Initialize swapchain as needed.

commit 7270628f3e61e64b320df169f67e87a7d5dfd640
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 3 09:36:43 2026 -0700

    Clean up empty files.

commit c01176c4d98c6646f922e3952ccb8a2caa0fc7c8
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Apr 2 23:36:43 2026 -0700

    Check Zmax in renderResolution().

commit ee5c4b94cef53b7482c3c78c32bb1fb47a4559d7
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Apr 2 23:26:19 2026 -0700

    Increment version to 3.11.

commit 4efe8c7ab536a09a23fd69ee5fa06cc086087cca
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu Apr 2 13:49:13 2026 -0700

    Add cmake uninstall; minor fixes.

commit 07f23dbe03743dbeb2c08154f81bc208eb03054c
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Wed Apr 1 18:51:37 2026 -0700

    Fix uninstall; fix makefile race conditions.

commit 28be3647be2feded16b833f0aaccf0fe7a32fe1e
Author: Charles <charles.staats.iii@gmail.com>
Date:   Wed Apr 1 08:45:43 2026 -0700

    Simplify code using virtual `signatureless` method.

commit 1f74796b06d957b62b1bacde3c03ad4be5774199
Merge: 8350c9d03 0a3323df4
Author: Charles <charles.staats.iii@gmail.com>
Date:   Tue Mar 31 07:59:42 2026 -0700

    Merge branch 'autounravelWithDatastructures' of https://github.com/vectorgraphics/asymptote into autounravelWithDatastructures

commit 8350c9d03bce521aba72b20ab3fdebaefc0be94b
Author: Charles <charles.staats.iii@gmail.com>
Date:   Tue Mar 31 07:58:21 2026 -0700

    Use rand rather than hash to get random element for testing.

commit 0a3323df444bb6f4e35a8fbd0d9c881885828a58
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 30 21:34:23 2026 -0700

    Add missing `EndTest()`.

commit 4e0d868420319126dcdb080b8c164373143fe34e
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon Mar 30 19:31:37 2026 -0700

    Add a script to verify the old can be assembled from the new.

commit 70f98536ec489cedfa9cccb96c69bd8820c60b62
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon Mar 30 19:30:49 2026 -0700

    Split errortest.asy into several smaller asy files.

commit f8e183bf4993cf827d287cdb4e9bca0180a6e720
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon Mar 30 17:07:12 2026 -0700

    Add mapInterfaceTest.asy.

commit 2db047afbce41f5bed2cf0d3e8bf26a6e6bc6fa5
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon Mar 30 16:54:01 2026 -0700

    Add rangeEdgeCasesTest.asy.

commit d43c759b460d053390f038d8495741befa323c9d
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon Mar 30 16:47:46 2026 -0700

    Add additional btreeSet test cases.

commit 0eb322feb37e1327d80c45d7f23c136afe442e18
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon Mar 30 16:27:07 2026 -0700

    Add iterEdgeCasesTest.asy.

commit c7b4d027bb96367853a70a9bed451196471c4676
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon Mar 30 16:09:02 2026 -0700

    Add autounravelCollectionsTest.

commit 3edcd6110e138e5fdcf9468bbe1f36d81c728a87
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon Mar 30 14:51:28 2026 -0700

    Clarify "exactly once" in hash explanation.

commit 84832a60a198a1e40b57fd4006016cd87c7b8e84
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon Mar 30 14:36:08 2026 -0700

    Minor fixes to documentation.

commit 294eeea9a44e3c9303359b094d20cf7101750489
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon Mar 30 14:26:32 2026 -0700

    Minor fixes and cleaning in base/collections.

commit ff29a627d40b5ae38cca8b747ba5dec244850e66
Merge: ae966de68 8c90f4692
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 29 12:30:04 2026 -0700

    Merge branch 'master' into vulkan.

commit 0222ba4dbf9fe0a31e505b755f756327d024564d
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 29 20:41:41 2026 -0700

    Fix bug #581: Prune spurious roots from lineintersections.

commit 6932da3f52d73a569da3f69c6172fbb15efb3b42
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sun Mar 29 18:50:46 2026 -0700

    Add --licenses commandline flag.

commit 52c7b6532a4b61f7da56d2862020922bd0c6be00
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sun Mar 29 17:43:10 2026 -0700

    Replace highwayhash license info with wyhash.

commit e7e0b7ce83052378a1c49c90362444c07beb4ff9
Merge: 9be9c1e12 8584c9052
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sun Mar 29 17:36:20 2026 -0700

    Merge branch 'autounravelWithDatastructures' into add-licenses

commit 8584c9052b9835f8fc87321d19aa86952e10ba47
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sun Mar 29 17:36:00 2026 -0700

    Document old 'map' datastructure as deprecated.

commit 8c90f46924c4977940a338ff3edf034f68b50ef0
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 29 12:06:00 2026 -0700

    Fix issue #567: options in animation.movie has no effect.

commit b98de4ab30f76f9085c8206fe881207b7d5a7e43
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 29 11:56:51 2026 -0700

    Add comment to Arc routines.

commit 97f4bd339c67360cbbd5f561935456ad15e2b102
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat Mar 28 19:07:40 2026 -0700

    Better comments for keyType and valType.

commit 540ab5dd0b83a46ad1879cad6f7f1a8820ad4649
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat Mar 28 15:37:00 2026 -0700

    Add clarifying comments.

commit ccf29fb3e98b1e3d32225498bfb32fc3f3360956
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat Mar 28 15:16:18 2026 -0700

    Move autoUnravels list from env to record.

commit b56280b264e4a264f34f2f115f4cb40225586255
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat Mar 28 13:18:34 2026 -0700

    Replace header guards with pragma in new files.

commit 02feaa7dfffbb6784b956ad76e6715df7e555d7e
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Mar 28 10:45:51 2026 -0700

    Address issue #574: Avoid division by zero with empty 3D scenes.

commit 700a6801235dc3ee7fe0e172f376b3ca3b92da21
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Mar 27 21:19:32 2026 -0700

    Add omitted #includes.

commit e3408c47f43894e262475be20f926c068db72eb6
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Mar 27 21:15:24 2026 -0700

    Avoid unnecessary memory allocations.

commit cb63eaa17411e028e80537ceba499ca714a13604
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Mar 27 21:14:54 2026 -0700

    Add header guards to hashing.h.

commit 57e6893beab269d2fb896dbd7304a8b1cc5825d0
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Mar 27 20:48:37 2026 -0700

    Replace a nullptr with a non-null error to return.

commit 827e6563f3fd2a43d12e017ae644ab5d708846b7
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Mar 27 20:27:46 2026 -0700

    Replace a reinterpret_cast usage with safer memcpy idiom.

commit c1915d501165fa0c9160c78e7fcad45c5b1ed2c2
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Mar 27 19:48:12 2026 -0700

    Fix minor bug in runstring.in.

commit 1b3df82b0ce171c17c341e74dd203d20334e0128
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Mar 27 19:39:35 2026 -0700

    Minor fixes to random.h.

commit 01b469ea67247abebb6268e80e78591b1cf6b896
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Mar 27 19:33:42 2026 -0700

    Fix and document null behavior for hashsets.

commit 6844a818f1e6712e2e107c0f615ff986d0971c22
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Mar 26 23:30:33 2026 -0700

    Address issue 568: dimension bars are not affected by margins.

commit bed8b269e93823d7f8279e43c4412199ebb6fa5f
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu Mar 26 18:03:54 2026 -0700

    Use wyhash instead of highwayhash.

commit 9be9c1e12c0713def4f555e7b1aa84c1f1253731
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu Mar 26 15:38:20 2026 -0700

    Add instructions for other third-party licenses (AI-generated).

commit 5332bd421a4a2470bd80134b28107045157f3759
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu Mar 26 15:13:01 2026 -0700

    Add license instructions and the boost license.

commit 332ba4cce7e07cb31b77e5a43adfcefc39e3d351
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu Mar 26 14:42:52 2026 -0700

    Update span.hpp to latest version from span-lite repository.

commit 937e5a9e04d2269126be480b1698e051b5651122
Author: Charles <charles.staats.iii@gmail.com>
Date:   Wed Mar 25 19:56:48 2026 -0700

    Delete stale or low-value comments.

commit bbb97d84142e2e197e2e7d2625757119f4c921e4
Merge: c538e28e7 6d2658ce7
Author: Charles <charles.staats.iii@gmail.com>
Date:   Wed Mar 25 19:29:53 2026 -0700

    Merge branch 'master' into autounravelWithDatastructures

commit c538e28e726cb2423af2b8a5b4eee68682c5f8e6
Author: Charles <charles.staats.iii@gmail.com>
Date:   Wed Mar 25 19:26:30 2026 -0700

    Get rid of `tacit` parameters, using ModeGuard at call sites.

commit c626fcfd2a07a62a53dafc429b4f20815fa63f75
Author: Charles <charles.staats.iii@gmail.com>
Date:   Wed Mar 25 17:14:52 2026 -0700

    Use ModeGuard rather than plumbing ErrorMode in some instances.

commit 6d2658ce7a48bead9d5793dd3ae8eab3045f683f
Merge: dd6d89b53 d2a8f7ba6
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Mar 25 16:01:13 2026 -0700

    Merge pull request #591 from vectorgraphics/dependabot/npm_and_yarn/webgl/picomatch-2.3.2
    
    Bump picomatch from 2.3.1 to 2.3.2 in /webgl

commit d2a8f7ba6dc750770a46d46fa3f851bd88a5ca1b
Author: dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
Date:   Wed Mar 25 22:09:57 2026 +0000

    Bump picomatch from 2.3.1 to 2.3.2 in /webgl
    
    Bumps [picomatch](https://github.com/micromatch/picomatch) from 2.3.1 to 2.3.2.
    - [Release notes](https://github.com/micromatch/picomatch/releases)
    - [Changelog](https://github.com/micromatch/picomatch/blob/master/CHANGELOG.md)
    - [Commits](https://github.com/micromatch/picomatch/compare/2.3.1...2.3.2)
    
    ---
    updated-dependencies:
    - dependency-name: picomatch
      dependency-version: 2.3.2
      dependency-type: indirect
    ...
    
    Signed-off-by: dependabot[bot] <support@github.com>

commit f904480496a454e08f34413c46c13a85fa6541c5
Author: Charles <charles.staats.iii@gmail.com>
Date:   Wed Mar 25 14:16:46 2026 -0700

    Some corrections based on copilot's feedback.

commit 28f0bcdb96496357480f40879da418e57982ecf1
Merge: 2a95319db dd6d89b53
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Mar 25 13:03:47 2026 -0700

    Merge branch 'master' into autounravelWithDatastructures.

commit dd6d89b533debdd3d8174e412d7972acee867b01
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Mar 25 13:01:18 2026 -0700

    Fix typos in documentation.

commit 2a95319db10f84f216770fe491503bb83e8f6c66
Merge: 6eacd30b7 bfa87d2eb
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Mar 25 12:20:07 2026 -0700

    Merge branch 'master' into autounravelWithDatastructures.

commit bfa87d2eb38b12525fd4311332cf757d9bc01367
Merge: e66906587 404a11b4a
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Mar 24 14:13:33 2026 -0700

    Merge pull request #590 from vectorgraphics/correctSpelling
    
    Correct spelling LIBARIES->LIBRARIES.

commit 6eacd30b788a7b984a5cd4f49e64702bbdf0ca4d
Merge: 84dd91a3a e66906587
Author: Charles <charles.staats.iii@gmail.com>
Date:   Tue Mar 24 13:52:30 2026 -0700

    Merge branch 'master' into autounravelWithDatastructures

commit 404a11b4a950b86e52d3e53fa41071cb9a43f225
Author: Charles <charles.staats.iii@gmail.com>
Date:   Tue Mar 24 13:28:56 2026 -0700

    Correct spelling LIBARIES->LIBRARIES.

commit e66906587ed5f7b6ba298856671c4a71a013507e
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Mar 23 20:59:30 2026 -0700

    Optimize integer multiplication.

commit 4bac377ce9511e069605d58c9cced5076bcb6e10
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 22 21:25:38 2026 -0700

    Update black formatter version.

commit 453147fa56e3142e4b0774152da31d9329a6ee5c
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 22 21:22:06 2026 -0700

    Rename requirements.lint.txt.

commit ef762a9bd588ca63f59fac20e79dbca64890d000
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 22 20:58:41 2026 -0700

    Remove obsolete file.

commit 84dd91a3aa06ed68497efadeea5811faaf4e9890
Merge: 163a75144 79ff42e29
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sun Mar 22 20:50:30 2026 -0700

    Merge branch 'master' into autounravelWithDatastructures

commit 79ff42e291eebc0abf08b28fcfb9bcbe1f2408bc
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 22 20:45:16 2026 -0700

    Make make cleaner cleaner.

commit 4e1fda089e5f9ada0f8800bc4501b983bb8530c0
Merge: 5891a2d61 e0455e63d
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 22 15:07:22 2026 -0700

    Merge pull request #573 from jrom99/patch-1.
    
    Add support for XDG base directory spec.

commit 5891a2d613cb230f6b38a79ffd11557c7bc243bb
Merge: 958c09154 7be25f22b
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 22 14:17:48 2026 -0700

    Merge pull request #589 from vectorgraphics/dependabot/npm_and_yarn/webgl/multi-0d13b2d87f
    
    Bump serialize-javascript and terser-webpack-plugin in /webgl

commit 7be25f22bd6efbdb7bf259362d1e9c72cdbd04dc
Author: dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
Date:   Sun Mar 22 21:17:07 2026 +0000

    Bump serialize-javascript and terser-webpack-plugin in /webgl
    
    Removes [serialize-javascript](https://github.com/yahoo/serialize-javascript). It's no longer used after updating ancestor dependency [terser-webpack-plugin](https://github.com/webpack/terser-webpack-plugin). These dependencies need to be updated together.
    
    
    Removes `serialize-javascript`
    
    Updates `terser-webpack-plugin` from 5.3.16 to 5.4.0
    - [Release notes](https://github.com/webpack/terser-webpack-plugin/releases)
    - [Changelog](https://github.com/webpack/terser-webpack-plugin/blob/main/CHANGELOG.md)
    - [Commits](https://github.com/webpack/terser-webpack-plugin/compare/v5.3.16...v5.4.0)
    
    ---
    updated-dependencies:
    - dependency-name: serialize-javascript
      dependency-version:
      dependency-type: indirect
    - dependency-name: terser-webpack-plugin
      dependency-version: 5.4.0
      dependency-type: indirect
    ...
    
    Signed-off-by: dependabot[bot] <support@github.com>

commit 958c0915437bf957ca78f28d1d919663dbfb684a
Merge: 7368ecb6d 6be4b235c
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 22 14:17:05 2026 -0700

    Merge pull request #586 from vectorgraphics/dependabot/npm_and_yarn/webgl/minimatch-3.1.5
    
    Bump minimatch from 3.1.2 to 3.1.5 in /webgl

commit 7368ecb6d605741d6a3ab0d6b99cb956fbeb4587
Merge: 2cfe8fd80 df7b24286
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 22 14:16:06 2026 -0700

    Merge pull request #588 from vectorgraphics/dependabot/npm_and_yarn/webgl/flatted-3.4.2
    
    Bump flatted from 3.3.3 to 3.4.2 in /webgl

commit ae966de688f15d4434b68dc1abcdacd0d96877b8
Merge: 4ae280f97 2cfe8fd80
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 22 13:26:21 2026 -0700

    Merge branch 'master' into vulkan.

commit 4ae280f970733d997c3a2bf497e9acc6b8da0872
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Mar 19 22:34:06 2026 -0700

    Update asygl.

commit 2cfe8fd80f9037909a5f497a636c736246e4c596
Merge: 9e716d331 88fe9c88a
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 22 13:24:41 2026 -0700

    Merge pull request #584 from vectorgraphics/separate-ncurses-ncursesw
    
    Support both ncurses & ncursesw

commit 89ac4048975f94ded336ff5a5dce072c60b3e512
Merge: 9d1199dd9 a111ee55d
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 22 00:03:22 2026 -0700

    Merge branch 'master' into vulkan.

commit 9d1199dd96083546694d145cd2039d6e4e1d0427
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 22 00:02:44 2026 -0700

    Fix camera diagnostic.

commit df7b24286a301b25bdc24fa678b824f088e52a14
Author: dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
Date:   Sat Mar 21 10:28:29 2026 +0000

    Bump flatted from 3.3.3 to 3.4.2 in /webgl
    
    Bumps [flatted](https://github.com/WebReflection/flatted) from 3.3.3 to 3.4.2.
    - [Commits](https://github.com/WebReflection/flatted/compare/v3.3.3...v3.4.2)
    
    ---
    updated-dependencies:
    - dependency-name: flatted
      dependency-version: 3.4.2
      dependency-type: indirect
    ...
    
    Signed-off-by: dependabot[bot] <support@github.com>

commit 9e716d3314a7f9c08b22324646133570312a6fb1
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Mar 19 22:34:06 2026 -0700

    Update asygl.

commit a111ee55d2ca5dab0f679cf96501840a266d1b58
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Mar 19 22:13:37 2026 -0700

    Fix last revision.

commit b56735e460eb41a4486ac8f7a91fd85f7f5e58b3
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Mar 19 21:53:53 2026 -0700

    Fix camera diagnostic.

commit 5fe2479c88b52da055693ee3776eadcf3a867813
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Mar 19 20:17:59 2026 -0700

    Improve make cleaner and cleanest.

commit 27f9fa0867c6c07aaa1bab87a3daf5f0f8df3eb4
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Mar 19 20:11:17 2026 -0700

    Update documentation.

commit 163a7514464381fc48c6788c3a7a4d599279118f
Merge: fd806f71e 4883a57ff
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Mar 19 14:39:18 2026 -0700

    Merge branch 'master' into autounravelWithDatastructures.

commit 9d80e9b25d682a8b9bbdffa77d2ccc3eb13488a4
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Thu Mar 19 14:03:02 2026 -0700

    Revert "Attempt to use MacOS metal argument buffers."
    
    This reverts commit 1c985ecc79c072de430cf14b8568018a86912244.

commit 925ea01d1b8491d884822f3048a6928c1a5b4df1
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Mar 5 23:51:31 2026 -0800

    Fix camera diagnostic.

commit 1c985ecc79c072de430cf14b8568018a86912244
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Mar 2 15:38:26 2026 -0800

    Attempt to use MacOS metal argument buffers.

commit d5a89e4fdbd978b915e0fd76c39e57a308c87c91
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Mar 2 15:37:59 2026 -0800

    Align SSBOs to 16 bytes

commit d1bd6e719bef6794a2232dcd4946901d9019f35b
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 1 15:31:28 2026 -0800

    Fix Lost VkDevice error on MacOS.

commit 6be4b235c09d9e4d92a60be3eb16358a3cd6b02a
Author: dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
Date:   Sat Feb 28 03:02:59 2026 +0000

    Bump minimatch from 3.1.2 to 3.1.5 in /webgl
    
    Bumps [minimatch](https://github.com/isaacs/minimatch) from 3.1.2 to 3.1.5.
    - [Changelog](https://github.com/isaacs/minimatch/blob/main/changelog.md)
    - [Commits](https://github.com/isaacs/minimatch/compare/v3.1.2...v3.1.5)
    
    ---
    updated-dependencies:
    - dependency-name: minimatch
      dependency-version: 3.1.5
      dependency-type: indirect
    ...
    
    Signed-off-by: dependabot[bot] <support@github.com>

commit cfac8e81d84fcd662553bf3b587a642bff54caf0
Merge: d600da8e7 1e03359ec
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Feb 24 23:21:43 2026 -0800

    Merge branch 'master' into vulkan.

commit 4883a57ffb5db6eb0860ee522d202b0ae2fa19e5
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Feb 24 23:01:11 2026 -0800

    Increment version to 3.10.

commit 1e03359ecb3aab5d01ba0ff17463e2b193991b55
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Feb 24 22:40:23 2026 -0800

    Update example.

commit 1f0aa6118400a2447e8b3a0f7759624118f3b946
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Feb 24 22:29:57 2026 -0800

    Remove experimental animate code from glrender.cc.

commit d600da8e7de31692c10cdee597d641995fdb7a5b
Merge: 58d956415 c7179cfd2
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Feb 24 20:59:09 2026 -0800

    Merge branch 'master' into vulkan.

commit c7179cfd236a5e10140844d58e3a60c6c8726048
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Feb 23 23:49:32 2026 -0800

    Increment version to 3.09.

commit 8c26bfcd74762123a23b0367a6e900cbe8995ef8
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Feb 23 23:31:59 2026 -0800

    Fix commit cec6d4be168879c02d2923e4d847d13c8e98da7f.

commit 4bc6319aa86decb948425f92bee7cbfa9e156246
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Feb 23 22:49:46 2026 -0800

    git subrepo pull --force LspCpp
    
    subrepo:
      subdir:   "LspCpp"
      merged:   "a9116e68a"
    upstream:
      origin:   "git@github.com:vectorgraphics/LspCpp"
      branch:   "master"
      commit:   "a9116e68a"
    git-subrepo:
      version:  "0.4.9"
      origin:   "???"
      commit:   "???"

commit cec6d4be168879c02d2923e4d847d13c8e98da7f
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Feb 23 22:12:08 2026 -0800

    Fix make clean, cleaner, and cleanest.

commit 96456db1e63eb391832b7123e5f5ab264fe1a191
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Feb 23 16:56:22 2026 -0800

    Preserve generated GUI files in distributed releases.

commit 0e707ac7f1adea719f140b7fd257c37112719734
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Feb 22 03:10:39 2026 -0800

    Increment version to 3.08.

commit 249148ced4c0f7496af20d337bc29fa8dce3e7ce
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Feb 22 02:45:57 2026 -0800

    git subrepo pull --force LspCpp
    
    subrepo:
      subdir:   "LspCpp"
      merged:   "824417847"
    upstream:
      origin:   "git@github.com:vectorgraphics/LspCpp"
      branch:   "master"
      commit:   "824417847"
    git-subrepo:
      version:  "0.4.9"
      origin:   "https://github.com/ingydotnet/git-subrepo"
      commit:   "b9b059a"

commit f952dc217f68fc3c3f438303bad52b9b8a4e5319
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Feb 22 02:13:56 2026 -0800

    Update asygl.

commit 3e41d45b433da995d942cdf721fa4ed854006e5b
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Feb 22 02:02:34 2026 -0800

    Apply WebGL transforms to all objects other than triangle groups.

commit 8b97971531340858d76dc51ef8a7f202b38f7543
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Feb 22 00:24:10 2026 -0800

    Autoplay WebGL animations based on autoplay setting; fix arrow key/slider race conditions.

commit 127d704b477e4baab2a46432a3083648d84f1e74
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Feb 20 23:36:16 2026 -0800

    Fix busy loop in WebGL animations; remove transform-dependent autoplay option.

commit 1d8b25778d59e165f57e1de87debc9d1587851f3
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Feb 21 16:50:53 2026 -0800

    Update fftw++.cc.

commit e6f9e4b0aff3a6d2a3ed35fac60f5c1de32643c0
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Feb 21 14:11:32 2026 -0800

    Restore missing strnlen workaround from e52e18ff2587258149829ebd544f6d4ef085a8e1.

commit bf4807bb08b4ef78883361666c9b78141cc48014
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Feb 14 18:53:28 2026 -0800

    Clean up deconstruct test files.

commit 51d7a7e4bf1b75368f0e638d47a6edecd2088ce7
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Feb 14 18:27:23 2026 -0800

    Remove unused files.

commit 88fe9c88abaace95f8d975e26594de9c3961062b
Author: Jamie Rassmaeemasmuang <jamievlin@outlook.com>
Date:   Sat Feb 7 22:07:35 2026 -0700

    AC: Support checking for ncursesw/ncurses.h.

commit 9aaf193c1d7e3ed153fd8e034f9b54ad4b5c4a59
Author: Jamie Rassmaeemasmuang <jamievlin@outlook.com>
Date:   Sat Feb 7 22:05:39 2026 -0700

    BUILD: Swtch macro flag to HAVE_NCURSESW_CURSES_H for vcpkg-based builds.

commit 7f1141e2694d785d071024d3569f6ab6a7a455c5
Author: Jamie Rassmaeemasmuang <jamievlin@outlook.com>
Date:   Sat Feb 7 22:05:22 2026 -0700

    CURSES: Support both ncurses and ncursesw.

commit 9ba620574ba162b83de851151a0fd40967e69e6c
Merge: c2eb78d02 66aad2268
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Feb 7 10:07:44 2026 -0700

    Merge pull request #583 from vectorgraphics/dependabot/npm_and_yarn/webgl/webpack-5.105.0
    
    Bump webpack from 5.99.9 to 5.105.0 in /webgl

commit 66aad2268e8633d3bf753d0ed28ead74dcbec5ee
Author: dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
Date:   Sat Feb 7 15:11:17 2026 +0000

    Bump webpack from 5.99.9 to 5.105.0 in /webgl
    
    Bumps [webpack](https://github.com/webpack/webpack) from 5.99.9 to 5.105.0.
    - [Release notes](https://github.com/webpack/webpack/releases)
    - [Changelog](https://github.com/webpack/webpack/blob/main/CHANGELOG.md)
    - [Commits](https://github.com/webpack/webpack/compare/v5.99.9...v5.105.0)
    
    ---
    updated-dependencies:
    - dependency-name: webpack
      dependency-version: 5.105.0
      dependency-type: direct:development
    ...
    
    Signed-off-by: dependabot[bot] <support@github.com>

commit 58d956415b408dc2225cb75bef0d3fc04f7a005c
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Feb 6 22:29:25 2026 -0800

    Update vcpkg baseline.

commit c2eb78d02ff9673cd1ad4f3630f27edb4f9600b3
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Feb 6 21:03:03 2026 -0800

    Reformat runtime.py.

commit 2e33363ca26e1c7743400a8e74bf05e36fc7a0db
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Feb 6 21:03:03 2026 -0800

    Reformat runtime.py.

commit 9f70b2bc51ada0e0bff97a8a305b752754d429dc
Merge: 0f4b217fc f5a907e67
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Feb 6 21:00:08 2026 -0800

    Merge branch 'master' into vulkan.

commit 0f4b217fc28e9b0ca8383cd175102c26d3a64597
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Feb 6 20:59:58 2026 -0800

    Remove comment.

commit f5a907e67ce23a05f09366f9947d9fe2fe45707f
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Feb 6 20:58:06 2026 -0800

    Reformat runtime.py.

commit 6e19a779686f08a3b5aaf5293a29346b83a93142
Merge: 1db30cc50 017c8f660
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Feb 6 18:52:21 2026 -0800

    Merge branch 'master' into vulkan.

commit 017c8f66011da5c70bf5546ab71c2ab50c1f960a
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Feb 6 14:53:46 2026 -0800

    Revert "CURSES: Change ncurses to ncursesw."
    
    This reverts commit 54cd06c45e6a11f2a4e32f19a9d8a3cbdb48d32d.

commit ea6e876b71dccf5c33683aa4a65652a2e80d067a
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Feb 5 17:06:21 2026 -0800

    Backport runtime.py to Python 3.7.4.

commit 5015d46291a76f154cf447157d3fdc2c19a6563a
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Feb 1 23:37:12 2026 -0800

    Increment version to 3.07.

commit 4f6e29f250b6c5f0c8fbea02f4e532507b7ee0db
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Feb 1 23:04:24 2026 -0800

    Remove unused function.

commit c2ef584fded3fda9db0135caf4f947300d7cb9dd
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Feb 1 22:53:10 2026 -0800

    Avoid modifying unitsphere in example.

commit 5b0b942797d310c6d653465a5a7312ab53f81d8a
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Feb 1 22:43:32 2026 -0800

    Update asymptote.spec.

commit 2fec96823775e8ac5903d99b148d571cdbe1cd31
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Feb 1 22:38:26 2026 -0800

    Update asygl.

commit 7bacc8eddf98e2ac8c7ffdda89e4eef174d151e8
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Feb 1 22:35:34 2026 -0800

    Fix AsyGL bounds.

commit 23ad5096d3e60225b55c950a2d510e8ab4e7cb87
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Feb 1 00:40:09 2026 -0800

    Update URL.

commit 9a64769ef0a38861e9da07719ff666f127e3dca5
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Feb 1 00:37:05 2026 -0800

    Fix typo in Makefile.in.

commit 3591155274cd1ce9704af560237fb3f1bdd2cad1
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Feb 1 00:21:47 2026 -0800

    Update build-asymptote.

commit bed25dbb93b3003b32a01452cda0d18636182615
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Feb 1 00:12:34 2026 -0800

    Fix warning messages.

commit e66960bc644599c4852d19531168e46efb1b744a
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jan 31 23:39:42 2026 -0800

    Increment asygl to version 1.03.

commit f369c70093c53153a2634cac759ce2b429b7753a
Merge: f07ae5ac5 7b85f3679
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jan 31 23:32:03 2026 -0800

    Merge branch 'asygl'.

commit 7b85f367939b483cc513332487e273a6e3e742f3
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jan 31 23:31:38 2026 -0800

    Rename delta to t.

commit 1526badc6c9bcf92684a1833f22648a3f4773f9c
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jan 31 23:24:25 2026 -0800

    Revert "Isolate autoplay and control animation for each patch."
    
    This reverts commit c3dd63d59690856d9bc70521beabf602f36030ec.

commit f07ae5ac543c09fcab899f62b36b70f52f76cda4
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jan 31 22:23:56 2026 -0800

    Update asygl.

commit fb4cfd8d60af0ee5f0af932524710879c41b77a2
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jan 31 22:17:13 2026 -0800

    Fix build-asygl.

commit 30060651f14d4217f2b0fde64d42e46e3c5fd080
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jan 31 22:11:51 2026 -0800

    Update npm versions.

commit 1a4b60e603cad959756c7fe2bb0f80fb50ec842d
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Wed Nov 12 22:37:39 2025 -0700

    CMAKE: Use custom fmem branch.
    
    The main fmem branch has minimum cmake support to low for newer cmake, causing build to fail.
    
    (cherry picked from commit 5851789c05bc236b9501f213a7f66100dea09a37)

commit 54cd06c45e6a11f2a4e32f19a9d8a3cbdb48d32d
Author: Jamie Rassmaeemasmuang <jamievlin@outlook.com>
Date:   Thu Jan 1 17:22:06 2026 -0700

    CURSES: Change ncurses to ncursesw.
    
    (cherry picked from commit 9731f1d0f010f37b35f8a974e8de45219b375b7b)

commit a5e7867030ab2d0620e9ffdd9c9576a88e994d67
Merge: 7a1cf162f 1144b0569
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jan 31 21:25:03 2026 -0800

    Merge pull request #582 from vectorgraphics/dependabot/npm_and_yarn/webgl/js-yaml-4.1.1
    
    Bump js-yaml from 4.1.0 to 4.1.1 in webgl.

commit 7a1cf162f7df28974f8bf47ad9f77702bae0cdc4
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jan 31 21:19:37 2026 -0800

    Remove unused examples.

commit 7d61a60823c620a116fd51401ae9b15074becb68
Author: Jamie Rassmaeemasmuang <jamievlin@outlook.com>
Date:   Sat Jan 31 22:19:07 2026 -0700

    Revert "CURSES: Change ncurses to ncursesw."
    
    This reverts commit 9731f1d0f010f37b35f8a974e8de45219b375b7b.

commit 9731f1d0f010f37b35f8a974e8de45219b375b7b
Author: Jamie Rassmaeemasmuang <jamievlin@outlook.com>
Date:   Thu Jan 1 17:22:06 2026 -0700

    CURSES: Change ncurses to ncursesw.

commit 7178a93e3a5e898670ee508fe985fa825ecc126f
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Nov 2 23:32:00 2025 -0700

    CMAKE: Specify additional LSP build options.

commit 056d566cbe69c2d28b073890cf4a9f65f3cd018f
Merge: c3dd63d59 9983084e1
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jan 31 21:13:46 2026 -0800

    Merge branch 'master' into asygl.

commit 1144b0569900b8f1da92d8eca6a24f40769df7e4
Author: dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
Date:   Sun Feb 1 05:12:09 2026 +0000

    Bump js-yaml from 4.1.0 to 4.1.1 in /webgl
    
    Bumps [js-yaml](https://github.com/nodeca/js-yaml) from 4.1.0 to 4.1.1.
    - [Changelog](https://github.com/nodeca/js-yaml/blob/master/CHANGELOG.md)
    - [Commits](https://github.com/nodeca/js-yaml/compare/4.1.0...4.1.1)
    
    ---
    updated-dependencies:
    - dependency-name: js-yaml
      dependency-version: 4.1.1
      dependency-type: indirect
    ...
    
    Signed-off-by: dependabot[bot] <support@github.com>

commit 9983084e15f634b8b48e264a98aa4469d7e870dc
Merge: 08446a52a 3056a6934
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jan 31 21:10:12 2026 -0800

    Merge branch 'webgl-ts-2'.

commit 08446a52a7f986330409c22841c466ac83fb8624
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jan 31 21:02:18 2026 -0800

    Update copyright year.

commit 4a9c9c07038d0095e358c502ad3eb3b457d2e04e
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Nov 2 23:10:51 2025 -0700

    VCPKG: Update dependencies for LspCpp.

commit 37451756fd37611f9b6d6ce1e93d1fc4acfc332a
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jan 31 13:52:49 2026 -0800

    git subrepo pull --force LspCpp
    
    subrepo:
      subdir:   "LspCpp"
      merged:   "492361a66"
    upstream:
      origin:   "git@github.com:vectorgraphics/LspCpp"
      branch:   "master"
      commit:   "492361a66"
    git-subrepo:
      version:  "0.4.9"
      origin:   "https://github.com/ingydotnet/git-subrepo"
      commit:   "b9b059a"

commit 96af06cc192b29c19dc3a4827c444e2c783f6800
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jan 31 13:38:16 2026 -0800

    Remove boost dependency from configure.ac.

commit f63ce1cf9245b02ddc1dd452cca922888ab2d589
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jan 31 09:56:20 2026 -0800

    Re-enable --nomask in MSWindows.

commit 4a93c063c31967a7e5c05cec67fd5fa7a50aef59
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jan 26 07:12:37 2026 -0800

    git subrepo pull --force LspCpp
    
    subrepo:
      subdir:   "LspCpp"
      merged:   "1d84d3b4f"
    upstream:
      origin:   "git@github.com:vectorgraphics/LspCpp"
      branch:   "master"
      commit:   "1d84d3b4f"
    git-subrepo:
      version:  "0.4.9"
      origin:   "https://github.com/ingydotnet/git-subrepo"
      commit:   "b9b059a"

commit 1c5c8d979d4c55b72c583905c74421ba946321c8
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jan 26 07:06:11 2026 -0800

    git subrepo pull --force LspCpp
    
    subrepo:
      subdir:   "LspCpp"
      merged:   "a417fa440"
    upstream:
      origin:   "git@github.com:vectorgraphics/LspCpp"
      branch:   "master"
      commit:   "a417fa440"
    git-subrepo:
      version:  "0.4.9"
      origin:   "https://github.com/ingydotnet/git-subrepo"
      commit:   "b9b059a"

commit e8be783caa285f3599e2bf13b87e0f8f69a6f1c2
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jan 26 06:57:46 2026 -0800

    git subrepo pull --force LspCpp
    
    subrepo:
      subdir:   "LspCpp"
      merged:   "742d90727"
    upstream:
      origin:   "git@github.com:vectorgraphics/LspCpp"
      branch:   "master"
      commit:   "742d90727"
    git-subrepo:
      version:  "0.4.9"
      origin:   "https://github.com/ingydotnet/git-subrepo"
      commit:   "b9b059a"

commit 4b7ea72ee6dabd21671cab22a7d6fa917fd265b9
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jan 25 22:55:21 2026 -0800

    git subrepo pull --force LspCpp
    
    subrepo:
      subdir:   "LspCpp"
      merged:   "e0cb646e5"
    upstream:
      origin:   "git@github.com:vectorgraphics/LspCpp"
      branch:   "master"
      commit:   "e0cb646e5"
    git-subrepo:
      version:  "0.4.9"
      origin:   "https://github.com/ingydotnet/git-subrepo"
      commit:   "b9b059a"

commit 4dfdd80312cebc1d27a0cf15b1b1cd09d0c314a1
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jan 25 21:31:14 2026 -0800

    Remove not-so-tiny tinyexr/examples.

commit 613f176805b7b71913d3912cde8e3fc74bd8a833
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jan 25 21:16:07 2026 -0800

    Ensure revision is nonempty.

commit 44a12f8a600b28b5df46662481be10ac2f3307fb
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jan 24 22:46:00 2026 -0800

    Improve diagnostic if PySide6 is missing.

commit c42c280aa83125124857ab62071dceb38a046816
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jan 11 13:20:19 2026 -0800

    Add explicit GCLIB dependency.

commit 4476811719cf9a468568f58fcd4d266c9209760f
Author: Jamie Rassmaeemasmuang <jamievlin@outlook.com>
Date:   Sun Dec 7 01:48:38 2025 -0700

    VCPKG: Bump vcpkg baseline to commit c49e1c4ed0bbde971759c750e0d5cc915c542db9.

commit 1db30cc5035067abfff63b94cc85aff76b117341
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Nov 21 23:33:16 2025 -0800

    Simplify code.

commit fd806f71eb798501cdd60b937d19e6db5f61db26
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Nov 21 20:25:46 2025 -0800

    Improve wording in documentation of isNullValue.

commit df8198804af7f0eef9f6b2f83c10dfb0d3e63d04
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Nov 21 19:36:54 2025 -0800

    Remove unused code.

commit f2981f06ec0e0279ff2f23d5173ff332c291d304
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Nov 16 15:22:46 2025 -0800

    Fix FXAA validation warnings.

commit df03732eabaa168787ccdcd39eddc98969708843
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Nov 16 00:26:10 2025 -0800

    Fix recreateSwapChain.

commit a315e68b0bd69440473138bff4ea986c1b4a5748
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Nov 14 22:31:57 2025 -0800

    Recreate compute pipelines in recreateSwapChain.

commit 5851789c05bc236b9501f213a7f66100dea09a37
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Wed Nov 12 22:37:39 2025 -0700

    CMAKE: Use custom fmem branch.
    
    The main fmem branch has minimum cmake support to low for newer cmake, causing build to fail.

commit 60da6b27802ac5cfc763f3b68be188c1a47a3bb0
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Nov 6 16:34:05 2025 -0800

    Improve waitForTimelineSemaphore().

commit 27a21cb641b7ca5ac0a5218489098d28a9a4d9ea
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Nov 5 14:12:09 2025 -0800

    Fix last commit.

commit 1c0394a4d6bf74b02603563ee475415f1456514e
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Nov 4 16:51:52 2025 -0800

    In Vulkan 1.4, timeline semaphore and synchronization2 support is guaranteed.

commit 4dcb277c6896be027370abc6932463d53472c829
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Oct 26 05:58:22 2025 -0700

    Fix vma_cxx header file.

commit 2f002763e351129ace2f8593bf0bb0fa1edaae76
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Oct 26 00:32:14 2025 -0700

    Clear count buffer when GPUcompress=true.

commit be4a32f4ae0bde24e1d19b13ad30bbbf86aefb23
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Oct 25 11:41:35 2025 -0700

    Simplify code.

commit e4b4f4f8fda6717cb359ece566eb3fc2b480f5cc
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Oct 24 22:39:58 2025 -0700

    Fix timeout issues when resizing image.

commit 00d9f76447d84ff100f5546c1ee8211232bd15b1
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Oct 9 22:40:56 2025 -0700

    Don't resend transparent data to GPU just because fragment buffer is resized.

commit 883138946923daeeb7dd8722641109cc9c56df07
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Oct 9 22:24:20 2025 -0700

    Simplify code.

commit 43e03f7bfa7500bbcea37cc2094975ac0fcb47af
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Oct 9 00:16:18 2025 -0700

    Defer transparent buffer creation.

commit 8621dfabe235fd3e78c5bba7d05c523720776a07
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Oct 8 19:42:10 2025 -0700

    Revert deferred transparency buffer creation.

commit e2bf4a7e743a65ff6ec861c8d72bf57b3583cf6b
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Sep 27 23:44:36 2025 -0700

    Partially revert 62dd780a73aee913cc76c7639e6f940bcf593f6f since gl_FragCoord.y can equal the height on some GPUs.

commit e0455e63d9d439a905bfdc591e707489a0a93b39
Author: jrom99 <47498278+jrom99@users.noreply.github.com>
Date:   Sat Sep 27 16:19:26 2025 -0300

    Add support for XDG base directory spec
    
    Currently, after opening the program, a directory named `.asy` is created in the home directory, hosting configuration and state files.
    
    This request adds support for the XDG base directory spec <https://wiki.archlinux.org/title/XDG_Base_Directory>, which is a cross-platform specification that de-clutters the home directory and simplify backup management.
    
    So, now instead of creating the `~/.asy` folder, the code checks if it exist and then uses it, fallbacking to the appropriate XDG directory.
    
    I took the liberty to simplify the code logic a bit, since there was also a possible bug in the code below, where the default options and current options were the same object, so the program wasn't actually reloading the settings when `setDefaults` was run.
    
    https://github.com/vectorgraphics/asymptote/blob/205a13c2bfdd5f6d0e61157e09d02f1506ed2cb4/GUI/xasyOptions.py#L22-L30

commit 08b4ad10820f9fd2e21aaaf910e26ebdc0057428
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Sep 25 00:31:15 2025 -0700

    Add out-of-memory checks.

commit 205a13c2bfdd5f6d0e61157e09d02f1506ed2cb4
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Sep 15 18:53:41 2025 -0700

    Update URL in comment.

commit c677cd7e07b5f2917c311a8920fdb41579bbe37b
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Sep 15 10:26:46 2025 -0700

    Add missing data file for linearregression example (issue #571).

commit ac5c8857bac28ce617baeb953b3287af90b4e4ff
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Sep 15 10:25:23 2025 -0700

    Update URL in comment to address issue #570.

commit 234108b25805a105d78080140617e49186e2c09e
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Sep 14 11:30:44 2025 -0700

    Simplify code.

commit 01db2a10617001d2bf2ae7196a525271ffe34180
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Sep 13 23:57:59 2025 -0700

    Fix segmentation fault.

commit 7cd6a9437d1cdb4ca954e397d6d4e29e91bb7dae
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Sep 13 22:59:20 2025 -0700

    Fix FXAA validation warnings.

commit 977c67cb58e45d4b26368e06b2ec4c3974c12e12
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Sep 13 19:58:50 2025 -0700

    Fix shader validation warnings.

commit b7b9c763c87e456c758ec260a2720e2880b2f1e8
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Sep 13 08:30:33 2025 -0700

    Fix validation warning.

commit cc4be2897f01b6a6cf04149d0b803bfb97de190c
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Sep 13 00:27:17 2025 -0700

    Add support for vkQueueSubmit2.

commit 10fbed8130ff4df74b0c81a39cda79722440632c
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Sep 12 22:42:28 2025 -0700

    Batch descriptor writes.

commit 24f1823611e41944a582e7cc5ff3bc926d12dedf
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Sep 12 21:05:30 2025 -0700

    Conditionally rewrite descriptors in recreateSwapChain().

commit 1edde5a414e2bc4bc62c4aeaf5acbcd13b1f47d0
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Sep 12 20:18:35 2025 -0700

    Update refreshBuffers to use timeline semaphores.

commit 677d54e47ba93eba9a936cda4c03802a145096e3
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Sep 12 20:12:51 2025 -0700

    Optimize CPU-GPU Synchronization in preDrawBuffers.

commit 559e6b8db6fbfa6f25a3f60490c19c695723eb7a
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Sep 12 19:49:26 2025 -0700

    Fix validation warning.

commit c25af92c6bddde0bcd6ab5ec7ef4de247473e387
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Sep 12 19:35:36 2025 -0700

    Use a static memory mapper for the feedback buffer; read both values at once.
    
    Add a proper memory barrier to the partialSums function to ensure that all compute shader writes are visible to the host before signaling the event.

commit 6199a08c9b5717aafcbf50f78dcc03eb7136d5a7
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Sep 12 16:17:44 2025 -0700

    Remove redundant clearing of count buffer.

commit f43ff586f9a53165b25aac7a6bf115e4d34a1eed
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Aug 31 12:34:03 2025 -0600

    VK: Fix validation error retention.

commit 8968666f8a85271e482d7e94e08ce000fee1d3fa
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Sep 11 22:57:41 2025 -0700

    Reduce the number of pipelines; simplify pipeline creation.

commit a71ae461575b7c6cf004dd3070c8546bb74291c5
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Sep 11 09:08:39 2025 -0700

    Fix validation errors.

commit 62fd786dac740c626bb6deeada9909c482ffb099
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Sep 11 00:39:24 2025 -0700

    Fix subpass dependencies.

commit 3c498af006e19825263c9a0466f73115dae658bc
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Sep 10 22:15:17 2025 -0700

    Improve synchronization.

commit a91909f0ba657c14714228410f472fb5597a30fd
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Sep 10 21:10:18 2025 -0700

    Revert "Fix validation issues."
    
    This reverts commit d1a6795539baf6fec2446a5054b9a40bc11f74cd.

commit 999652dd6ce76d4ca20a57e957933f5a7aa4f873
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Sep 10 11:08:37 2025 -0700

    Revert "Fix race condition."
    
    This reverts commit dae5adddd61ddc124a61c4f1800f6651710cd910.

commit f47d24f782f9e54426fb55eaa13b69b6d5e4d4b2
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Sep 10 00:09:57 2025 -0700

    Remove diagnostic.

commit 11788b0b16f3d2874c1570f02ca15c685e322b02
Merge: 4e6541f9e fd7012a73
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Sep 10 00:08:55 2025 -0700

    Merge branch 'vulkanCheck' into vulkan.

commit fd7012a73e5b60284436f2690213237a183716c3
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Sep 10 00:00:22 2025 -0700

    Reset timeline semaphore values to avoid timeout issues.

commit 0fe7395eaafc973d0b846264a353d95f90d4bb99
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Sep 9 23:33:36 2025 -0700

    Fix export synchronization.

commit d08ddd732276616b129e25a23059ff0e0596eb61
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Sep 9 23:17:23 2025 -0700

    Disable XMODIFIERS.

commit 2035927384d15845e7cddca5d02c77312ec685e9
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Sep 9 23:11:20 2025 -0700

    Fix validation errors.

commit 5b6b90250f2f23f56f99a30b8b6db8035079251b
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Sep 9 21:20:52 2025 -0700

    Fix validation error under MacOS.

commit dae5adddd61ddc124a61c4f1800f6651710cd910
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Sep 9 19:54:08 2025 -0700

    Fix race condition.

commit 4e6541f9e735496baf6f4c09ab2c2ba80dd39f77
Merge: e47f80c1d db96bc821
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Sep 8 13:21:10 2025 -0700

    Merge branch 'vulkanCheck' into vulkan.

commit db96bc82198f7f24eeb57aa01a0d6e5375ac53a8
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Sep 8 13:16:48 2025 -0700

    Fix validation error.

commit cddcf93bad0d26338268ffdd000832a77d937d8b
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Sep 8 13:03:58 2025 -0700

    Fix last revision.

commit e47f80c1d1b1dff0bae266dc2b058beb07394abe
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Sep 7 23:21:38 2025 -0700

    Use a consistent fence-based approach in the transparency pre-pass.
    
    Add timeline semaphores for better synchronization.

commit 1dba0d6d8ee6711550ac79dd3c0dfe75f0674274
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Sep 7 23:21:38 2025 -0700

    Use a consistent fence-based approach in the transparency pre-pass.
    
    Add timeline semaphores for better synchronization.

commit 452925c2c02324e6a5f563141c5bafe22aac34c9
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Sep 7 11:36:15 2025 -0700

    Fix compress workflow.

commit a9dc798928f8a5d1cd3867588f102471ee6e1438
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Sep 7 11:26:39 2025 -0700

    Use switch statement for renderPass selection.

commit f1e2a56daaf480091a6798188b23d73600c3c84f
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Sep 7 00:14:14 2025 -0700

    Don't wait for event after recreating swapchain.

commit 6808c5da913c1940ae0af646bc1863cd1dd789ea
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Sep 7 00:13:37 2025 -0700

    Fix quit when not multithreading.

commit 5ba17fe313d2cbc5a121a74e60eebb49c5ea70de
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Sep 6 23:29:21 2025 -0700

    Remove unused depth stencil from countRenderPass.

commit 02a38b2d056f4c0db961f3d40d9b3b32b189d695
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Sep 6 22:48:08 2025 -0700

    Under MacOS, prefer low power mode for better stability.

commit 64bee49ffa280a4567e55cb93e48ab84c0e9a7bd
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Sep 6 22:38:29 2025 -0700

    Add focus callback; reduce timeouts to 1s.

commit 06b70f63ec8b19d276d2c49e8ad433f70a578a5d
Merge: 99c916da8 914781b6d
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Aug 31 15:00:26 2025 -0700

    Merge branch 'vulkan' into vulkanCheck.

commit 914781b6df31cd34f6668955113a22420c31f791
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Aug 31 14:49:06 2025 -0700

    Remove unused uint.

commit 99c916da8868404f577617801d73f7350b12221f
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Aug 31 11:27:25 2025 -0700

    Fix merge.

commit 520f0bb34d771091c4fbf1a3f0b1946a6a39f04b
Merge: 55e3d6f86 be12d9705
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Aug 31 10:49:06 2025 -0700

    Merge branch 'vulkan' into vulkanCheck.

commit be12d97056dee73164e9f54bed3e6d36707053db
Merge: 0e62c0309 f75c5b63c
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Aug 31 11:32:52 2025 -0600

    Merge branch 'master' into vulkan

commit f75c5b63cf03b30abdaa81daca41e70d1125a9c6
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Aug 31 11:30:46 2025 -0600

    REPO: Add node_modules and dist to repo ignore list.

commit 0e62c03093a36d971688026d9aecaeac265ff665
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Aug 30 22:07:06 2025 -0700

    Work around pointless assert under WIN32.

commit 55e3d6f861476d2cfe567002e7c086a89f2de5fa
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Aug 30 19:07:09 2025 -0700

    Add debugging barrier.

commit c596df606bee80faf6629808aff37b1ac87b7d73
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Aug 30 18:57:59 2025 -0700

    Fix zoom.

commit c491ea78c1955b2396806b901b7f47d749a32f6a
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Aug 30 18:57:59 2025 -0700

    Fix zoom.

commit c3dd63d59690856d9bc70521beabf602f36030ec
Author: Quan Hoang Nguyen <quanhoang@Quans-MacBook-Pro.local>
Date:   Sat Aug 30 18:09:02 2025 +0900

    Isolate autoplay and control animation for each patch.

commit 25d3b74679ef46e151c5a9ecf2274154a633f6e1
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Aug 30 14:48:44 2025 -0700

    Fix FXAA validation error.

commit d1a6795539baf6fec2446a5054b9a40bc11f74cd
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Aug 30 01:28:15 2025 -0700

    Fix validation issues.

commit cbf717f804b5a41f7b1046d11f43baf0951fa744
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 29 23:58:02 2025 -0700

    Fix validation error.

commit da6242b43327cbfdf5a4e7c14af0fba9f71a90a9
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 29 22:56:26 2025 -0700

    Force copying transparent data to GPU on fragment buffer resize.

commit 5b838ca4061483292103e8949ad8aee33fe630e9
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 29 10:33:59 2025 -0700

    Defer transparency buffer creation until preDrawBuffers.

commit aade5d76982c1c6bf2162857e33632a3509a709e
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 29 10:33:59 2025 -0700

    Defer transparency buffer creation until preDrawBuffers.

commit 411fbeb2c07d157ea59b9de7ce47cb8e85ef3e99
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 29 09:47:53 2025 -0700

    Revert "Add sanity check."
    
    This reverts commit b91b37fbc226477c0e65446a3d3b4eb3f1ac9a6f.

commit b91b37fbc226477c0e65446a3d3b4eb3f1ac9a6f
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Aug 28 20:02:10 2025 -0700

    Add sanity check.

commit ec0be9623740d5fa1cad179607894064e0d64651
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Aug 28 19:46:24 2025 -0700

    Fix last revision.

commit c671b2577035d21d9340eaa5853bc5cdc3da4826
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Aug 28 19:39:00 2025 -0700

    Add diagnostics.

commit 0dd6cc2d41adad7cb990586898b603e6cd451314
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Aug 28 18:50:12 2025 -0700

    Standardize push constants.

commit b64c2b642f160c760a3241fdaeb0da9151f7ab05
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Aug 28 16:52:55 2025 -0700

    Simplify code.

commit b5e67c42b43db08d186509d6b0d66a97d46f7301
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Aug 28 15:00:39 2025 -0700

    Improve partial sum timing.

commit 9b9d72abad943d96be949fddfe59e6f23224b47c
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Aug 28 12:30:25 2025 -0700

    Use same pipelineLayout for all 3 compute sum pipelines.

commit 62dd780a73aee913cc76c7639e6f940bcf593f6f
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Aug 27 23:44:42 2025 -0700

    Minimize transparency buffer allocation.

commit f8368fb49d1f4bff556ba0535c9f691e4cdebcbe
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Aug 25 23:41:38 2025 -0700

    Fix mismatched FXAA image format.

commit e13808cccaa609507e57494b0073c4489fcb34a5
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Aug 25 20:46:54 2025 -0700

    Move VALIDATION preprocessor macro to vkrender.cc.

commit a4f8b91ac1b66fc5d643d7bc6f3520f52d7352eb
Merge: 28df39e1f bdccf9446
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Aug 25 10:53:24 2025 -0700

    Merge pull request #561 from luzpaz/typo
    
    Fix various typos.

commit bdccf9446747205fba090bf4d2c593d855906505
Author: luzpaz <luzpaz@users.noreply.github.com>
Date:   Mon Aug 25 10:17:47 2025 -0400

    Fix various typos
    Found via `codespell -q 3 -L alo,atleast,clen,siz,sord,te,uptodate`

commit 450b4db437d70d729ac85dfe51885d710ba12931
Author: Quan Hoang Nguyen <quanhoang@Quans-MacBook-Pro.local>
Date:   Sun Aug 24 12:34:28 2025 +0700

    Add 'b' key event: on/off slider bar

commit f8ec145cc789a1e2fe046523e280c5f00f7c5da7
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Aug 21 21:55:55 2025 -0700

    Move export before presenting.

commit 4c22ed6d60d573a291ad02787a74b4361a46c729
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Aug 21 20:22:41 2025 -0700

    Fix offscreen flag.

commit 9749bce77675fe29531443ceaf4765478d6ce5ec
Author: Quan Hoang Nguyen <quanhoang@Quans-MacBook-Pro.local>
Date:   Fri Aug 22 00:17:03 2025 +0700

    Fix animate condition for slider

commit 2a0a33945d961cad8cbc72144fa71a7a9afce63e
Author: Quan Hoang Nguyen <quanhoang@Quans-MacBook-Pro.local>
Date:   Thu Aug 21 22:05:18 2025 +0700

    Implement slider

commit 5c798174fc1cd5cca5e63c5e17974f5f03a8cc13
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Aug 20 15:58:39 2025 -0700

    Add missing file.

commit 4a03e39f9a9cca5f1dca21e91c20c78b5baf2339
Merge: c42574902 28df39e1f
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Aug 19 09:47:12 2025 -0700

    Merge branch 'master' into asygl.

commit 28df39e1f5f0f7f6a344986f8e0396d01d935670
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Fri May 30 20:24:17 2025 -0700

    Add enable-large-config to GCOPTIONS to fix "too many root sets" error on some(?) macs.

commit c425749029d742e77a321bb7a326f5279d734e93
Merge: e03385007 dcf8dcf85
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Aug 19 09:38:40 2025 -0700

    Merge branch 'master' into asygl.

commit 15710d0fd5b015401370393817639a98802e87cb
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Aug 18 21:56:35 2025 -0700

    Standardize reshape0.

commit 58c1748cf10e9f4a034ccc2a55646c26c2cc9d8a
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Aug 18 16:52:22 2025 -0700

    Suppress undisposed key event warning.

commit afb9ee65689c9b3d1b431cb7db882c0583ad45dd
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Aug 18 16:18:24 2025 -0700

    Fix export dimensions.

commit 017eb4595a4227ea481a9fe2936f1c8ffbd0ffa7
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Aug 18 16:04:20 2025 -0700

    Fix mode.

commit f6f84bf08c8f1f613f82b0eb92320ce0408561b6
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Aug 18 13:59:04 2025 -0700

    Fix interactive rendering.

commit 542cf6b527222091310b2d4c552db756691a8a5f
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Aug 18 13:24:17 2025 -0700

    Fix exporting.

commit f5b7b26d507aec6bd124541923f08ab87ca70eb6
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Aug 18 13:12:25 2025 -0700

    Fix export.

commit da63a7e5d648e38a638f415f283976268588149d
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Aug 18 12:02:19 2025 -0700

    Fix home key.

commit 5568ef2020dacf758be21cc6dd43d5c12bb0b8a0
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Aug 18 00:48:03 2025 -0700

    Fix validation errors when viewing.

commit c9966f47ae617b015007eb6d738d0f38fe0ee954
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Aug 17 23:20:47 2025 -0700

    Optimize opaque scenes.

commit 90a60ede1aa8b09d4eeb4f7a6ae0b4b5f783e0d8
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Aug 17 20:05:25 2025 -0700

    Fix software rendering flag.

commit e6a5bce25f58a39096b1044644253d1841ee183c
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Aug 17 17:41:26 2025 -0700

    Fix last revision.

commit ad91dc221f7a25f1bbd405a229a36dc4cf377ca3
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Aug 17 16:50:31 2025 -0700

    Fix dependent buffer creation.

commit 9a75e26ee60fe32ee3e7a514bc272094fc0e940b
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Aug 17 13:35:53 2025 -0700

    Fix multithreaded offscreen hang.

commit fb457e37516c2c980393c633201830ae06d5d388
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Aug 17 09:53:05 2025 -0700

    Port missing code.

commit 1a640483ba83c10d6da8090a2cb0d30ad2c19453
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Aug 16 23:11:43 2025 -0700

    Fix last revision.

commit 6a352e640444a1a95cf06741ee87fc105b83cfdf
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Aug 16 22:51:08 2025 -0700

    Clear buffers on update.

commit a25394e3ddd4a340d4cab07f3cad7e9fabc1fbf4
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat Aug 16 16:21:41 2025 -0700

    Make Set_T and SortedSet_T importable from btree.asy for user convenience.

commit d367413146e11e12c36c780633f229ad29a8dfb8
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Aug 16 15:08:18 2025 -0700

    Avoid redundant rendering; fix window issues.

commit 6401d62a07723366cb20f1271fa79245072e4558
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 15 23:12:38 2025 -0700

    Fix vertical pan direction for perspective projections.

commit 2ab5335dc0a0ec6eb8febd9762fb8ed5a6721acc
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 15 23:09:12 2025 -0700

    Set origin at lower-left corner with y coordinate increasing up.

commit 1210add5cae30fd76beeacceee02fc9da5906572
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 15 20:35:10 2025 -0700

    Fix window visibility.

commit 4f58f617c50947d94fc8df8127aa529391e917f5
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 15 20:03:03 2025 -0700

    Optimize buffer usage for opaque scenes.

commit 9049309cb01b4be1118c5c5a98e9bde9caf96763
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 15 16:39:06 2025 -0700

    Return immediately from drawFrame() upon recreating swapchain.

commit e0338500754c506ce8d6073b4f0aaa0eaa9b661b
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 15 15:52:33 2025 -0700

    Fix nested color transformations.

commit 594c51ee943937a0a998f530b3a819e3ebbf6203
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 15 13:33:26 2025 -0700

    Use a single startTime.

commit 02bcf9d21a8a9ca4d4ee431e8760ed7250c57c62
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Aug 14 20:05:14 2025 -0700

    Fix home.

commit fbe13b634acef1ba45e517428645d3197be25013
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Aug 14 15:24:58 2025 -0700

    Fix resizing.

commit f2d7ab02de43444838fd75335e47a00075febb32
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Aug 14 10:03:05 2025 -0700

    Fix onscreen rendering under MacOS.

commit b5f7f0593ba59db9ea1d5442707e2cbf6133e3da
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Aug 14 01:42:01 2025 -0700

    Pass width and height to chooseExtent().

commit 772d6c2fa7897737c71059756a600131a3c2acc8
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Aug 14 01:11:24 2025 -0700

    Suppress dvisvgm warnings in deconstruct test.

commit cd565127f2e66859b5097dea3c973fc62aef9d21
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Aug 13 21:52:57 2025 -0700

    Reformat file.

commit 58ef603fbdcae45a2be0985900f7cba006f01552
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Aug 13 21:47:10 2025 -0700

    Reformat file.

commit 74d5c58204288c33107ec77c6e1e47988c322219
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Aug 12 21:51:28 2025 -0700

    git subrepo pull (merge) --force LspCpp
    
    subrepo:
      subdir:   "LspCpp"
      merged:   "8d172bd36"
    upstream:
      origin:   "git@github.com:vectorgraphics/LspCpp"
      branch:   "master"
      commit:   "8d172bd36"
    git-subrepo:
      version:  "0.4.9"
      origin:   "???"
      commit:   "???"

commit dcf8dcf85b81a7bdd759eaf516b721f722d6e6a7
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Aug 14 01:11:24 2025 -0700

    Suppress dvisvgm warnings in deconstruct test.

commit 3bb966909903bf109f776448736fa5ba407afb39
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Aug 13 22:55:10 2025 -0700

    Improve diagnostics.

commit 0a921360b63d2989b8f61dbf25d1bd7ad9ff1435
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Aug 13 22:31:35 2025 -0700

    Fix offscreen rendering.

commit 42b0892cbf8cc0408a99dbad9a3a3307bb76245a
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Aug 13 21:52:57 2025 -0700

    Reformat file.

commit 6657a147b85fb4b4dd06ee0ae81b79325f7e4aed
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Aug 13 21:47:10 2025 -0700

    Reformat file.

commit f0e5511981c2c49c47ea5ce2e110468a961ade4c
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Aug 13 21:52:57 2025 -0700

    Reformat file.

commit f9c4442f0c5a89e3411e58a0096f4b98dbd99edb
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Aug 13 21:47:10 2025 -0700

    Reformat file.

commit ba7fdd6eea01e967cee84733ffd421d2b36cc971
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Aug 13 20:27:22 2025 -0700

    Improve diagnostic.

commit f3fab7d7d05177b3debac97ef0478c59b9659da9
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Aug 13 20:02:51 2025 -0700

    Add settings.device option for selecting desired Vulkan device.

commit 54a9a259ee0f0d1e659bcb45230ffb4c4f0930b7
Merge: c031dee39 3fcec975f
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Aug 13 18:55:47 2025 -0700

    Merge branch 'master' into vulkan.

commit 3ab8e8f9e5241a20f54c86aff9efe19c75dea818
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Aug 12 21:51:28 2025 -0700

    git subrepo pull (merge) --force LspCpp
    
    subrepo:
      subdir:   "LspCpp"
      merged:   "8d172bd36"
    upstream:
      origin:   "git@github.com:vectorgraphics/LspCpp"
      branch:   "master"
      commit:   "8d172bd36"
    git-subrepo:
      version:  "0.4.9"
      origin:   "???"
      commit:   "???"

commit 23bb79b5c830af73fe0932e69c44b61ea40a23d2
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Aug 12 10:38:04 2025 -0700

    Cache color.

commit 334cfe59e5b171a7e5b72fa29fc52d18533692a7
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Aug 12 10:11:04 2025 -0700

    Simplify code.

commit deffe243cb086e4197398a78746a8dd90b9d7d94
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Aug 12 09:47:15 2025 -0700

    Rename exactBounds to haveBounds.

commit 3fcec975f109fe7958cf60e4572f717ae5bbb96d
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Aug 11 23:13:22 2025 -0700

    Add permission fields to global function and variable list diagnostic; omit private fields from asy-keywords.el.

commit 429a5960acb76d30cfe17c19798c2a2671e466aa
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Aug 11 16:33:20 2025 -0700

    Improve variable list diagnostic.

commit 87dba9464a034daa4f19e4d4989a28f6234835a5
Author: Nguyen Hoang Quan <quanhoangnguyen2306@gmail.com>
Date:   Sun Aug 10 18:25:25 2025 +0700

    Isolate static and autoplay animation. Change now() calling to drawScene().

commit d7ff9fd57c0b056c052930d20f37dadb51a01177
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat Aug 9 17:45:02 2025 -0700

    Install collections library with base directory.

commit cd62341ac011cbb2c667c082070e0f78b5d0ffcb
Author: Nguyen Hoang Quan <quanhoangnguyen2306@gmail.com>
Date:   Sun Aug 10 01:35:52 2025 +0700

    Resolve conflict in gl.ts

commit 030bf047d57c7afb575b328ff837324656a9f674
Author: Nguyen Hoang Quan <quanhoangnguyen2306@gmail.com>
Date:   Sun Aug 10 01:24:09 2025 +0700

    Fix arrowkey animation control
    
    t

commit 8c5a003e7d25a04e988051b30c96d714a81061dd
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 8 23:32:30 2025 -0700

    Fix nonanimated webgl output.

commit c0464ffb821c22f779e08ce4db5dfa23ca238aeb
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 8 23:16:49 2025 -0700

    Fix user transform.

commit 66db5a36a6a159eade731968e5161cc13af86d36
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 8 22:47:34 2025 -0700

    Revert "Fix asygl transform."
    
    This reverts commit 4eb99d2f21f627ff61af8b02859aeaa9ba243cb5.

commit 4eb99d2f21f627ff61af8b02859aeaa9ba243cb5
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 8 22:37:04 2025 -0700

    Fix asygl transform.

commit a4f1d46d7fbc7e1f52efc45c927789dd10863df3
Author: Nguyen Hoang Quan <quanhoangnguyen2306@gmail.com>
Date:   Fri Aug 8 23:02:15 2025 +0700

    Implement left/right arrow key animation

commit 070445923dc7803f19648f3c3f01f0439734d8e6
Author: Nguyen Hoang Quan <quanhoangnguyen2306@gmail.com>
Date:   Fri Aug 8 15:49:08 2025 +0700

    Fix requestAnimationFrame condition on duration, fix color transform

commit e42c72215db89ec1208645a4f5c0b2e7eb36f1e6
Author: Nguyen Hoang Quan <quanhoangnguyen2306@gmail.com>
Date:   Fri Aug 8 13:09:34 2025 +0700

    Implementing abstract type for Transformation

commit 8d170e0756d9d1c62494da3835baf83dd4dc282f
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Aug 7 01:33:18 2025 -0700

    Implement color animations.

commit 26ddd1cb6eb10c058cf9fdb5daa321082520d9fc
Merge: 0c3fed3a9 8a8dfaa7b
Author: Charles <charles.staats.iii@gmail.com>
Date:   Wed Aug 6 18:40:33 2025 -0700

    Merge branch 'master' into autounravelWithDatastructures

commit dcd3949e748231e1c68a1a2497481fa000de422d
Merge: 752f6b233 3056a6934
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Aug 6 04:30:44 2025 -0700

    Merge branch 'webgl-ts-2' into asygl.

commit 3056a69348128d4380831e90e2ef937d77d0b38a
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Aug 6 04:30:04 2025 -0700

    Fix comments.

commit 752f6b233a93b18ee7fc43dd60676fddae8a8225
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Aug 5 21:11:11 2025 -0700

    Add duration parameter to beginTransform.

commit 0ef3b6d118fe432ce014b4860de0c8a67a4aa65f
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Aug 5 20:53:53 2025 -0700

    Implement dedicated beginTransform/endTransform pair.

commit 333428bc9c60d675212ab32e0b8592187846848b
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Aug 4 23:16:29 2025 -0700

    Specify animation transform in user coordinates.

commit 47aeccd9829797703ae6010b1c5cf988ea36ee34
Merge: a1e17ab1a 8a8dfaa7b
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Aug 4 11:38:26 2025 -0700

    Merge branch 'master' into asygl.

commit 8a8dfaa7bbaec9c983f429dffb986983c4a0767e
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Aug 4 11:34:38 2025 -0700

    Add optional pen arguments py and pz to axes3().

commit c031dee391abe99bd9ccd0fc7c34942943caf995
Merge: 32a1e7411 5968bdfb3
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 1 23:09:36 2025 -0700

    Merge branch 'vulkan' into render.

commit 5968bdfb3824806e793682f6257c1f61fff174eb
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 1 23:02:03 2025 -0700

    Add include.

commit 4afe89b6f93d574241437138fc93a1d52174dae1
Merge: fad2c82f5 efb09864f
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 1 20:15:52 2025 -0700

    Merge branch 'master' into vulkan.

commit efb09864fd6201a1f88ed9299ae8b4cd540c5e06
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 1 20:10:45 2025 -0700

    Implement zoomThreshold.

commit 32a1e74114651038c05372a24e06c987d8228c3f
Merge: b53e1965b fad2c82f5
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 1 15:47:14 2025 -0700

    Merge branch 'vulkan' into render.

commit fad2c82f502156d02d9f17cb3344365b4ae5e70e
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Aug 1 15:46:05 2025 -0700

    Implement zoomThreshold.

commit a1e17ab1a2f65a31f57472c41c84b752295d81a4
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jul 31 23:09:25 2025 -0700

    Skip null transforms.

commit 2d861bf009f03f7dd6433a5e8eda6f7801f6c0bb
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jul 31 23:02:13 2025 -0700

    Implement AsyGL begingroup and endgroup functions.

commit 2f5b05e349d7442d9022ee20b7928a69ba35e227
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Jul 30 23:52:35 2025 -0700

    Fix last revision.

commit 176386fe787c223c4c8232288549817055c815e4
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Jul 30 23:50:58 2025 -0700

    Add jsTransform argument to begingroup3.

commit b53e1965bcf4cc3cd81cb2132fd43c110af9f26d
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 29 12:08:44 2025 -0700

    Remove unused variable.

commit b7343c835a54a4652feed5dc49a5fc903e9fadec
Merge: 1b6cfe054 7cf9a4d46
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 29 09:30:22 2025 -0700

    Merge branch 'render' into vulkan.

commit 1b6cfe05455d8901fa97f9f8df4503efb85cb9e9
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jul 27 23:13:06 2025 -0700

    Untangle rendering and vulkan code.

commit 15b88e7a03b8e2f2d66a424af1d9f0126b1ef0b5
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 29 09:29:39 2025 -0700

    Remove rendundant render call.

commit 7cf9a4d460ebfce4090c4f10ac3577d3f7f78c75
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jul 27 23:13:06 2025 -0700

    Untangle rendering and vulkan code.

commit 79f0f1b913199d04b774ee55cf38f3b6520ffe15
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jul 27 20:05:39 2025 -0700

    Add demoTransform.js example that uses glMatrix functions.

commit 52f11084596005e7e5caaa8c0b35e972032d684d
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jul 27 16:24:03 2025 -0600

    JS: Include glmat.ts to entry files.

commit 1ed991f733d4e93c85fc7d86864fa8c4396d1442
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jul 27 16:23:53 2025 -0600

    ASYGL: Add gl-mat module exports.

commit af71500bd8d33524397b9ff3ebb2381b34f92af3
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Jul 23 20:30:38 2025 -0700

    Fix flickering and refreshing under MacOS.

commit 7e0dd04b3fd9e023abc0daaea1521e5f3aaaa8d7
Merge: 56cd5b685 a023c0ee5
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 22 11:55:24 2025 -0700

    Merge branch 'render' into vulkan.

commit a023c0ee57314ca1eda5dbe9a2ba13fe9f4ea3a5
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 22 11:52:59 2025 -0700

    Add external render test.

commit 56cd5b68564c374ec7e145a01acc01845ee283a8
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 22 00:32:32 2025 -0700

    Avoid multiple calls to render.

commit 32beced9378fbae7cf22658704bfc20da0b58056
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jul 20 23:34:13 2025 -0700

    Add demonstration of nonlinear transform.

commit bb5282528c514f5c2ea546dc60e7c39f78009ae5
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jul 20 21:13:53 2025 -0700

    Generalize transformation.

commit 93bcc3236eaed60500da6256961ca8df20881f15
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jul 20 20:20:00 2025 -0700

    Remove trailing whitespace.

commit dd1f3cf69090865e70f5b1f6ba2ea15cc15272dd
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jul 20 17:00:06 2025 -0700

    Simplify mainLoop.

commit 47f49d0f67b4c23d33e689bb517407fa158181ed
Author: Nguyen Hoang Quan <quanhoangnguyen2306@gmail.com>
Date:   Sun Jul 20 16:44:19 2025 +0700

    Demo changes for gl.ts

commit 0c3fed3a968d74c22dbc012a7221ac1ab7daa1b6
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Jul 18 16:38:10 2025 -0700

    Delete unused function.

commit 5de5dfa0b27c8dce21e0eb8fa0d95076885ba916
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Jul 18 15:55:40 2025 -0700

    Delete obselete comment.

commit 7d437e20d2531620f8b49cb4e49227914e485616
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Jul 18 15:53:35 2025 -0700

    Delete obselete comments.

commit 703879dcadfdae4c8ba338128e511c34bebef31e
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jul 17 12:53:21 2025 -0700

    Move controlpoint dependencies into Geomery class.

commit ed87ae410e23127dab452b4fcfd1816566b63f9e
Merge: 0d9a311e5 d8338ea9a
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Jul 16 15:18:24 2025 -0700

    Merge pull request #556 from vectorgraphics/cmake-base-files-autoglob
    
    CMAKE: Use globbing to get asy and glsl files.

commit d8338ea9a56fd45d10185f929005cc26cc495a0d
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Wed Jul 16 01:40:12 2025 -0600

    CMAKE: Use globbing to get asy and glsl files.

commit 16830434493bfda1e3380e5937a772d18cd07714
Merge: 2bef21d0c 00059b893
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 15 10:24:02 2025 -0700

    Merge branch 'vulkan' into render.

commit 00059b893289b05e8827e2276e4c7155fffa5e5a
Merge: 012440d27 0d9a311e5
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 15 10:23:15 2025 -0700

    Merge branch 'master' into vulkan.

commit 2bef21d0c78aabb2aff759999505d64cf661bbe5
Merge: c5a92d90f 012440d27
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 15 10:16:36 2025 -0700

    Merge branch 'vulkan' into render.

commit d04f588365864a98813efac80b14494ca42654d5
Merge: 3884e1556 fb60b2b4b
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 15 09:36:27 2025 -0700

    Merge branch 'webgl-ts-2' into asygl.

commit 0d9a311e583d5ef442e1959121d7f353c489001a
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jul 14 10:21:47 2025 -0700

    Improve last revision.

commit 94dd473f65600b2c1f0cc31a06cbeb97291ed795
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jul 14 08:33:07 2025 -0700

    Fix issue #555: Incomplete error message under MSWindows.

commit e8245f979d05f4f857a77cdf6404fa38536d577d
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jul 14 08:21:39 2025 -0700

    Treat the jpeg format as a synonym for jpg.

commit 012440d2741e0651fb294972f45fbee6fc94e1e2
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jul 13 18:34:54 2025 -0700

    Simplify code.

commit f3947db92cfc7503ae41c729aa724d690c1cd896
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jul 12 20:02:50 2025 -0700

    Fix last revision.

commit e65b220e61c7b5c78516a3953266d0bb66a14d05
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jul 12 20:01:51 2025 -0700

    Add vsync option.

commit fb60b2b4b3a6a74b9e79b9b0c1aec3ffc2e5f05d
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jul 12 19:47:45 2025 -0600

    ASYGL: Quote remaining variables to prvent globbing.

commit 31489f5901aaaa82c410533136c65c35fe5b7795
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jul 12 19:42:54 2025 -0600

    ASYGL: Remove original clang-format check from build-asygl script.

commit e82ece54c69ea831242b29ddd2696561d5697087
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Jul 11 23:47:01 2025 -0700

    Fix last revision.

commit 70e383b685db7e4228e1240eb7347474e692738c
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Jul 11 23:41:47 2025 -0700

    Wake up GLFW on resize events.

commit 8ebfc95b160920053387147548d0cbfdc3c26828
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Fri Jul 11 21:00:56 2025 -0600

    ASYGL: Add debug-source-map option to build-asygl.

commit 3884e155618bfbba7e1372ba5707cca4d0bc05b8
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Jul 11 00:19:52 2025 -0700

    Begin transformation demo.

commit 6366e48fc9b2844f33aa1f5cd8977e03645c4107
Merge: 3b877b94c a7e006516
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jul 10 20:28:50 2025 -0700

    Merge branch 'webgl-ts-2' into asygl.

commit 5dee177e578db1e873c0fca4d50d42c854703e7f
Merge: d6c574be3 6253fe8c8
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jul 10 00:00:19 2025 -0700

    Merge branch 'master' into autounravelWithDatastructures.

commit 6253fe8c819803541c5f46bb753fec5d85704598
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Jul 9 23:55:07 2025 -0700

    Support v3d and gzipped XDR files up to size 2^64-1.
    Fix file mode descriptions.

commit 7aa6ad29b4c823905b897eed440f1c6d67bc7652
Merge: 1bfcd1c96 939a3b563
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Jul 9 11:10:07 2025 -0700

    Merge branch 'master' into vulkan.

commit d6c574be37e93100212016b61f52ced1ec0923f5
Merge: fb241766e 939a3b563
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Jul 9 11:07:41 2025 -0700

    Merge branch 'master' into autounravelWithDatastructures.

commit a7e006516f91df39f3cdd96e304d6a18d4ad808d
Merge: 88ee5a805 939a3b563
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 8 23:25:34 2025 -0700

    Merge branch 'master' into webgl-ts-2.

commit 939a3b5637343c90399c4ccd06ddb1a39c3e26f1
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 8 23:12:16 2025 -0700

    Simplify code.

commit a7a040161d0eb5fe3f11348d6b043207dd144b3d
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 8 23:06:41 2025 -0700

    Implement ogzxfile.

commit 1ebfd9b559652b6b589dca4e294198cb056cc1ed
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jul 7 17:05:14 2025 -0700

    Clean up GUI files.

commit 73d25cb71eda88e9efa300a1868b01ec406b5877
Merge: b7aa7c0c3 3fa3f8d51
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jul 7 12:45:54 2025 -0700

    Merge pull request #517 from vectorgraphics/perl2py.

commit 3fa3f8d510bd4c3a136701d9974e5ce14c2bc833
Merge: 043db4891 b7aa7c0c3
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jul 6 23:54:24 2025 -0700

    Merge branch 'master' into perl2py.

commit b7aa7c0c324379b8cdee93f710f43c788e0dbb49
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jul 6 23:32:01 2025 -0700

    Remove unused files.

commit 2636b251dd39374a2b5b0e885fccc6945bbfd78b
Merge: 21ab31a7b 7228b5221
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jul 6 22:18:14 2025 -0700

    Merge pull request #550 from vectorgraphics/qt6.
    
    Use pyside6 (Qt6) for GUI.

commit 88ee5a805bf15956d85b0d9d2378a55f2be7f7ba
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jul 6 21:00:55 2025 -0600

    ASYGL: Add clang-format file for javascript formatting.

commit a0a5ac23fc10e1bf2cf380cc4041cc63a558d8a9
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jul 6 20:11:16 2025 -0600

    BUILD: Change build-asygl to use webpack building.

commit b895e2ce5ecec72575a94cf75ea528b73e327555
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jul 6 19:43:57 2025 -0600

    WEBPACK: Add no-source-map-debug build option.

commit 789e6371ff7cf0855879c962f0aa9d48456d0dd2
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jul 6 19:40:54 2025 -0600

    WEBPACK: Add no-source-map-debug option.

commit 635f2a3a8e94537f2a6b689fb43192984bf0df57
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jul 6 19:36:59 2025 -0600

    NODE: Update package-lock.json.

commit 4ab09a9c92e5ba45df129675e89571c6b930d0a0
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jul 5 23:38:00 2025 -0600

    CMAKE: Add option to use custom-built asygl.

commit 37b5f9183e269d50de66ed274cfba45c8d4a8d56
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jun 28 22:34:08 2025 -0600

    TS: Remove top-level function wrapper since we are using webpack.

commit 3148174be64581fc2ac530370f914b3174090a60
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jun 28 22:26:10 2025 -0600

    Revert webgl version bump.

commit 883ce3cd5be27cd9cc355dbef6ec560ba7d530d3
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jun 28 16:47:40 2025 -0600

    WEBPACK: Fix asygl-1.03.js.

commit 2c13604968592e861b2ddf01f92f7db753fb346b
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jun 28 16:44:54 2025 -0600

    WEBPACK: Fix common.js.

commit 93c13ed9330ed901309aff194b00d5e86118f468
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jun 28 16:35:54 2025 -0600

    JS: Edit html generation to work with updated asygl.

commit 6a517699cda2b3c92cc1ea89acb27ee15abfa95c
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jun 28 16:34:06 2025 -0600

    GL: Bump asygl to 1.03.

commit 6f8316332ca05e18c19c1c63595df466f87730a9
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jun 28 16:33:13 2025 -0600

    GL: Add asygl 1.03.

commit e38ecde05b2e0048601ea59ccf635973e6d4e308
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jun 28 16:28:03 2025 -0600

    NODE: Fix package.json.

commit 6e89c6287e1649326cdd8beed3027f07522a00ef
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jun 28 16:23:54 2025 -0600

    CI: Remove npm dependencies stage.

commit 90548a3e93506da9cc057f5609319d31889c3f90
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jun 28 15:59:12 2025 -0600

    NODE: Remove code relating to downloading external files.

commit 0fb2e9bda431c8f7bcdb6d5784235fca3d093bd5
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jun 28 15:58:52 2025 -0600

    TS: declare global var Module.

commit a050db5bed84c5c728bb2811403f36fdd4213db7
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jun 28 13:40:17 2025 -0600

    TS: Add global types.

commit e2405e8c8ace12ebfca419e263c3e1b0192082a3
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jun 28 13:40:08 2025 -0600

    TS: Set language level to es2017.

commit 7263d4401d6fe568f4101baf21ba1d1a1f74a919
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Wed Jun 25 02:06:01 2025 -0600

    CI: Temporarily allow ESLint pass even if it failed.

commit 7bc80265f3373ad25d379e70f5731540df6e7491
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Wed Jun 25 01:57:23 2025 -0600

    ESLINT: Ignore src/ext/* files.

commit 494d7e91fd7923316d10fd753f06b041b76805c9
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Wed Jun 25 01:53:31 2025 -0600

    CI: Add asygl-sanity to pull request precheck.

commit 1895382cd836582a4996c64153c806fc0bba619e
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Wed Jun 25 01:52:40 2025 -0600

    CI: Add asygl-sanity CI file.

commit 74dfe5f8bc38568f828483eec8e2ef920b4e1f45
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Jun 24 12:03:41 2025 -0600

    NPM: Add targets for clean and dependencies.

commit 78b9c43bb0447da593aa51d872c984dcc34509bf
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Jun 24 12:03:25 2025 -0600

    NODE: Add script to clean files.

commit 532403537a95b18f33487754f30bfb41831071fe
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Jun 24 11:49:37 2025 -0600

    WEBPACK: Copy tinyexr.wasm to dist.

commit 4b02c7d0524e5384375525d0f51d01be3c8607ab
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Jun 24 11:49:25 2025 -0600

    NPM: Add webpack copier plugin.

commit fe10bbf5ed91ed9e768d4d4107d5ffc45c77ffd5
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Jun 24 11:31:52 2025 -0600

    TS: Set module to ES2020.

commit 85cc773f0eb6a13fe9f3cf6a1fb5c29fc49ddeee
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Jun 24 01:44:01 2025 -0600

    NPM: Disable fs/os/path bundling.

commit 7ad5c2adcc20b01fd028ddeca3c8ed385a23c676
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Jun 24 01:20:44 2025 -0600

    JS: Add tool script to download tinyexr.

commit 16dd66a6b2b0d08262117c3259c5d3372773706a
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Jun 24 01:19:37 2025 -0600

    REPO: Add src/ext to ignore list.

commit 44ffa357412e992d58c60bb5e02ef654fb630e97
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Mon Jun 23 23:44:27 2025 -0600

    git subrepo pull (merge) tinyexr
    
    subrepo:
      subdir:   "tinyexr"
      merged:   "2dc260526"
    upstream:
      origin:   "git@github.com:syoyo/tinyexr"
      branch:   "release"
      commit:   "5e523cd9c"
    git-subrepo:
      version:  "0.4.9"
      origin:   "???"
      commit:   "???"

commit 084ef781206b61e8e396d7df0f10ae6800b60286
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jun 21 13:33:46 2025 -0600

    tmp! checkpoint

commit 32ca7b476604ce08108f8f706e46933dcba9f033
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jun 22 16:27:09 2025 -0600

    WEBPACK: Add glsl as a source asset for webpack.

commit 30b31dd87d2bf3c8fdb087c221b91205a36ebd91
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jun 22 15:51:52 2025 -0600

    REPO: Add glsl.d.ts module file to export shaders.

commit ee10b9fc9c7ca2edf5fcd42d15c508242f8080ed
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jun 22 15:51:37 2025 -0600

    REPO: Include *.d.ts files in repo.

commit adf17d355f976a6748820a2e79c41f4f7e11f123
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jun 22 12:21:49 2025 -0600

    NPM: Add build targets for webpack.

commit 35d277cfb328abeae26ea88095b20963984afc61
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Jun 21 03:01:32 2025 -0600

    NPM: Add gl-matrix to npm dependencies.

commit bb530793b4d09f88c6eb4eb4ad43c50a50d457d1
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Jan 11 22:02:06 2024 -0700

    NODE: Set up basic libraries.

commit 3e228a2b3f723e55d9326272a90eaa8d9b024b07
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Jan 11 21:52:13 2024 -0700

    NODE: Init node package.

commit bdbecbb7c8b9f813eef1f6ff493bcdb82bb019c3
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Fri Jun 20 23:10:48 2025 -0600

    TS: Move shaders file to src/shaders.

commit 6d9dd78f49e682924ed04f7148bfbca082396133
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Fri Jun 20 23:10:36 2025 -0600

    TS: Change gl.js to gl.ts.

commit 7228b5221d48111ef00fa971dc19e9bba456212b
Merge: d021203a5 21ab31a7b
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jul 6 14:11:40 2025 -0700

    Merge branch 'master' into qt6.

commit 21ab31a7b796d33fac5f992580eb92224e8fd933
Merge: b42e6b6e4 d0cb18be2
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jul 6 09:43:57 2025 -0700

    Merge pull request #543 from vectorgraphics/optionalComma.
    
    Allow optional comma before ellipsis in rest argument

commit d0cb18be24df2b188f96408848b099258feb4b8e
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jul 6 09:39:42 2025 -0700

    Remove obsolete test script.

commit 3b9b11fb63b56e76b1670d7e6d623aa9fccc763d
Merge: e49ff93bf b42e6b6e4
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jul 6 00:20:40 2025 -0700

    Merge branch 'master' into optionalComma.

commit b42e6b6e4a8e6ac71bcb5fda0c3fd58e13c81d82
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jul 6 00:18:46 2025 -0700

    Remove obsolete test code.

commit 3f9a0494dfbe234e6e92f9a6639943a4b44a5c3e
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jul 5 23:12:20 2025 -0700

    Revert "Remove obsolete testing code."
    
    This reverts commit 5cbf2354357b7507b17ec4724db0076857b7eae6.

commit 5cbf2354357b7507b17ec4724db0076857b7eae6
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jul 5 22:46:58 2025 -0700

    Remove obsolete testing code.

commit e49ff93bfe24bae67abcc79e85166d1ccbf07882
Merge: 1db83bbe0 2ae1b191e
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jul 5 20:30:29 2025 -0700

    Merge branch 'master' into optionalComma.

commit 2ae1b191e55400a6b6638a26610e95a5a45aaeb0
Merge: 6498d3ad3 b3db10c43
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jul 5 20:16:01 2025 -0700

    Merge pull request #554 from vectorgraphics/make-asy-tests-list-optional.
    
    Make asy tests list optional

commit b3db10c43574c78746636e46d144be992a2d0eeb
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Jul 3 22:52:41 2025 -0600

    CI: Initialize latex in test stage.

commit 8b7addf182ad96fcfda26132269bb038a173aee9
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Jul 3 00:59:51 2025 -0600

    CI: Remove check-no-missing-asy-tests.

commit 4d659e4bad0df48bffaf5aa97ac23fa09ca0d433
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Jul 3 00:44:01 2025 -0600

    CMAKE: Change wce test name to bundled.asy.wce.

commit 9e758d5b27d8b60c43e3f705c33415835f3e8efc
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Jul 3 00:41:00 2025 -0600

    CMAKE: Modify generated tests to use asy-generated* labels.

commit 065abc084b8642d5472e6982855aea281a10a009
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Jul 3 00:31:32 2025 -0600

    REPO: Add tests/xdata to ignore list.

commit 7b6bad26b7d0d7f5dce12f7d992e70a193f892d5
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Jul 3 00:31:21 2025 -0600

    CMAKE: Add asy-check-tests test.

commit 7acbbf7425631a137997073c03527c4cccea53ba
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Jul 3 00:31:07 2025 -0600

    CMAKE: Remove asy-tests-list generated cmake script.

commit 90521475a6ab389ecdf1ff64a502662497e089d0
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Jul 3 00:18:34 2025 -0600

    PY: Add helper script to run asy tests.

commit 6498d3ad37f0ebff77839d98a539397faf64dc23
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jul 3 14:57:03 2025 -0700

    Begin moving version test from plain.asy to base/checkversion.asy.

commit fbc06837945644fb30eeb94cda4f46486bf2bde7
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jul 3 14:21:34 2025 -0700

    Increment version to 3.06.

commit d021203a5e614ae67e59064516118aa40d98086d
Merge: 4b25872e3 3c4afab99
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jul 3 11:39:00 2025 -0700

    Merge branch 'master' into qt6.

commit 3c4afab991ffcfedaf7e39eab6e4055c98f56457
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jul 3 11:37:30 2025 -0700

    Add deconstruct test.

commit b9aff3a006a5d235472d2bea754926dce7ef7796
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jul 3 10:24:57 2025 -0700

    Add xdr character test.

commit c6decbb23857fe7b642dd0bfb3e0da4cd06c7454
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Wed Jul 2 22:29:59 2025 -0600

    CMAKE: Make include of asy-tests-list.cmake optional.

commit a195e2a5d18de606c7b2242f72fe815f3bec852f
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Jul 2 11:36:11 2025 -0700

    Fix memixstream.

commit 4b25872e32ef217b30f042c8c497993c72f28e48
Merge: 749d466df a05e04c71
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 1 20:28:58 2025 -0700

    Merge branch 'master' into qt6.

commit a05e04c7124f3fb3795cf78b9a174e0c431c7473
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 1 20:28:09 2025 -0700

    Simplify make check.

commit 39b89dcd3dc490c6d1538d19bad69891c3746c4c
Merge: 321f230f5 70f6dec05
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Jul 1 17:52:10 2025 -0600

    Merge pull request #553 from vectorgraphics/replace-setup-latex-ci-windows
    
    CI: Replace custom action with choco for texlive.

commit 70f6dec05d850a624c211bd26f2b760a986ab511
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Jul 1 17:39:37 2025 -0600

    CI: Expand path with texlive in windows CI.

commit dd98db5cc1945c2adcb398e676dacf4a91684025
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Jul 1 17:38:39 2025 -0600

    CMAKE: Add additional notice mssages to options.

commit 1548a9fafc777e2fe84abd8fa9866c41b5939408
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Jul 1 17:19:39 2025 -0600

    CI: specify pdftex explicitly in CI.

commit e17d4571c8b8e12d486bb29ce939d2c2ed6c9aae
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Jul 1 16:43:58 2025 -0600

    CI: Replace custom action with choco for texlive.

commit 749d466df28b0d679dfe192163640b79ec9b0efc
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 1 14:56:01 2025 -0700

    Revert "Update TeXLive action."
    
    This reverts commit 80bf09ec4ae25cad69fc21ffba6da19dc4b916a9.

commit 80bf09ec4ae25cad69fc21ffba6da19dc4b916a9
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 1 14:47:49 2025 -0700

    Update TeXLive action.

commit 7b3f0fcd0b19b60fe8b929887c2a8509d0b9d48b
Merge: d67f14315 321f230f5
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 1 13:26:56 2025 -0700

    Merge branch 'master' into qt6.

commit 321f230f5c888ff91dedccaa48487a693fc79b3d
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 1 13:16:51 2025 -0700

    Update documentation.

commit 1bfcd1c969cea83cc77987b43638f29926a5564e
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 1 10:50:37 2025 -0700

    Force redraw.

commit c5b805600bc92686828612e3ed432511d719e7ff
Merge: f27a6537e 5dad4478c
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Jul 1 11:04:30 2025 -0600

    Merge pull request #552 from vectorgraphics/retry-ghostscript-install-ci
    
    CI: Use retry for installing ghoscript.

commit 5dad4478cbf472e77e9c2cc4dae45a83ce14286e
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Jul 1 10:36:24 2025 -0600

    CI: Use retry for installing ghoscript.

commit 7f36b8368c4a07a5af9a8b3f29c2b7935c35a49b
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 1 08:31:53 2025 -0700

    Fix interactive mode.

commit 5d5169692b38bf3424f60284d0e932eec0a0ea28
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 1 08:22:00 2025 -0700

    Fix compilation without Vulkan support.

commit d67f14315690d5b99c916e86e93f1a11e4863d7d
Merge: 8f106c2d8 f27a6537e
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 1 02:40:10 2025 -0700

    Merge branch 'master' into qt6.

commit f27a6537e1720ac65cb6d1bd2f8ed24bdbf55b93
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 1 02:39:47 2025 -0700

    Regenerate tests.

commit 8f106c2d809a2c3556fe21135ad04261fbea8575
Merge: bd1ec79f4 c45a21e9e
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 1 02:32:15 2025 -0700

    Merge branch 'master' into qt6.

commit c45a21e9e89df1afedefa8cef235021a2ed4a7d1
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 1 02:19:19 2025 -0700

    Update URL of Asymptote Web Application.

commit 359ab1ad8f5954d1ee973ce1cfd00a0951a2bc59
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 1 02:03:15 2025 -0700

    Add XDR tests.

commit 42eba5f3f46efac71ed612bf053dca3ddf593c77
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 1 01:05:20 2025 -0600

    Suppress MacOS X warnings.

commit fb81149f6c050cfa7af0aa04433a1022becb6f5d
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jul 1 00:53:47 2025 -0600

    Port xstream updates to MacOS X.

commit 87386472859f053d193ce586c0dbdafb5bf45f39
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jun 30 23:12:17 2025 -0700

    Fix last revision.

commit 172d021fdcb5805a95f0f93c2359e4cec27bc2ee
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jun 30 22:15:04 2025 -0700

    Fix last revision.

commit 0e82219b6f45ef0172be48a49e1c6219c8337338
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jun 30 21:44:32 2025 -0700

    Restrict optimization pragma to GCC.

commit 0309552646eb2275601018ef81e604ea1779ae8a
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jun 30 18:18:50 2025 -0700

    Avoid wasting CPU cycles in mainLoop.

commit b146fd2ec0a4cb6c536914fa7d3ebdfacd730914
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jun 30 17:55:23 2025 -0700

    Fix mainLoop.

commit bd1ec79f4b77ae6eb9fa2da8fcca7c7709bff83f
Merge: b91ce316c 61a4e86e8
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jun 29 23:42:28 2025 -0700

    Merge branch 'master' into qt6.

commit 61a4e86e898353713a73a51cd5a50d6142566bd6
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jun 29 23:41:19 2025 -0700

    Improve array read tests.

commit 14e27840238fd1992c505599c0d1686dc3b5c506
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jun 29 23:31:59 2025 -0700

    Update documentation.

commit 7dbdf992ba26a47f659209c85b33d1bc94d53c63
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jun 29 22:58:47 2025 -0700

    Reinstate file.singlereal by partially reverting commit
    2643b3266bcf097515bb3aa3d8c375f6a55171e2, working around GCC optimization bug.

commit b3a2012a707d6c2331967ca55d16fea7b9940df3
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jun 29 20:47:11 2025 -0700

    Implement XDR and binary string reads.

commit b91ce316c9ed4aded4ad416e82138358c96fb8da
Merge: 22c715899 842945d23
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jun 26 17:16:13 2025 -0700

    Merge branch 'master' into qt6.

commit 842945d23266092a194ade0c66735d21a5ed5524
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jun 26 16:46:28 2025 -0700

    Simplify code.

commit 36a519033ff3c132ea1607958987e7fea584beef
Merge: 2046a3100 b52f219a9
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jun 26 13:50:11 2025 -0700

    Merge branch 'master' into vulkan.

commit b52f219a915b10b9d98a9587c8ad44c1553d00ee
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jun 26 13:29:25 2025 -0700

    Simplify code.

commit 034380739eb9583999aa7e0145521b4013f9e9e9
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jun 26 13:07:59 2025 -0700

    Remove unused code.

commit 2ed539103d8680f0241eb9a51e7e0c42b0ed5239
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jun 26 13:06:52 2025 -0700

    Fix 64-bit integer XDR reads and writes under UNIX.

commit 6713a8149cb2e2ba740f406ac6294b0106ccc17a
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jun 26 13:05:51 2025 -0700

    Remove obsolete code.

commit c5a92d90f7be3842e3ed10a6732039d664a81d7e
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jun 24 13:30:05 2025 -0700

    Begin render extraction.

commit d28c5c516799acb6ce21e2bd83dfe583e3a5da5f
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jun 24 09:47:55 2025 -0700

    Enforce binary mode for xdr input and output.

commit 2046a3100817e82a82c3ea4d7192af047a8a8fe4
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jun 22 22:21:58 2025 -0700

    Fix home.

commit c389500371fbf5d88b4f81140922af5bc410eb28
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jun 22 21:38:42 2025 -0700

    Fix 3D workflow.

commit 993a13e6acccc49dde3dbd6f0ddd801815d052a5
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jun 21 23:00:48 2025 -0700

    Fix interactive mode.

commit 8a071321aca0b93b9ad40b7daabb028bcad096d3
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jun 21 22:22:39 2025 -0700

    Fix exit errors.

commit 6cd6c5c1a2e19da7e43fabd89a9130d242d466f6
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Jun 20 14:51:21 2025 -0700

    Stop rendering on quit.

commit 3b877b94cf642c5ff93e9160c86e01b6bde72344
Merge: b33b3ed74 3396b9bc7
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jun 19 10:38:40 2025 -0700

    Merge branch 'master' into asygl.

commit b33b3ed74e2d54e90b1cd61c426f82ee90fef665
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jun 19 10:38:29 2025 -0700

    Reformulate 2D animation example.

commit 3396b9bc7291143179b0d5bad9e5da7b6a46a4d4
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Jun 19 10:37:15 2025 -0700

    Remove explicit 'gif:' format from animate call.

commit cdbe9596b8d90ebb2536345b9535da5dfcb70d96
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jun 17 22:50:19 2025 -0700

    Fix exit errors for opaque scenes.

commit f79acb024010e9c1d74f989a52db4f06ebe181b0
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Jun 17 20:32:34 2025 -0700

    Disable redraw during shipout.

commit 6c3e4aac176b9c73a9bc996719977dceab5d5706
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Jun 13 21:27:05 2025 -0700

    Fix aspect ratio with multiple shipouts.

commit 1db83bbe0d9057d835709df7c92a7993cc036a80
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Jun 13 19:53:55 2025 -0700

    Edit documentation.

commit fc50401e3729cf5272fc31c44e158a77ee1bf80e
Merge: 6e25493e3 2f60e660c
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Jun 13 19:38:12 2025 -0700

    Merge branch 'master' into optionalComma

commit 3429e89dcd129d05a48fe854792c60326b2555ee
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Jun 13 19:20:01 2025 -0700

    Revert "Use new Vulkan renderer for each shipouut3."
    
    This reverts commit 0f56d3e6c7bfd6b799d6221fffd1b3d8dd199304.

commit 043db4891bc3a46cda21da77d3f544408a317d31
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Jun 13 15:53:51 2025 -0700

    Remove runtime.pl (replaced by runtime.py).

commit dead7e6f65c2ff24521362bfae2a416a122b7e56
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Jun 13 15:45:53 2025 -0700

    Remove unnecessary logging.

commit 267d75e2a498d0f6f4506f306e0d77ec87fcaec2
Author: Charles <charles.staats.iii@gmail.com>
Date:   Wed Jun 11 15:49:44 2025 -0700

    Refactor runtime.py.

commit 5ec664db73e102cf5bbb6b563c250a8bd25d9b5b
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jun 9 18:59:14 2025 -0700

    Increase default value of MaxFramesInFlight to 6.

commit a019d2557cdee19820666f8db8941fd01000fbc9
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jun 9 18:56:35 2025 -0700

    Use a separate semaphore for each swapchain image submission.

commit fcc97da495252c483b85ce1b64d3e473e6321de6
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon Jun 9 17:02:19 2025 -0700

    Restore config.guess and config.sub from master.

commit 278807f491321d9d6d919253a84b79e0571c9baa
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jun 9 16:51:40 2025 -0700

    Remove unused MESA_OVERLAY_LAYER.

commit 8d2d5ab9bab7380b688372b1d5b52a3512e0f539
Merge: 1ec56cb70 2f60e660c
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon Jun 9 09:28:36 2025 -0700

    Merge branch 'master' into perl2py

commit 1ec56cb70a107a3fb62c4f8422aabeb90b65347d
Merge: cf8e36023 a9482f571
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon Jun 9 09:10:02 2025 -0700

    Merge branch 'master' into perl2py

commit fb241766e9068d47ee74d56ca95150e718581a59
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon Jun 9 09:09:29 2025 -0700

    Improve nullValue documentation.

commit a51f7f7800e0193fcad139abfc3f4f44bcba7f2f
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jun 8 15:39:20 2025 -0700

    Fix Vulkan validation warnings.

commit 22c715899ed84c3acea919c5fa3819105c571fce
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jun 8 12:53:52 2025 -0600

    GUI: Show status bar after save consistently.

commit 6269a38e1e5c1e285b4ebc097d56252f9512ac6c
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jun 8 12:47:28 2025 -0600

    GUI: Remove some unused lines.

commit c760c83928ecc439b628dbeec0e22641947a1866
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jun 8 12:46:46 2025 -0600

    GUI: Replace "print" function with errors in a message box.

commit 77125985ab8da40af616e14d4166176f50dd0622
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jun 8 12:45:42 2025 -0600

    GUI: Add error_msgbox util function.

commit 0f56d3e6c7bfd6b799d6221fffd1b3d8dd199304
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Jun 7 23:22:33 2025 -0700

    Use new Vulkan renderer for each shipouut3.

commit 050388ccf51f3b005b87f31a81f32fb28778167b
Merge: 94434f555 2f60e660c
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Jun 6 20:29:29 2025 -0700

    Merge branch 'master' into qt6.

commit 2f60e660c525c4345f261a2f1d14a54964eb5d48
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Jun 6 20:28:41 2025 -0700

    Respect xmap transforms again.

commit 94434f5556a5f36918c4e9f431e3e8d5a805eb94
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Jun 5 23:10:12 2025 -0600

    GUI: Fix actionSave.

commit 20f733d741ccb2b82a4ccfdd0146928ea1b116bc
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Jun 5 22:35:29 2025 -0600

    GUI: Port pyqt5 calls to qt6.

commit 3e7ed714ff6623d9b73c204e467f945ea834cafc
Author: Charles <charles.staats.iii@gmail.com>
Date:   Tue Jun 3 18:14:09 2025 -0700

    Edit documentation.

commit c7e58f05548bc53d083714e09cc371a3af6eb78f
Author: Charles <charles.staats.iii@gmail.com>
Date:   Tue Jun 3 16:47:29 2025 -0700

    Minor formatting improvement.

commit 5fcd522d255da633351e16e8468c7571691ddb88
Merge: 8a30da109 a9482f571
Author: Charles <charles.staats.iii@gmail.com>
Date:   Tue Jun 3 16:30:50 2025 -0700

    Merge branch 'master' into autounravelWithDatastructures

commit 8a30da10943f6280dff49a10e925d2abc3104c83
Author: Charles <charles.staats.iii@gmail.com>
Date:   Tue Jun 3 16:29:55 2025 -0700

    Require keyword for nullValue parameter in map constructors.

commit 345eb4a96523196ad94d91d6b29727e64130d5f1
Merge: 56c6ef0ab a9482f571
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jun 2 13:26:51 2025 -0700

    Merge branch 'master' into vulkan.

commit a9482f571bd2d672ae5ef085016ca5e875354864
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jun 2 13:26:44 2025 -0700

    Fix last revision.

commit 56c6ef0ab06a77ea02476d52be7413086cca4416
Merge: dbaa93d0e 9df09017a
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jun 2 13:18:53 2025 -0700

    Merge branch 'master' into vulkan.

commit 9df09017a6052bf96f0882d97dffb55c05867dda
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jun 2 13:18:17 2025 -0700

    Increase another CI timeout.

commit dbaa93d0e707b21488ce886cbfdcff4736b4a385
Merge: c98dd83dc 513efa6c3
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jun 2 10:20:43 2025 -0700

    Merge branch 'master' into vulkan.

commit 513efa6c314c3e81a18341bb39f02da0aff8b0e6
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jun 2 10:20:33 2025 -0700

    Increase CI timeout.

commit c98dd83dc7e7d7d3b105ed13a04839fadc2677b4
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Jun 2 01:30:11 2025 -0700

    Invalidate transparency depth on resizing.

commit 0ab7509cf429cb1b91203fc418abb3498d107b7c
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Mon Jun 2 00:46:36 2025 -0600

    GUI: Add more Qt.Slot decorators.

commit dbb2ead9f1ae39d8689b6556b53d6644afa4a8a4
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Mon Jun 2 00:43:16 2025 -0600

    GUI: Fix additional Messagebox signature changes.

commit ff333243a4a52c6b2f48eb6e3a74699134702a9e
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Mon Jun 2 00:43:00 2025 -0600

    GUI: Add Slot decoration to button functions for performance improvements.

commit 9529cc307c1d9997883f602727b2b05b15108315
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Mon Jun 2 00:17:35 2025 -0600

    GUI: Fix signal disconnection in InplaceAddObj.

commit cf2076cccfd379a8cddc99580fb29222e9bdb898
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jun 1 23:36:37 2025 -0600

    PY: Fix minor unpythonic style.

commit 87d6dfc94d24c39b01b12d117cc072f7e5e3f6e6
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jun 1 23:27:56 2025 -0600

    PY: Remove old testing code from UndoRedoStack.py.

commit 91e750b1427a678c156e042797dfe58b283acbe0
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jun 1 23:27:20 2025 -0600

    GUI: Fix additional pyside6 issues.

commit 20d76ac1c521495ee094d5a6a512e8cb2dcc75e0
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Jun 1 13:03:43 2025 -0600

    GUI: Fix png data format.

commit 16a4f6f1ccee6351f5596d63cae69c43d6c70cc0
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Jun 1 11:45:30 2025 -0700

    GUI: Respect physical DPI.

commit 4f5f44b28b7f68fde104c371fc6bec9da295cb83
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat May 31 10:17:20 2025 -0600

    DOC: Update pyqt5 to PySide6 in docs.

commit 044405f7c8b79febd4df71bdb492c3f1b91a83c2
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat May 31 10:11:16 2025 -0600

    MAKE: Remove mentions of pyuic5/pyrcc5 since gui build is managed by buildtool.py.

commit b1e5ad5347dab3eb933508a0bf5dec8f221f8ecb
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat May 31 09:59:27 2025 -0600

    GUI: Add mkdir call when creating a new directory in buildtool.

commit c401f5d5176daff4e6d53e132c7dfba548bf100e
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue May 27 11:01:42 2025 -0600

    QT: Port parts of qt calls to use Pyside6 functions.

commit ebf11ae149e7a8658fc02c351c1fc9d9c2f413e2
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 31 09:57:57 2025 -0700

    Zero transparency buffers.

commit 3a5b93ece4dfc22c99981ba96f237da45a3d300c
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Mon May 26 23:56:47 2025 -0600

    PY: Fix names of some variables that shadow builtins.

commit fdafd8684d31f1953b4aa58403af3e7c28732590
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Mon May 26 23:43:16 2025 -0600

    QT6: Remove high DPI scaling options.

commit 18c191a22ce9fa5176e420b466a94f1458899fec
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Mon May 26 23:42:08 2025 -0600

    QT: Change pyqtSlot/pyqtSignal to Slot/Signal.

commit 2656064eff5ed67d5797a64416911905479b4840
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Mon May 26 22:58:04 2025 -0600

    GUI: Use pyside6-rcc for building icons.

commit e2dfea76651d37f92cfc0b2403b6991347d6868b
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Mon May 26 22:24:32 2025 -0600

    GUI: Use pyside6-uic for building GUI files.

commit 147c4d4edf4c88dc97b4d3cc468ce91efe19b97b
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Mon May 26 01:07:18 2025 -0600

    PY: Change PyQt5 to PySide6 import.

commit d9c73613f02af177bf8712fb96beb62babf47233
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat May 24 10:58:55 2025 -0600

    PY: Bump numpy to 2.0.0.

commit d6b006147122826607a9bd5e34cdba3674d5a6f7
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat May 24 10:58:22 2025 -0600

    QT: Change PyQt to PySide6.

commit eb33d6d864d0fb8e5392dbbbc907c21259c922c0
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Fri May 30 20:24:17 2025 -0700

    Add enable-large-config to GCOPTIONS to fix "too many root sets" error on some(?) macs.

commit 9c21f366b241572f77a981e25a9a5fa054caf21c
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri May 30 18:19:26 2025 -0700

    Document overloads in the same place for Set.add and Set.delete.

commit a2354f8cea0677b223fdeec8328a8a6261332164
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 25 12:20:34 2025 -0700

    Clean up build-asymptote-CTAN.

commit 1107aa4540841238dbec066d142df55edf45c44b
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon May 26 11:18:06 2025 -0700

    Expand iterator documentation.

commit 2c6d60dd03984a856074df98bb3df969609cc1be
Merge: b30a21370 f3faabf8b
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon May 26 10:51:41 2025 -0700

    Merge branch 'master' into autounravelWithDatastructures

commit f3faabf8b067d6daa7016e3438258496759b1857
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Mon May 26 00:57:15 2025 -0600

    REPO: Modify gitignore to exclude .idea everywhere.

commit 052983e2eb4801fb6d17ed8d06dac18ae069f384
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 25 12:12:12 2025 -0700

    Increment version to 3.05.

commit 1cfeecfc04efb9f6457a6243b46441d911eba7f2
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 24 13:26:14 2025 -0700

    Fix last revision.

commit f21cd77f3a139d1bce048f2597d04715758cb1ed
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 24 13:21:55 2025 -0700

    List URLs to source code for dynamically linked MSWindows libraries.

commit 04e1dfd250bbf1033fe9a139c588b2e9303711b8
Merge: 1da070d6c 118dd50b4
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 24 13:04:02 2025 -0700

    Merge branch 'master' into vulkan.

commit 118dd50b48e6a0de7b80d258ac54d96c4d4bbf1d
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 24 13:01:02 2025 -0700

    Change WebGL KEYS to comments.

commit 1da070d6c4bb677007668c8533a3fc64eafea318
Merge: 08fc9c5a2 888c93cb1
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 24 12:40:30 2025 -0700

    Merge branch 'master' into vulkan.

commit 888c93cb1b2d912cd392e450779d7fcb19a0ddac
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 24 12:19:24 2025 -0700

    Implement settings.keys: optionally add KEYS to WebGL output.

commit 585e7894ea788aa467604e83db1dc3b0b544ab35
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 24 12:15:23 2025 -0700

    Add KEY to cylinder and disk primitives.

commit 2622dc2282b5484ca7d305f9ebd6583d517d2bb8
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 24 08:18:40 2025 -0700

    Restore example.

commit 08fc9c5a2d923d4a09e6bc3fc1437f256c4ee947
Merge: c4286e187 ff38310cd
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 22 11:55:34 2025 -0700

    Merge branch 'master' into vulkan.

commit ff38310cda44d645255002a693d4c0adf4bd3f19
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 22 11:54:41 2025 -0700

    Copy version.asy to top-level base directory for testing purposes.

commit c4286e187e37e09b175bf29459109209bcbe1b21
Merge: 0e24597e9 201b3ebdd
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 22 10:55:18 2025 -0700

    shMerge branch 'master' into vulkan.

commit 201b3ebdd6e889ff252657d8e1307db4aff2afd6
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu May 22 10:53:50 2025 -0700

    Fix unlink issues under MSWindows.

commit 0e24597e911c2144d8e9e6321d0242f75834e01a
Merge: 30b71418e c005fe151
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed May 21 23:22:38 2025 -0700

    Merge branch 'master' into vulkan.

commit 552844cf477675ace123d862f3a1dffab67fdade
Merge: d93212c85 a8d72054d
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed May 21 23:21:57 2025 -0700

    Merge branch 'master' of github.com:vectorgraphics/asymptote

commit d93212c85642efdb8e34ef5f4845b3fecc706c9e
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed May 21 23:21:31 2025 -0700

    Fix CMake builds.

commit a8d72054d039101b8e148e9cb477bdc8fb57ac19
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed May 21 23:06:21 2025 -0700

    Update build-asymptote.ps1.

commit c005fe1517e6d016f5319d01cbfbe1c176fa1c08
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed May 21 21:54:15 2025 -0700

    Update build-gui.yml.

commit 30b71418e7710cb835f290deb397d5378f25abb3
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed May 21 21:54:15 2025 -0700

    Update build-gui.yml.

commit 07de767b759e484659e44350d03e84aeb1cc828e
Merge: 1c0faa515 095847b91
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed May 21 21:45:24 2025 -0700

    Merge branch 'master' into vulkan.

commit 095847b91c669ceca06572fda35076c1ad2ffe8c
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed May 21 21:22:38 2025 -0700

    Remove unused files.

commit 579756ca19853a42b6d431f93bc96c3a44f76db9
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 20 21:37:25 2025 -0700

    Update required setuptools version.

commit 66719c732100dc6b34495f6575e7a139cba0edb9
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 20 21:33:50 2025 -0700

    Update asygl.

commit 30afe085fa08ae6c3a5e2d6244b212fd5a1f435e
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue May 20 21:32:28 2025 -0700

    Remove projection-dependence of shaders for correct rendering of embedded WebGL images.

commit 08c4c25ec5b8c76a06ad51c0c0a8250848f6b307
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon May 19 10:31:13 2025 -0700

    Revert "Update asygl."
    
    This reverts commit 0d13b088207cbbd8942f2eee55287d95a135957b.

commit 3c9de631d62c19697c33f1d60b41d59c146f5d77
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 18 21:58:45 2025 -0700

    Revert "Fix race condition between embedded WebGL scenes."
    
    This reverts commit 6ea778325776f1905e96d125b658388af182eb8d.

commit 0d13b088207cbbd8942f2eee55287d95a135957b
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 18 21:43:53 2025 -0700

    Update asygl.

commit 6ea778325776f1905e96d125b658388af182eb8d
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 18 21:39:12 2025 -0700

    Fix race condition between embedded WebGL scenes.

commit ae4edfbd6a96a85d661178f516e183d246045e26
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 18 00:31:47 2025 -0700

    git subrepo pull (merge) --force LspCpp
    
    subrepo:
      subdir:   "LspCpp"
      merged:   "273a4a224"
    upstream:
      origin:   "git@github.com:vectorgraphics/LspCpp"
      branch:   "master"
      commit:   "273a4a224"
    git-subrepo:
      version:  "0.4.9"
      origin:   "???"
      commit:   "???"

commit dc093856266b7d4024c0711c1d056adec5917609
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 17 22:39:12 2025 -0700

    Use pngdriver=png16malpha by default.
    Use ghostscript options "-dTextAlphaBits=4" and "-dGraphicsAlphaBits=4"
    for pngdriver.

commit b30a21370c56cdaddc11d9a78a125b2f8cefc01a
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon May 12 17:41:31 2025 -0700

    Document casts between Array_T and T[], as well as Array_T.data.

commit 29e397a3418fd6c95cc00c9f870e1e0902547298
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon May 12 17:32:53 2025 -0700

    Make makeQueue an autounraveled method of Queue_T.

commit 88cc6268cf2e5870920ea27aae41be58fea4b69d
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 11 15:07:01 2025 -0700

    Increment version to 3.04.

commit 1c0faa515b4e3cb613175cc527ccf13ddcf28689
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 11 14:13:58 2025 -0700

    Support --outname again in MSWindows build.

commit 664e2b2e90efcaf1ad0b71ff9d86589d92d0eb49
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 11 14:13:58 2025 -0700

    Support --outname again in MSWindows build.

commit 476dd64d9fbf8b119f532afde10c75c211950a3b
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 10 20:53:04 2025 -0700

    Edit documentation.

commit 29ece1f933ca6911eb616862108739c2bfa03912
Merge: 1f8003d8d c38d7617f
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 10 19:44:33 2025 -0700

    Merge branch 'master' into vulkan.

commit 2e74c97a81cbadbf6a9ea44fa123f3656f82314f
Merge: 6fecce69c c38d7617f
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat May 10 19:19:28 2025 -0700

    Merge branch 'master' into autounravelWithDatastructures

commit c38d7617f1d61e850fb8ef86aa7e0ed6c6e5f420
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 10 17:01:24 2025 -0700

    Simplify code.

commit e8dcdee86938f21d2efe3c1a1442d4bf6678c34e
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat May 10 17:52:28 2025 -0600

    W32: Fix implementation of renameOverwrite by parsing the return value correctly.

commit 6e25493e30551ab514afe1c650604074d693cb20
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat May 10 09:27:11 2025 -0700

    Update tests cmake.

commit 849b0dd482a318451e0c7d1ba56d4a3c2e5edbb4
Merge: b5d0b404c 177125ffc
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat May 10 09:13:13 2025 -0700

    Merge branch 'master' into optionalComma

commit 6fecce69c51e7b5294806db2621b202425623711
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat May 10 09:03:30 2025 -0700

    Add missing cross-reference in documentation.

commit ffd1fb5f3354ecef623fb4f57431747ef6aaa0e4
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat May 10 08:51:28 2025 -0700

    Clarify principle of reversibility use in documentation.

commit f70c2a83e88d01f6048bf0c031be8263abea240b
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 9 14:50:39 2025 -0700

    Fix last revision.

commit 0054f80ebe23f35e30ab16f81ef8c11d3820f7b8
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 9 14:40:27 2025 -0700

    Fix last revision.

commit 5d03a31162eff7271b1107d78124b1204523d9ca
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 9 14:37:54 2025 -0700

    Fix last revision; update FFTW++ files.

commit e2c7b2730553876180933e2b4b640902d7d03568
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 9 10:42:04 2025 -0700

    Port rename to MSWindows.

commit acaf12bc3a642eec8c850fd12d32f353b3c94655
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 9 10:18:54 2025 -0700

    Revert "W32: Replace rename with MoveFileExA on windows to allow overwriting."
    
    This reverts commit 1771aa6990c74397380c31d432da7630a8547fdc.

commit 7a646465e03571e28ef17827ba10ab07bfb4aefa
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu May 8 21:26:36 2025 -0700

    Fix splaytree and add it to tests (but not documentation).

commit 50dbd04efa30c7ac4ab62d0e9c744626a56b0c47
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu May 8 18:09:41 2025 -0700

    Rename firstGEQ to atOrAfter, likewise firstLEQ -> atOrBefore.

commit e6aff74727b07a14f63b30420de528d6f856a29a
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu May 8 16:59:34 2025 -0700

    Refine PLFunction example in documentation.

commit b54eaeae8675a7a317f80e884f26ce3fb35232f8
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed May 7 22:13:48 2025 -0700

    Edit documentation.

commit 2b904ba4436b7db891f9c5a68b2aaaeb9de77e17
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed May 7 20:35:48 2025 -0700

    Change camp_random to camp.

commit b946b50f7750cd2921c9407a4d0e78a763a18a9b
Author: Charles <charles.staats.iii@gmail.com>
Date:   Tue May 6 18:18:28 2025 -0700

    Register btreegeneral with cmake.

commit a9f48e2290da2ec07dd1498218250e628bfe3fc3
Author: Charles <charles.staats.iii@gmail.com>
Date:   Tue May 6 18:09:22 2025 -0700

    Edit documentation.

commit 4b1d98bc018ff090aa47967e18fbe3b8bbdacfba
Author: Charles <charles.staats.iii@gmail.com>
Date:   Tue May 6 18:05:44 2025 -0700

    Add set operators to General Index.

commit 326b6bbe82bc8772a130e7e32d52d77f7fe37bed
Author: Charles <charles.staats.iii@gmail.com>
Date:   Tue May 6 17:50:20 2025 -0700

    Fix RNG after merge.

commit 6c928fe5b3f80b14bc789df7fec81e404080be25
Merge: 9d858021d 177125ffc
Author: Charles <charles.staats.iii@gmail.com>
Date:   Tue May 6 17:24:10 2025 -0700

    Merge branch 'master' into autounravelWithDatastructures

commit 9d858021d087bf7cdaff9d6d0bbc0dd521371ae0
Author: Charles <charles.staats.iii@gmail.com>
Date:   Tue May 6 09:26:41 2025 -0700

    Rename set.swap to set.push.

commit 903aee33d04a2d34fb03c3e2c09b12df7a03058d
Author: Charles <charles.staats.iii@gmail.com>
Date:   Mon May 5 18:22:09 2025 -0700

    Document iterating over SortedSet.

commit 1f8003d8db57fab7ba2150efc9e6e777df192316
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun May 4 21:57:47 2025 -0700

    Fix VulkanMemoryAllocator warning messages.

commit bd7f2a59a73ca740bf282b0c07863f2ceedfba9b
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat May 3 21:37:34 2025 -0700

    Edit documentation.

commit d8915e56525e6a44d0cf6375a843757e80e09f74
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat May 3 18:56:31 2025 -0700

    Manually format two lines in documentation.

commit 7b120a1a294337bc53486e6190f39afc66e46dd5
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat May 3 18:40:13 2025 -0700

    Ensure Set.get implementations throw error when nullT is needed but not defined.

commit 7547191c48fb613e05d11b3d298376256409a4ce
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat May 3 18:34:46 2025 -0700

    Document Set.newEmpty.

commit 42e79b0647f5aabfda425b4d91b2da52fbe73e5d
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat May 3 18:26:45 2025 -0700

    Test and fix set binary ops, newEmpty method.

commit 843156764d1de587a76fa3da0a7d56888515e7b7
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat May 3 16:59:59 2025 -0700

    Improve BTreeSet constructor documentation.

commit a6d06808b9ec6f2101f44ab31b6a0696d0bb2ed8
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat May 3 16:17:17 2025 -0700

    Move btree to btreegeneral.

commit b7c582796dc53b66cc2bf50678fe85a53cebfd05
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 2 23:34:27 2025 -0700

    Use consistent VK_API_VERSION.

commit 1640fe4c2d191c7d515c3db3b2fad463cc4bd3af
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 2 23:29:43 2025 -0700

    Improve diagnostic.

commit 177125ffcf4419952ffb8b77b438a014c7e9b315
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri May 2 23:09:50 2025 -0700

    Fix xasy setting.

commit 3d772a51222aea56d6bd0f5bd7733d915feae983
Author: Charles <charles.staats.iii@gmail.com>
Date:   Thu May 1 22:39:38 2025 -0700

    Add intersection and symmetric difference operators.

commit 8bbc9f2cde790101391f5cbd7d155a14a38711ca
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 30 21:41:14 2025 -0700

    Edit documentation.

commit eef6b7d40a59be434ddef92e760487eadac79fa7
Author: Charles <charles.staats.iii@gmail.com>
Date:   Wed Apr 30 19:44:33 2025 -0700

    Minor correction to PLFunction example.

commit b32e5406a50a6df84911e5f69707bda4510203cf
Author: Charles <charles.staats.iii@gmail.com>
Date:   Wed Apr 30 19:32:37 2025 -0700

    Documentation example for using sets as maps.

commit d6c01c496458c3cd576c55f2116cc12280fb50a2
Author: Charles <charles.staats.iii@gmail.com>
Date:   Wed Apr 30 17:48:09 2025 -0700

    Add Queue documentation.

commit f0900d427ec844ee4e67202b2e7f84bae194813b
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 29 20:58:09 2025 -0700

    git subrepo clone --force --branch=v3.2.1 https://github.com/GPUOpen-LibrariesAndSDKs/VulkanMemoryAllocator
    
    subrepo:
      subdir:   "VulkanMemoryAllocator"
      merged:   "c788c5215"
    upstream:
      origin:   "https://github.com/GPUOpen-LibrariesAndSDKs/VulkanMemoryAllocator"
      branch:   "v3.2.1"
      commit:   "c788c5215"
    git-subrepo:
      version:  "0.4.9"
      origin:   "https://github.com/ingydotnet/git-subrepo"
      commit:   "b9b059a"

commit a6534e9e4f1826544bdccf277ef26c9942eaa1b9
Merge: 8fd7316e8 ee7686077
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 29 13:30:22 2025 -0700

    Merge branch 'master' into vulkan.

commit ee7686077c93e75bca61da337532170f0a310548
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 29 13:29:44 2025 -0700

    Fix last two revisions.

commit 8fd7316e8657ccb12397f545ded50992cdf50ed0
Merge: 2db2d8260 d9cbac891
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 28 23:23:08 2025 -0700

    Merge branch 'master' into vulkan.

commit d9cbac891fde5b1706ae9f643ebd00c20e67b2f2
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 28 23:22:55 2025 -0700

    Add missing setenv argument.

commit 2db2d826033c7eb347f309b024a4cede32bc230b
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 28 23:04:39 2025 -0700

    Disable MoltenVK logs by default.

commit c0562accad992c88857e9241304bc86992a1bf1d
Merge: a11457eef 219f5b43b
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 28 22:53:42 2025 -0700

    Merge branch 'master' into vulkan.

commit 219f5b43b5a6da0cc21d87128153ff4d4f40090f
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 28 22:51:07 2025 -0700

    Implement setenv and unsetenv for MSWindows.

commit a11457eefb6fdb54364dfd41dfbbc074f66f2069
Merge: 94fdf60af e31c4b767
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 28 21:56:58 2025 -0700

    Merge branch 'master' into vulkan.

commit e31c4b76781606665f8a575abb7334e10a03e4d9
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 28 21:56:24 2025 -0700

    Remove obsolete code.

commit 94fdf60af92e5358e35b1b24b45bf0415b70e60e
Merge: 1248d7fd4 1767469b5
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 28 21:49:40 2025 -0700

    Merge branch 'master' into vulkan.

commit 1767469b548e7ad293d7bfa69ddb482fde8f53b7
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Apr 28 21:44:26 2025 -0700

    Remove obsolete code.

commit 1248d7fd4f5665573cc14b3a08045d518fa0319f
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 27 22:05:51 2025 -0700

    When running on a remote server, use GPU for rendering when View=false.

commit a564732bbaf6ec3eb2719b9efe8a0071d914c49e
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sun Apr 27 19:11:38 2025 -0700

    Begin documenting Queue_T API.

commit fc90dff9ea9a8d048d0b93cc519d3ea4beb1d9a9
Author: Charles <charles.staats.iii@gmail.com>
Date:   Sat Apr 26 16:33:29 2025 -0700

    Document the SortedSet API.

commit 0c60e42e57fa4cd43895d38e449100bf7bb32ef7
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Apr 25 18:45:15 2025 -0700

    Document the Set_T API.

commit 6c233fd198083016c208d33608236540ddd1d03a
Author: Charles <charles.staats.iii@gmail.com>
Date:   Fri Apr 25 18:41:06 2025 -0700

    Make Set_T.delete more user friendly; add Set_T.extract with previous behavior.

commit a4cf3480b540ab6fb9b24f1864d103a9437d6f31
Merge: 3bd2de12b 1771aa699
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Apr 22 01:01:39 2025 -0600

    Merge pull request #545 from vectorgraphics/fix-windows-file-rename-override
    
    W32: Replace rename with MoveFileExA on windows to allow overwriting.

commit 1771aa6990c74397380c31d432da7630a8547fdc
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Mon Apr 21 21:15:57 2025 -0600

    W32: Replace rename with MoveFileExA on windows to allow overwriting.

commit 58b9bb1355725150d977c0c871879488c3ff5902
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Mon Apr 21 20:12:26 2025 -0600

    VK: Set minimum window size to 1x1.

commit b1a9eed3aba3960cf83b5d10b9df27c390ee5055
Author: Cole White <cmwhite@ualberta.ca>
Date:   Mon Apr 21 19:21:22 2025 -0600

    Update VMA allocator Vulkan version to 1.3

commit 530155dcd0c59a3b7f54286244fd3bc80bc5bcce
Author: Cole White <cmwhite@ualberta.ca>
Date:   Mon Apr 21 18:53:25 2025 -0600

    Update instance to 1.4 and add portability flags on instance creation.

commit b269f78ff856bef13f1382632a120fc06e5158a1
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Apr 20 19:44:28 2025 -0600

    3D: Ignore any screen changes to 0x0 size.

commit 480b0247b2842eaa1b2bddd4077c927ee30fb082
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Apr 20 19:36:56 2025 -0600

    GLFW: Set minimum window size to 10x10px.

commit e04186f3c97ce4fe1d40d7f7593f895741a21d39
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sat Apr 12 09:35:11 2025 -0700

    Delete HighwayHash-based fingerprinting in case someday we want to move to a different hashing algorithm.

commit 3bd2de12b5d900671a18a6a57832cde9af0ce2cf
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 11 22:37:47 2025 -0700

    Increment version to 3.03.

commit 827761cd8d204f082b0f7b4dd23804a522142c77
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Apr 11 21:08:33 2025 -0700

    Fix 3D pixels.

commit 2e95d89b2fffa72310541611577523e6ffe8f784
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 9 22:05:06 2025 -0700

    Edit documentation.

commit a8f140beb61d35601357a2c0205a31a0b26c0793
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Wed Apr 9 18:41:59 2025 -0700

    Edit documentation.

commit d8ab010628550b7ec76ccbc5146b6adcf73dacff
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Wed Apr 9 18:26:08 2025 -0700

    Add benchmark code specifically for maps.

commit bb2c3064a70045634ef33a61fefc8bfd61c8e38e
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Apr 8 22:22:49 2025 -0700

    Edit documentation.

commit 25a774a8c696dc621736be15dab6d2e51b26f378
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Apr 6 23:23:21 2025 -0700

    Fix capsize; port in sizing logic from OpenGL version.

commit b36f25c052e871fdc37b35cbcb7f06f945f463ea
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Apr 3 21:01:17 2025 -0700

    Edit documentation.

commit 3067190deee8171491e59eeaf030fb7af258a3c6
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Apr 3 19:52:50 2025 -0700

    Fix obsolete type.

commit 6b44093498711d3b3c07b4fb848fe0af40a73239
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 2 21:33:20 2025 -0700

    Update section heading.

commit 448350b1f681575c76b336d2d10c817fe4d89485
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Wed Apr 2 21:29:14 2025 -0700

    Fix YYDEBUG at least for one machine running MacOS.

commit 62d8bd7a43b54d8452da687af8197a3dc7431123
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Apr 2 20:39:12 2025 -0700

    Port configure to MacOS again.

commit f7a115c5d8aa4a1f7d97c58cb60c02dacfa4d258
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Wed Apr 2 19:30:32 2025 -0700

    Minor documentation addition.

commit 35e635f1f86a6985f6367dbb259e8abb4b8f4eb5
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Wed Apr 2 19:27:39 2025 -0700

    Minor improvements to hashset.asy.

commit b5d0b404c9b420941a528b2a197a71a4deaccc80
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Tue Apr 1 15:42:15 2025 -0700

    Document optional comma for rest arguments.

commit a55037f39fbb110a2013be8347810ef33e0ed863
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Tue Apr 1 15:36:42 2025 -0700

    Add comma before rest arguments when printing signatures.

commit 8d5b4bfb4866077d63b0956ac386de059c0cb61a
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Tue Apr 1 13:59:48 2025 -0700

    Add optional commas before ellipsis.

commit 25400ec58d0f79dfd6980f0a6fe0b1657c7192ef
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Tue Apr 1 13:32:37 2025 -0700

    Add some documentation for Set_T.

commit d0941cdcf0f7dc5de01cf1059255cc7841bd4d65
Merge: 7e7c4c5bc 5e1b2aca6
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 31 18:30:58 2025 -0700

    Merge branch 'autounravelWithDatastructures' of https://github.com/vectorgraphics/asymptote into autounravelWithDatastructures

commit 7e7c4c5bc1398d494cf60a64c2afdef7e92be3f4
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 31 18:30:51 2025 -0700

    Document using maps as sets.

commit 088147a0c845b13bcb416d1a08d74f2c08849856
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 31 18:29:44 2025 -0700

    Fix cmake lists of asy files.

commit efea191a8460205e42f2fd890eda5094020fee43
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 31 18:17:33 2025 -0700

    Rename repset to set.

commit 83ca82a02fb2d4aa02270be9e31349963c6b507d
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 30 22:22:15 2025 -0700

    Remove pragmas.

commit 380d88fa5348a4fb49cbca1f33cfe68ff2839d19
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 30 22:17:19 2025 -0700

    Fix warning messages.

commit 1269075f41a4ed1b966d119ab0f9538447f5cfca
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 30 22:03:01 2025 -0700

    Fix args.view.

commit af8f9b74d15b7a5dac0f213748c83a059c3232ba
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Mar 30 22:19:02 2025 -0600

    VK: Fix missing args.tup in picture.cc's call to AsyVkRender::render function.

commit 4bfdda125e63a78fa5c60d96ec3f6da417217787
Merge: 129494004 de51a196d
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sat Mar 29 23:44:27 2025 -0600

    Merge remote-tracking branch 'origin' into vulkan

commit 5e1b2aca6bec558bdd2a26506314a08d69024d55
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Mar 29 22:37:37 2025 -0700

    Edit documentation.

commit de51a196d67e785120b155ecc896bfadfab25ced
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Mar 29 20:41:05 2025 -0700

    Document range type.

commit 5baa95ba8eb5d22f9ad82c911d3d4e91f7da4a34
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Mar 29 20:21:01 2025 -0700

    Simplify code.

commit 1e61290f1d9c2ee84523cbef5232abd5016b1e1c
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sat Mar 29 19:33:45 2025 -0700

    Documentation updates.

commit c48f9e552c2ef2eb3edb8ce1f12fd5737bdf62b4
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sat Mar 29 19:33:33 2025 -0700

    Delete Map_K_V.removeAll() method.

commit 1294940047dfc0e746acb06bc67ae2bc3b3cf5ce
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Mar 27 22:41:20 2025 -0700

    Fix warning and improve efficiency.

commit 91e5ccf59b931f86070068426cfca84ce2594b62
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Mar 27 22:40:02 2025 -0700

    Add missing libraries.

commit 47bd0ae55c3357364fca394f1a796ada25d68b17
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Mar 27 22:15:47 2025 -0700

    Fix CONST.

commit 6afef6457b7c9cbfbd598ef304a7a442dfdc80bf
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Mar 27 22:15:27 2025 -0700

    Fix INCL.

commit 28f393d2660d13c2f8c0a6d78c2808b31996e1e8
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Mar 27 21:51:47 2025 -0700

    Initially seed random number generators with std::random_device.

commit dba230b2e2566e2f37e9200c30e93384d8f90709
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Mar 27 21:57:30 2025 -0600

    RAND: Use mt19937_64 as random engine.

commit 8e849e3cfbd0a01b6b7f5364ce9ac3c411374dfc
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Mar 27 21:39:27 2025 -0600

    VK: Use VULKAN_HPP_DEFAULT_DISPATCHER instead of vk::defaultDispatchLoaderDynamic.

commit 53ffeb67c724c58bfde35f9479ebbff4fbfa2a0c
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Mar 27 21:39:06 2025 -0600

    CXX: Remove extraneous #endif in fileio.cc.

commit 34c48768703e205835a7782e1a0b87ab8af9e4dc
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Mar 27 20:26:12 2025 -0700

    Generalize rand() to an arbitrary integer interval.

commit 35c1eef80462e44581ca41ca9c6693297eca6c6b
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Mar 27 20:52:21 2025 -0600

    VCPKG: Bump baseline version.

commit b5346c4f962e70d25bfee597664e7c1b3c777247
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Mar 27 20:49:57 2025 -0600

    CMAKE: Fix asy-files.cmake.

commit 57c84e557c35848be522f8924803edc8d57386de
Author: John Bowman <bowman@ualberta.ca>
Date:   Thu Mar 27 20:08:50 2025 -0700

    Set randMax to intMax.

commit 3f8a6097e301183951dbc9cd110b2dcabb96b4a3
Merge: 744eba008 8eebfd08f
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Mar 27 20:49:32 2025 -0600

    Merge remote-tracking branch 'origin/master' into msvc-vulkan

commit 2f27a475b89a0f04ad7fe060e461dff7311e9496
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Mar 26 21:39:19 2025 -0700

    Edit documentation.

commit 8eebfd08f58ad80bb699972854b3f53ea6909911
Author: John Bowman <bowman@ualberta.ca>
Date:   Wed Mar 26 19:42:03 2025 -0700

    Fix typo in documentation of unitrand.

commit 300af7a535e42f157159eca40be73a0570f1a36a
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Wed Mar 26 19:37:56 2025 -0700

    Minor doc improvements.

commit f9d3173f2ecfda305f7f55019ae000747c964488
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 24 17:24:06 2025 -0700

    Add btreemap and a test for it.

commit 883301e2acb07e33ed28d9e6d7b86debccf8699e
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 24 09:15:50 2025 -0700

    Improve documentation.

commit 518ac93e44bef71082be5d62aa6358007d8fe14d
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sun Mar 23 19:00:44 2025 -0700

    List new random.(cc|h) in cmake.

commit 9e34a3bf052d7aad005fb1211cd2d31b5d7e2795
Merge: 50ee67b16 109d4e3ff
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sun Mar 23 17:56:30 2025 -0700

    Merge branch 'master' into autounravelWithDatastructures

commit 50ee67b1653581adb5e52c48ccdfc5df5fe78fa4
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sun Mar 23 17:54:17 2025 -0700

    Minor optimizations for hashrepsets.

commit 16a565b30a0ebf89695e1a7e13043192596a9fa7
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sun Mar 23 17:53:53 2025 -0700

    Add repset benchmark.

commit 41f723cdd07ddab655bf89d62a31df6cd326acff
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sun Mar 23 17:51:04 2025 -0700

    Test btree with different maxPivots.

commit 109d4e3ff02b8571d34a651f7aa1ec095183bb81
Merge: 0e4fe6547 12718954a
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Mar 22 22:13:52 2025 -0700

    Merge pull request #540 from vectorgraphics/539-configure-creates-a-broken-makefile
    
    Fix #539: Avoid the use of realpath.

commit 12718954af4ae659a9f84dc63f13152a4fe04f08
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Mar 22 21:49:34 2025 -0700

    Fix #539: Avoid the use of realpath.

commit 3ec3e5e34aefbfe20c60f92b7bafb159f53782c1
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sat Mar 22 19:54:02 2025 -0700

    Minor optimizations to btree.

commit 0e4fe6547de55ea2ba1f0d39b723a4ca9a28bd74
Merge: c289e4329 7a4eedac8
Author: John Bowman <bowman@ualberta.ca>
Date:   Fri Mar 21 10:59:23 2025 -0700

    Merge pull request #538 from vectorgraphics/fix-msvc-registry-reading.
    
    Fix path search algorithm when asy is installed outside the standard directory.

commit 7a4eedac80d99f93150a6063544890f6c6ff713d
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Mar 20 20:56:45 2025 -0600

    W32: Remove "other" from move constructor.

commit 64a61447afbdeacc0d18f93cc02ccc0b22bc743a
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Thu Mar 20 20:56:17 2025 -0600

    W32: Change implementation of getEntry so it returns valid value without glob.

commit eb0f6342c424ea1ac085b7d6c9e12530c32450c1
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Thu Mar 20 09:18:18 2025 -0700

    Document randString function.

commit f1cb94d3a17c1adcb67451585dec74ea8913516c
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Wed Mar 19 23:34:23 2025 -0700

    Add randString builtin function.

commit 2bd754d67b49546e6a7524a7e5b81316c866986e
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Wed Mar 19 21:23:41 2025 -0700

    Minor documentation improvements.

commit c289e4329b4f14cf855859ce267d9c9d8778b38a
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Wed Mar 19 22:04:53 2025 -0600

    PY: Add clarifying remarks to scan-asy-tests-cmake.py.

commit d96e5207a3a8468460bccc843118418f4edabd0d
Merge: b1f435f2a bc9364b39
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Wed Mar 19 17:30:59 2025 -0700

    Merge branch 'master' into autounravelWithDatastructures

commit b1f435f2a7b64ef46b4c7ead7bf705dcd675b2b1
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Wed Mar 19 13:09:29 2025 -0700

    Rename Index to General Index to avoid conflict with index.html as "root" of html site.

commit 1c1f647e0cf01e775b6f79364907f70fd90753ad
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Wed Mar 19 12:42:45 2025 -0700

    Remove warning that templates are experimental.

commit 48ff4ea509683457f29067c6a11e4a053151af39
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Wed Mar 19 12:41:56 2025 -0700

    Add rangeTest.

commit 7f400daa6d7ebe6eebfb8d37080929e8df143ef0
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Wed Mar 19 12:39:06 2025 -0700

    Change behavior of range to match sequence.

commit bc9364b39a70165f024630cd37d49d5c13f02636
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Mar 18 20:04:53 2025 -0700

    Add executable flag.

commit 923e912dd3a70f996ac3afe61cb5f90fe3d8264c
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Mar 18 21:01:02 2025 -0600

    CMAKE: Update generated-asy-tests-list.cmake.

commit 5ba3a64ce24ef2811426fc8f61d6467f6ddd7412
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Mar 18 21:00:02 2025 -0600

    PY: Ignore any empty test directories in scan-asy-tests-cmake.py.

commit afda977f80e37e004c689e3fd93e97d5ad531965
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Tue Mar 18 20:59:44 2025 -0600

    PY: Add newline to end of each test explicity in scan-asy-tests-cmake.py.

commit 703dbee48d4dbae05e5cf46b020fcae948bec11d
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Tue Mar 18 09:32:41 2025 -0700

    Reformat python script.

commit 10d88cbe3590bd7e72710fea21c36c280ee17959
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Tue Mar 18 09:29:29 2025 -0700

    Update asy-tests-list.cmake.

commit 79951ab4ef8e447d25bba4d7c5b314a72ed66e8e
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Mar 18 09:11:44 2025 -0700

    Fix #537: update documenation regarding default value of keepAspect.

commit 47a65d24f6f92d6cd3970c8ddab71ef97c7a0a45
Merge: 00584ebc3 26358ec5b
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Tue Mar 18 09:27:39 2025 -0700

    Merge branch 'tweakScanAsyTestsCmake' into autounravelWithDatastructures

commit 26358ec5ba9496451df7c8d4e91d0d59e23c1c29
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Tue Mar 18 09:27:13 2025 -0700

    Ignore empty directories when generating asy-tests-list.cmake.

commit 00584ebc34798152b446e38e77f4f6c9c92bb950
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Mar 17 21:46:34 2025 -0700

    Edit documentation.

commit 23d881549eadf946acc29b565702764d332c7882
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 17 19:43:34 2025 -0700

    Add pairs iterator to hashmap.

commit 730650d583deb20981b808b483191726f75e60bb
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 17 19:37:55 2025 -0700

    Start hashmap documentation.

commit 579ccc18708fcde5daf65cde80a426e1ee45130f
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 17 18:12:31 2025 -0700

    Document enumerate.

commit 711a8fffae211521b6176abc893dc43635fed45f
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 17 17:49:57 2025 -0700

    Allow (and document) long heterogenous zip with default.

commit 64d64df46c6be1d94d20ac45a12cdb445b22453a
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 17 17:17:26 2025 -0700

    Allow default pair for heterogenous zipping.

commit 6dccadb152874992a1d1d161bea5e9fc51067a21
Merge: 4d0ba561e c1868d457
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 17 09:15:54 2025 -0700

    Merge branch 'master' into autounravelWithDatastructures

commit c1868d4570bfd17311aea0c4e759546c666e757c
Merge: 91ef39b8a aac010bf4
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Mar 16 20:54:12 2025 -0600

    Merge pull request #536 from vectorgraphics/asy-test-scanning
    
    Add python script to scan and generate asy test file lists

commit aac010bf4c0d68535956106dcc73705029593b4a
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Mar 16 20:09:04 2025 -0600

    CI: Add step to check if there are missing asy unit tests in generated/asy-tests-list.cmake.

commit 7cceff3385d157f9fd15703f7d23c0ae61a80636
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Mar 16 20:07:14 2025 -0600

    CI: Rename lint-non-gui-python-files to misc-sanity-checks.

commit c09b13e0d03fb1c0d79f5d2632247bbb6dbfd5fd
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Mar 16 15:23:23 2025 -0600

    CMAKE Use generated asy-tests-list.cmake.

commit 4dbc28d01c95030373fa549b781157599a3f4224
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Mar 16 15:06:07 2025 -0600

    CMAKE: Add generated asy test list file.

commit 9d9242ec3abd1c9851d5131d1b6a1ed3c440a903
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Mar 16 15:05:52 2025 -0600

    CMAKE: Add script to scan and generate asy test list.

commit 907459263a044fe38265fe6eb5f0b2253d86d947
Author: Supakorn 'Jamie' Rassameemasmuang <jamievlin@outlook.com>
Date:   Sun Mar 16 11:03:21 2025 -0600

    REPO: Add .editorconfig to gitignore file.

commit 4d0ba561e507a2ab342362ff4668d46e4b13582d
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Thu Mar 13 17:51:10 2025 -0700

    Document zip.

commit a0bd417be0357079123fcafff3162d3b0292c816
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Thu Mar 13 15:58:38 2025 -0700

    Change Iterable_Array_T to Iterable_array_T to indicate T[] and not wrapper Array_T.

commit 73665ddcd8439dc702696da4c99d5ad88e2645c2
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Thu Mar 13 13:39:21 2025 -0700

    Document rest argument in array initialization.

commit 1a10c99523358d73c705a3d0f5eb2c059fbaaeed
Merge: 096c4b1a8 3da441070
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Thu Mar 13 13:22:10 2025 -0700

    Merge branch 'btree' into autounravelWithDatastructures

commit 3da441070cb931b285cb417a5c2548f3b17b8dae
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Wed Mar 12 19:40:51 2025 -0700

    Tests succeeding for btree as sorted set.

commit 91ef39b8a453fb46503e890c6fb040356c27a959
Merge: 5e43d12df 063d3984b
Author: John Bowman <bowman@ualberta.ca>
Date:   Tue Mar 11 21:24:11 2025 -0700

    Merge pull request #534 from vectorgraphics/tmp-fix-doc
    
    Move operator init doc to the correct section.

commit 096c4b1a81593d2f41f32b5934902cf48431063c
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 10 15:19:53 2025 -0700

    In dotted import, automatically assign name if none specified.

commit 84bf4240da67e4a679c50554c5693a156a77b3fb
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Mar 10 15:00:48 2025 -0700

    Update documentation.

commit 55e513a574c6ac73d375cea1a80e368e1364de43
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 10 14:56:58 2025 -0700

    Add new files to cmake.

commit 4232961ad9e28e9cb9f31e5dffa5672a174a2cfc
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 10 14:53:22 2025 -0700

    Improved iterator utilities.

commit 0b72df5e4a6dd82035b0ed2aa29058f4fbc74606
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 10 12:55:28 2025 -0700

    Finish documenting collections.iter.

commit 5887e425bbed439b63534bb58db0f404c2a3b2db
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 10 12:01:07 2025 -0700

    Partial documentation for collections.iter.

commit 8f4468c53fe6b440aa4d78fe4dbfa54ea82d915f
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 10 11:42:15 2025 -0700

    Improve range documentation.

commit 00c99f21cb9f82948265d88fd8bebd9c0f1323d7
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 10 11:34:28 2025 -0700

    Add and document range function.

commit fd19514ad4951b9ae148720fa5572544d2e3370f
Merge: 029b5867f 8db6e8aff
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sun Mar 9 15:48:31 2025 -0700

    Merge branch 'autounravelWithDatastructures' into btree

commit 8db6e8affd1dddc97a52d9b4276db2efd12b9eb3
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sun Mar 9 14:18:32 2025 -0700

    Add keys() method to maps.

commit eda3dbce5f28cb8510ae2ac36f79bf6b6873acbd
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sun Mar 9 13:43:48 2025 -0700

    Delete no-longer-relevant comment.

commit 90be8ddb6425693a4964a0b3f45299f38abced51
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sat Mar 8 18:46:32 2025 -0800

    Document user-defined hash methods, more on wraparray.

commit 70c4b0865a925efb5b0f352610399238e28b84fc
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sat Mar 8 18:39:40 2025 -0800

    Add `restricted` to Array_T fields.

commit 33faec677a3c9d45e354c2d4bf2315ae1cb55780
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Fri Mar 7 08:49:58 2025 -0800

    Make cmake aware of collections.wraparray.

commit f06a952757a237f6e18aca7e336a7528766b929d
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Thu Mar 6 18:39:33 2025 -0800

    Partially document wraparray.

commit 1f79a2eb8493656f01cf23d23d3a059b0907f87b
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Thu Mar 6 17:22:08 2025 -0800

    Add extra test for wraparray.

commit 2cc61078733eb125f8e98b40738832b3687cebc2
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Thu Mar 6 17:18:28 2025 -0800

    Add tests for wraparray and fix bugs.

commit c029132d9ca56eb2365e643a5e40a91aace142b2
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Thu Mar 6 16:17:51 2025 -0800

    Add collections.wraparray.

commit 063d3984b3dd8cb162a019a43976d2c2fa226c32
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Thu Mar 6 12:51:29 2025 -0800

    Move operator init doc to the correct section.

commit 185ab72f9a521c72e2c290181e001c7c6f64823a
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Thu Mar 6 12:42:24 2025 -0800

    Document hash and Pair_K_V.

commit 05711967edb9854caa79cf3941a657ca3b628eaa
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Thu Mar 6 12:40:48 2025 -0800

    Improve operator== for Pair_K_V.

commit 7dc51214e53c791b829e134ccbd7b228108cb8a0
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Wed Mar 5 12:35:09 2025 -0800

    Document dotted directory imports.

commit 72fa1fb9000ca7e9b2ad00ce095c0a8465bc4863
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Tue Mar 4 17:25:20 2025 -0800

    Document operator iter.

commit 7d4370776a79a19c430ab40de971babb0785be27
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Tue Mar 4 16:09:56 2025 -0800

    Document operator[] and operator[=].

commit 84d526138d6f9dea2018953fce2b6cdc44dbfef5
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Tue Mar 4 10:25:03 2025 -0800

    Delete outdated datastructure.

commit d7fab38969a050a434ef8d4a5828b3fb21b2aa09
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Tue Mar 4 10:20:57 2025 -0800

    Create dict = HashMap_string_string class in plain.

commit 571fb58c8771044b824fb11fb2f054ae59b4027b
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Mar 3 22:50:42 2025 -0800

    Update Makefile.

commit 9000520b77fe9ca19ae35066a53cc2dd04ba3bbb
Merge: 65ca7a482 5e43d12df
Author: John Bowman <bowman@ualberta.ca>
Date:   Mon Mar 3 21:55:45 2025 -0800

    Merge branch 'master' into autounravelWithDatastructures.

commit 65ca7a482028bd6ac9cdefdf134412eb24077e46
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Mon Mar 3 19:28:18 2025 -0800

    Make highwayhash target a real file.

commit d1f9c875d86a4eb4336074efb4cc1fa8a3de64d5
Merge: 90ca86927 15ba08b45
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sun Mar 2 21:05:26 2025 -0800

    Merge branch 'autounravelWithDatastructures' of https://github.com/vectorgraphics/asymptote into autounravelWithDatastructures

commit 90ca869278925e61d334b01e57fdd88e76e8c9ab
Author: Charles Staats III <charles.staats.iii@gmail.com>
Date:   Sun Mar 2 21:05:03 2025 -0800

    Detect architecture in makefile.

commit 5e43d12dfd1c25b1aa896ea08e528765a2c32aea
Author: John Bowman <bowman@ualberta.ca>
Date:   Sun Mar 2 19:40:32 2025 -0800

    git subrepo pull (merge) LspCpp
    
    subrepo:
      subdir:   "LspCpp"
      merged:   "222549234"
    upstream:
      origin:   "git@github.com:vectorgraphics/LspCpp"
      branch:   "master"
      commit:   "11c5053a1"
    git-subrepo:
      version:  "0.4.9"
      origin:   "https://github.com/ingydotnet/git-subrepo"
      commit:   "b9b059a"

commit 15ba08b45c85321be45f532dcaac7d221d2215d9
Merge: 279c1f3d2 68d3bfd4e
Author: John Bowman <bowman@ualberta.ca>
Date:   Sat Mar 1 21:40:23 2025 -0800

    Merge branch 'master' into autounravelWithDatastructures.

